unit ETALONAuto;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, ooMisc,
  maths, gti2util, gti2_auto_def, gti2_auto_main, gti2const, ComCtrls;

type
  TEtalonneAutoDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    PotarTab: TTabControl;
    Memo: TMemo;
    EtalonBtn: TSpeedButton;
    EtalonLabel: TLabel;
    OKbtn: TBitBtn;
    Gauge: TProgressBar;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PotarTabChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
  private
    Pcourant : integer;
    indexCapteur : integer;
    codePotar : char;
  public
    voieCourante : Tvoie;
  end;

var
  EtalonneAutoDlg: TEtalonneAutoDlg;

implementation

{$R *.DFM}


procedure TEtalonneAutoDlg.FormActivate(Sender: TObject);
var i : integer;
begin
     indexCapteur := voieCourante.indexCapteurAuto;
with listeCapteursAuto[indexCapteur] do begin
     PotarTab.tabs.clear;
     for i := 0 to maxPotarAuto do
         if potarActif[i] then PotarTab.tabs.add(nomPotar[i]);
     PotarTab.TabIndex := 0;
     codePotar := numToCodePotar(voieCourante.numOrphy);
     PotarTabChange(nil);
     gauge.position := 0;
end end;

procedure TEtalonneAutoDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(11)
end;

procedure TEtalonneAutoDlg.PotarTabChange(Sender: TObject);
var N,i : integer;
begin
    N := 0;
    for i := 0 to maxPotarAuto do
        if ListeCapteursAuto[indexCapteur].potarActif[i] then begin
           if PotarTab.tabIndex=N then Pcourant := i;
           inc(N);
        end;
    memo.text := ListeCapteursAuto[indexCapteur].aidePotar[Pcourant];
    EtalonLabel.Visible := false;
    EtalonBtn.Enabled := true;
    EtalonBtn.visible := true;
    gauge.position := 0;
end;

procedure TEtalonneAutoDlg.EtalonBtnClick(Sender: TObject);

function IsGreater(P : integer) : boolean;
const
    attenteMin = 5; { 0,5 seconde }
    attenteMax = 20; { 2 secondes }
var oldzi,i,zi : integer;
    zr : double;
begin with listeCapteursAuto[indexCapteur] do begin
     GtsMainForm.EcritOrphy('WEPOTAR '+codePotar+' '+intToStr(Pcourant)+' '+intToStr(P));
     zi := 40000;
     i := 0;
     repeat
        oldzi := zi;
        delayTicks(2,false); { pour tre sr d'en avoir 1 ! }
        zi := GtsMainForm.getInt('WEA '+intToStr(voieCourante.numOrphy));
        inc(i);
     until ((abs(zi-oldzi)<8) and (i>attenteMin)) or (i>attenteMax);
     zr := valeurReal(zi);
     result := zr>valeurAttendue[Pcourant];
end end;

var mini,maxi,test,i : integer;
    valeurCAN : double;
begin with ListeCapteursAuto[indexCapteur] do begin
      EtalonBtn.Enabled := false;
      test := valeurPotar[Pcourant];
      if isGreater(test)
         then begin
            maxi := test;
            mini := 0;
         end
         else begin
            mini := test;
            maxi := 1024;
         end;
      i := 0;
      gauge.position := 0;
      repeat
           test := (mini+maxi) div 2;
           if isGreater(test)
              then maxi := test
              else mini := test;
           inc(i);
           gauge.position := i;
      until (maxi-mini)<2;
      GtsMainForm.EcritOrphy('WMPOTAR '+codePotar+' '+intToStr(Pcourant));
      valeurPotar[Pcourant] := test;
      if PCourant in [2,3] then begin
           delayTicks(2,false);
           test := GtsMainForm.getInt('WEA '+intToStr(voieCourante.numOrphy));
           valeurCAN := voieCourante.ValeurVolt(test);
           if PCourant=3 then
              voieCourante.UnVolt := (valeurAttendue[3]-offsetC[codeUniteC])/valeurCan;
           if PCourant=2 then
              voieCourante.offset := valeurAttendue[3]-UnVoltC[codeUniteC]*valeurCan;
      end;
      EtalonBtn.visible := false;
      EtalonLabel.Visible := true;
      gauge.position := gauge.max;
end end;

end.
