Unit Fft;

interface

uses Maths_osc, sysUtils;

const
   MaxVecteurFFT = 8192;

type
   tCalculFourier = (cZero,cHamming,cHarmonique,cAjuste);
   IndiceVecteurFFT = 0..MaxVecteurFFT;
   VecteurFFT = array[IndiceVecteurFFT] of double;
   VecteurIntFFT = array[indiceVecteurFFT] of integer;

var
   CoeffInterpole : double;
   AnalyseHarmonique : boolean;

Procedure Fourier(Nbre : integer;const X : vecteur;var Xr,Xi : vecteurFFT;
                  calculFourier : TcalculFourier;var NbreFFT : integer);
Procedure SpectreAmplitude(Nbre : integer;const X : vecteur;
                           var ampli,freq : vecteur;var NbreFFT : integer);
procedure calculAutoCorrelation(Nbre : integer;const X : vecteur;
               var Xa : vecteurFFT;var indexPeriode : integer);
procedure FourierInverse(Nbre,NbreFFT : integer;const Xr,Xi : vecteurFFT;
                         var Xa : vecteur);

Implementation

function Puiss2Inf(N : LongInt) : LongInt;
begin
    result := 1;
    while result<N do result := 2*result;
    if result>N then result := result div 2;
end;

function Puiss2Sup(N : LongInt) : LongInt;
begin
    result := Puiss2Inf(N);
    if result<N then result := 2*result;
    if result>maxVecteurFFT then result := maxVecteurFFT;
end;

var tbi : vecteurIntFFT;
    wr,wi : vecteurFFT;

Procedure CalculIntLineaire(const Y : vecteur;Nbre,NbreLisse : integer;
          var YLisse : vecteur);
var i,ix : integer;
    t : double;
begin
      Ylisse[0] := Y[0];
      coeffInterpole := Nbre/NbreLisse;
      Ylisse[pred(NbreLisse)] := Y[pred(Nbre)];
      for i := 1 to NbreLisse-2 do begin
          t := i*coeffInterpole;
// recherche de i initial proche
          ix := trunc(t);
// x[ix]<t<=x[ix+1]
	        Ylisse[i] := Y[ix]+(t-ix)*(Y[succ(ix)]-Y[ix]);
      end;
end; // CalculIntLineaire

Procedure spectreAmplitude(Nbre : integer;const X : vecteur;
                           var ampli,freq : vecteur;var NbreFFT : integer);
var i,imax,i0 : integer;
    Xr,Xi : vecteurFFT;
    valeurMax : double;

function AjusteFrequence(var j1 : integer) : boolean;
var i,j2,j3 : integer;
    F0,A0,valeurRef : double;
begin
    valeurRef := valeurMax / 50;
    repeat
       inc(j1)
    until (j1>imax) or
          ((ampli[j1+1]<ampli[j1]) and
           (ampli[j1]>valeurRef)); // maximum  local en j1
    result := j1<=imax;
    if not result then exit;
    if ampli[j1-1]>ampli[j1+1] then j2 := j1-1 else j2 := j1+1;
    F0 := 1-(ampli[j1]/(ampli[j2]+ampli[j1]));
    A0 := ampli[j1]/sinc(pi*F0);
    if j1>j2 then F0 := j1-F0 else F0 := j1+F0;
    j2 := j1;
    repeat dec(j2)
    until (j2=0) or (ampli[j2]<ampli[j2-1]);
    j3 := j1;
    repeat inc(j3)
    until (j3>=imax) or (ampli[j3]<ampli[j3+1]);
    for i := j2 to j3 do ampli[i] := 0;
    ampli[j1] := A0;
    freq[j1] := F0;
    j1 := j3;
end;

{
function AjusteFrequenceBis(var j1 : integer) : boolean;
var i,j2,j3 : integer;
    valeurRef : double;
begin
    valeurRef := valeurMax / 50;
    repeat
       inc(j1)
    until (j1>imax) or
          ((ampli[j1+1]<ampli[j1]) and
           (ampli[j1]>valeurRef)); // maximum  local en j1
    result := j1<=imax;
    if not result then exit;
    j2 := j1;
    repeat dec(j2)
    until (j2=0) or (ampli[j2]<ampli[j2-1]); // fin du lobe central  gauche
    j3 := j1;
    repeat inc(j3)
    until (j3>=imax) or (ampli[j3]<ampli[j3+1]);// fin du lobe central  droite
    for i := j2 to pred(j1) do ampli[i] := 0;
    for i := succ(j1) to j3 do ampli[i] := 0;
    j1 := j3;
end;
}

begin
    if analyseHarmonique
       then Fourier(Nbre,X,Xr,Xi,cHarmonique,NbreFFT)
       else Fourier(Nbre,X,Xr,Xi,cAjuste,NbreFFT);
    for i:= 0 to pred(NbreFFT) do begin
         ampli[i] := sqrt(sqr(xr[i])+sqr(xi[i]));
         freq[i] := i;
    end;
    if not analyseHarmonique then begin
        i0 := 0;
        imax := (NbreFFT div 2) - 2;
        repeat inc(i0)
        until (ampli[i0]>ampli[i0-1]) or (i0>=imax); // on vite le continu
        valeurMax := 0;
        for i:= i0 to imax do
            if ampli[i]>valeurMax then valeurMax := ampli[i];
        while AjusteFrequence(i0) do;
    end;
end;

PROCEDURE tfd(var xr,xi : vecteurFFT;NbreFFT : integer);
 { Transformation proprement dite }
var a,i,j,k,k0,nbbloc,tbloc,r,r0,p0,nombre0 : integer;
    zr,zi,c : double;
begin
  nbbloc:=NbreFFT;
  tbloc:=1;
  r:=trunc(0.5+Ln(NbreFFT)/ln(2));
  for i:=1 to r do begin
          tbloc:=2*tbloc;
          nbbloc:=nbbloc div 2;
          for j:=1 to nbbloc do begin
             nombre0:=(NbreFFT div nbbloc -1) div 2;
             r0:=0;
             for k0:=0 to nombre0 do begin
                    k:=k0+(pred(j))*tbloc;
                    p0:=k+tbloc div 2;
                    a:=r0;
                    zr:=xr[p0]*wr[a]-xi[p0]*wi[a];
                    zi:=xr[p0]*wi[a]+xi[p0]*wr[a];
                    xr[p0]:=xr[k]-zr;
                    xi[p0]:=xi[k]-zi;
                    xr[k]:=xr[k]+zr;
                    xi[k]:=xi[k]+zi;
                    r0:=r0+nbbloc;
             end; {k0}
          end; {j}
  end; {i}
  c := 2/NbreFFT;
  for i := 0 to pred(NbreFFT) do begin
       xr[i]:=c*xr[i];
       xi[i]:=c*xi[i];
  end;
  xr[0] := xr[0]*2;
  xi[0] := xi[0]*2;
end; // tfd

PROCEDURE tfdi(var xr,xi : vecteurFFT;NbreFFT : integer);
 { Transformation inverse proprement dite }
var a,i,j,k,k0,nbbloc,tbloc,r,r0,p0,nombre0 : integer;
    zr,zi,c : double;
begin
  nbbloc:=NbreFFT;
  tbloc:=1;
  r:=trunc(0.5+Ln(NbreFFT)/ln(2));
  for i:=1 to r do begin
          tbloc:=2*tbloc;
          nbbloc:=nbbloc div 2;
          for j:=1 to nbbloc do begin
             nombre0:=(NbreFFT div nbbloc -1) div 2;
             r0:=0;
             for k0:=0 to nombre0 do begin
                    k:=k0+(pred(j))*tbloc;
                    p0:=k+tbloc div 2;
                    a:=r0;
                    zr:=xr[p0]*wr[a]+xi[p0]*wi[a];
                    zi:=-xr[p0]*wi[a]+xi[p0]*wr[a];
                    xr[p0]:=xr[k]-zr;
                    xi[p0]:=xi[k]-zi;
                    xr[k]:=xr[k]+zr;
                    xi[k]:=xi[k]+zi;
                    r0:=r0+nbbloc;
             end; {k0}
          end; {j}
  end; {i}
  c := 2/NbreFFT;
  for i := 0 to pred(NbreFFT) do begin
       xr[i]:=c*xr[i];
       xi[i]:=c*xi[i];
  end;
  xr[0] := xr[0]*2;
  xi[0] := xi[0]*2;
end; // tfdi

PROCEDURE inverserIndices(NbreFFT : integer);
{ Table de l'ordre inverse des bits }
var i,j,k,r,p0,q,tiroir : integer;
    dpsn : double;
begin
  dpsn:=2*pi/NbreFFT;
  for i:=0 to pred(NbreFFT) do begin
         wr[i]:=COS(dpsn*i);
         wi[i]:=SIN(-dpsn*i);
{ ATTENTION : les indices ne sont pas permuts }
{ la permutation selon tbi[] sera faite dans le fentrage }
  end;
  for i:=0 to pred(NbreFFT) do tbi[i]:=i;
  r:=trunc(0.5+Ln(NbreFFT)/ln(2));
  for i:=0 to pred(NbreFFT) do begin
      p0:=r;
      q:=1;
      k:=0;
      for j:=1 to r do begin
           if (i and puissDeux(PRED(p0)))<>0 then k:=k+q;
           q:=2*q;
           DEC(p0);
      end;
      if k>i then begin
            tiroir:=tbi[k];
            tbi[k]:=tbi[i];
            tbi[i]:=tiroir;
      end;
    end;
end; // inverserIndices

Procedure Fourier(Nbre : integer;const X : vecteur;var Xr,Xi : vecteurFFT;
                  calculFourier : TcalculFourier;var NbreFFT : integer);

procedure fenetrerHamming;
const coeff = 1.852;
//    FlatTop : coeffFenetrage := 4.638;
var j : integer;
    kf,dpsn : double;
begin
     dpsn:=2*pi/Nbre;
     for j:=0 to pred(Nbre) do begin
         kf:=0.54-0.46*cos(j*dpsn);
         xr[tbi[j]]:=kf*X[j]*coeff; // fentrage et renormalisation
// et rangement avec permutation des mesures tableau fentres dans xr[]
         xi[j]:=0;
     end;
     for j:=Nbre to pred(NbreFFT) do begin
         xr[tbi[j]]:=0;
{ rangement avec permutation des zros dans xr[] }
         xi[j]:=0;
     end;
end; // Hamming

procedure fenetrerRect;
var i : integer;
begin
        for i:=0 to pred(Nbre) do begin
            xr[tbi[i]] := x[i];
            xi[i] := 0;
        end;
        for i:=Nbre to pred(NbreFFT) do begin
            xr[tbi[i]] := 0;
            xi[i] := 0;
        end;
end;

var Xlisse : vecteur;
    i : integer;
    coeff : double;
begin
     case calculFourier of
        cZero : begin
            NbreFFT := maxVecteurFFT;
            inverserIndices(NbreFFT);
            fenetrerRect;
        end;
        cHarmonique : begin
            NbreFFT := puiss2Sup(Nbre);
            CalculIntLineaire(X,nbre,NbreFFT,XLisse);
            inverserIndices(NbreFFT);
            for i := 0 to pred(NbreFFT) do begin
                  xr[tbi[i]] := Xlisse[i];
                  xi[i] := 0;
            end;
        end;
        cHamming : begin
            NbreFFT := maxVecteurFFT;
            inverserIndices(NbreFFT);
            fenetrerHamming;
        end;
        cAjuste : begin
            NbreFFT := puiss2Inf(Nbre);
            inverserIndices(NbreFFT);
            for i:=0 to pred(NbreFFT) do begin
                xr[tbi[i]] := x[i];
                xi[i] := 0;
            end;
       end;
     end;
     tfd(xr,xi,NbreFFT);
     if calculFourier=cHamming then begin
         coeff := NbreFFT/Nbre;
         for i := 0 to pred(NbreFFT) do begin
            xr[i] := xr[i]*coeff;
            xi[i] := xi[i]*coeff;
         end;
     end;
end; // Fourier

procedure calculAutoCorrelation(Nbre : integer;const X : vecteur;
                               var Xa : vecteurFFT;var indexPeriode : integer);
var Xr,Xi,Ya : vecteurFFT;

procedure fenetreInverse;
var j : integer;
begin
     for j := 0 to pred(MaxVecteurFFT) do begin
         Xa[tbi[j]] := xr[j];
         Ya[tbi[j]] := xi[j];
     end;
end;

var i,j,nbreFFT : integer;
    max1,moy : double;
//   nbrePeriode,NbrePeriodeMax,testIndex : integer;
//   indexUnePeriode : integer;
//   max : double;
begin
    inverserIndices(maxVecteurFFT);
    Fourier(Nbre,X,Xr,Xi,cZero,nbreFFT);
    for i := 0 to pred(MaxVecteurFFT) do begin { conjugue(x)*x }
        Xr[i] := Xr[i]*Xr[i]+Xi[i]*Xi[i];
        Xi[i] := 0;
    end;{for i}
    fenetreInverse;
    tfdi(Xa,Ya,maxVecteurFFT);
    moy := 0;
    for j := 0 to pred(Nbre) do
        moy := moy + Xa[j];
    moy := moy/nbre;
    indexPeriode := 0;
    i := 0;
    repeat
        inc(i)
    until (i>Nbre) or (Xa[i]<moy); // on vite le continu
    max1 := moy;
    for j := i+1 to pred(Nbre) do
        if Xa[j]>max1 then begin
           max1 := Xa[j];
           indexPeriode := j;
        end;
{
    if indexPeriode<16 then exit;
    indexUnePeriode := indexPeriode;
    NbrePeriodeMax := Nbre div IndexUnePeriode;
    for NbrePeriode := 2 to NbrePeriodeMax do begin
       testIndex := indexUnePeriode*(NbrePeriode-1);
       max := 2*max1/3; // recherche Nime priode un peu plus faible ?
       i := testIndex;
       repeat
          inc(i)
       until (i>Nbre) or (Xa[i]<moy); // on vite la priode prcdente
       for j := i+1 to pred(Nbre) do
           if Xa[j]>max then begin
              max := Xa[j];
              testIndex := j;
           end;
       if abs(testIndex-NbrePeriode*indexUnePeriode)<(indexUnePeriode div 20)
          then indexPeriode := testIndex div NbrePeriode
          else break;
    end;
}
end; // calculAutoCorrelation


procedure FourierInverse(Nbre,NbreFFT : integer;const Xr,Xi : vecteurFFT;
                         var Xa : vecteur);
var j : integer;
    XX,YY : vecteurFFT;
begin
    for j := 0 to pred(nbreFFT) do begin
        XX[tbi[j]] := xr[j];
        YY[tbi[j]] := xi[j];
    end;
    tfdi(XX,YY,nbreFFT);
    for j := 0 to pred(nbre) do
        Xa[j] := XX[j];
end; // FourierInverse

end.

