unit Gbf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons,
  maths, gti2_module_def, gti2Util, gti2_gts2,
  gti2_module_graphe, uniteker, ExtCtrls, gti2Const, parser10;

type
  TGBFForm = class(TForm)
    SignalGB: TGroupBox;
    TriangleBtn: TSpeedButton;
    CarreBtn: TSpeedButton;
    SinusBtn: TSpeedButton;
    DCBtn: TSpeedButton;
    OffsetGB: TGroupBox;
    OffsetEdit: TEdit;
    OffsetScroll: TScrollBar;
    AmplitudeGB: TGroupBox;
    AmplitudeEdit: TEdit;
    AmplitudeScroll: TScrollBar;
    DutyGB: TGroupBox;
    DutyEdit: TEdit;
    DutyScroll: TScrollBar;
    FrequenceGB: TGroupBox;
    FrequenceSpin: TSpinButton;
    FrequenceEdit: TEdit;
    AideBtn: TSpeedButton;
    PanelCourbe: TPanel;
    Oscillo: TPaintBox;
    ArbitraireBtn: TSpeedButton;
    PanelArbitraire: TPanel;
    ExpressionEdit: TLabeledEdit;
    NumSARG: TRadioGroup;
    MajTimer: TTimer;
    MajBtn: TSpeedButton;
    procedure ParamChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SignalBtnClick(Sender: TObject);
    procedure FrequenceEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure FrequenceSpinDownClick(Sender: TObject);
    procedure FrequenceSpinUpClick(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
    procedure FrequenceEditExit(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure ExpressionEditExit(Sender: TObject);
    procedure NumSARGClick(Sender: TObject);
    procedure MajTimerTimer(Sender: TObject);
    procedure MajBtnClick(Sender: TObject);
  private
    Periode : integer;
    ModifSignal : boolean;
    UniteVolt : Tunite;
    ParserI : Tparser;
    IndiceParser : PParserFloat;
    procedure ModifFrequence(down : boolean);
    Procedure MajSA;
    Procedure FaireMaj;    
    Procedure MajFrequence;    
    Procedure DesactiveBtn;
    Procedure ActiveBtn;
    Function ValeurSA(i : integer) : byte;
  public
  end;

var
  GBFForm: TGBFForm;

implementation

uses Gti2_module_Main, modeDlg;

{$R *.DFM}

const NbreSA = 256;

Function TGBFForm.ValeurSA(i : integer) : byte;
var valeurR : double;
    valeurI,posDuty : integer;
begin
     valeurI := 0;
     PosDuty := NbreSA*DutyScroll.position div 100;
     if posDuty<2 then posDuty := 2;
     if posDuty>(NbreSA-2) then posDuty := NbreSA-2;
     if sinusBtn.down then
        valeurI := round(AmplitudeScroll.position*sin(2*pi*i/NbreSA));
     if carreBtn.down then if i>PosDuty
        then valeurI := -AmplitudeScroll.position
        else valeurI := AmplitudeScroll.position;
     if triangleBtn.down then if i>PosDuty
        then valeurI := AmplitudeScroll.position-round((i-posDuty)*AmplitudeScroll.position*2.0/(NbreSA-posDuty))
        else valeurI := -AmplitudeScroll.position+round(i*AmplitudeScroll.position*2.0/posDuty);
     if ArbitraireBtn.down
        then begin
             IndiceParser^ := i;
             valeurR := ParserI.Value;
             valeurI := round(valeurR*255/5);
        end
        else valeurI := valeurI+OffsetScroll.position;
     if valeurI>255 then valeurI := 255;
     if valeurI<0 then valeurI := 0;
     result := valeurI
end;

procedure TGBFForm.FaireMaj;
var i : integer;
begin
     enabled := false;
     GtsMainForm.setLectureParametres;
     GtsMainForm.ecritOrphy('WSYNTH 2'); { arrt}
     if DCBtn.down
        then GtsMainForm.ecritOrphy('WDAC '+intTostr(NumSARG.itemIndex)+' '+
                                     intToStr(OffsetScroll.position))
        else begin
             if ModifSignal then begin
                DesactiveBtn;
                GtsMainForm.EcritOrphy('WTELE '+intToStr(nbreSA));
                for i := 0 to pred(NbreSA) do if isGTI2
                    then Gti2.output := char(valeurSA(i))
                    else GtsMainForm.VoieSerie.OutPut := char(valeurSA(i));
                repeat until GtsMainForm.voieSerie.outBuffUsed=0;
                ModifSignal := false;
                ActiveBtn;
             end;
             GtsMainForm.ecritOrphy('WSYNTH '+intTostr(NumSARG.itemIndex)+
                                    ' '+intToStr(periode)+' 0');
        end;
     enabled := true;
     MajBtn.enabled := false;
     GtsMainForm.finLectureParametres;
end;

procedure TGBFForm.ParamChange(Sender: TObject);
begin
    ModifSignal := true;
    majSA;
end;

procedure TGBFForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     GtsMainForm.ecritOrphy('WSYNTH 2'); { arrt}
     GtsMainForm.GTBFItem.checked := false;
     parserI.free;
     Hide;
end;

procedure TGBFForm.FormCreate(Sender: TObject);
begin
     UniteVolt := Tunite.create;
     UniteVolt.NomUnite := 'V';
     ModifSignal := true;
     Periode := 1000; { s soit 1 ms }
     ParserI := Tparser.create(nil);
     IndiceParser := ParserI.SetVariable('i',0);
     ParserI.expression := 'i*5/255';
     ExpressionEdit.text := ParserI.expression;
end;

procedure TGBFForm.SignalBtnClick(Sender: TObject);
begin
    ModifSignal := true;
    MajSA
end;

procedure TGBFForm.FrequenceEditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then FrequenceEditExit(sender)
end;

procedure TGBFForm.MajFrequence;
begin
        try
        if periode<20 then periode := 20;
        if periode>32767 then periode := 32767;
        MajSA;
        except
        end;
end;

procedure TGBFForm.FormActivate(Sender: TObject);
begin
     MajSA
end;

procedure TGBFForm.FrequenceSpinDownClick(Sender: TObject);
begin
     ModifFrequence(true)
end;

procedure TGBFForm.ModifFrequence(down : boolean);
var dN : integer;
begin
     dN := periode div 20; { pas de 5% }
     if down
        then inc(periode,dN)
        else dec(periode,dN);
     MajFrequence;
end;

procedure TGBFForm.FrequenceSpinUpClick(Sender: TObject);
begin
     ModifFrequence(false)
end;

procedure TGBFForm.DesactiveBtn;
begin
    DutyScroll.enabled := false;
    OffsetScroll.enabled := false;
    AmplitudeScroll.enabled := false;
    FrequenceEdit.enabled := false;
    FrequenceSpin.enabled := false;
    Screen.cursor := crHourGlass;
end;

procedure TGBFForm.ActiveBtn;
begin
    DutyScroll.enabled := true;
    OffsetScroll.enabled := true;
    AmplitudeScroll.enabled := true;
    FrequenceEdit.enabled := true;
    FrequenceSpin.enabled := true;
    Screen.cursor := crDefault;
end;

procedure TGBFForm.AideBtnClick(Sender: TObject);
begin
   Application.HelpContext(15)
end;

procedure TGBFForm.FrequenceEditExit(Sender: TObject);
var frequence : double;
begin
     frequence := GetFloat(FrequenceEdit.text);
     periode := trunc(1e6/frequence/NbreSA);
     MajFrequence
end;

procedure TGBFForm.OscilloPaint(Sender: TObject);
var y0 : double;
    i : indiceVecteur;
    xi,yi : integer;
    AX,AY,BY : double;
begin
     if NumSARG.itemIndex=0 then y0 := 0 else y0 := 127;
with oscillo.canvas do begin
     pen.width := 1;
     pen.style := psSolid;
     pen.color := clBlue;
     AX := oscillo.width/NbreSA;
     AY := -oscillo.height/MaxiHardSA;
     BY := oscillo.height;
     yi := round(AY*valeurSA(0)+BY);
     MoveTo(0,yi);
     for i := 0 to pred(NbreSA) do begin
        yi := round(AY*valeurSA(i)+BY);
        xi := round(AX*i);
        LineTo(xi,yi);
     end;{for i}
     yi := round(AY*y0+BY);
     MoveTo(0,yi);
     xi := round(AX*NbreSA);
     pen.style := psDot;
     pen.color := clBlack;
     LineTo(xi,yi);
end end;

procedure TGBFForm.ExpressionEditExit(Sender: TObject);
begin
     ParserI.expression := ExpressionEdit.text
end;

procedure TGBFForm.NumSARGClick(Sender: TObject);
begin
    ModifSignal := true;
    majSA
end;

procedure TGBFForm.MajTimerTimer(Sender: TObject);
begin
    if MajBtn.enabled
       then if MajBtn.layout=blGlyphRight
          then MajBtn.layout := blGlyphLeft
          else MajBtn.layout := blGlyphRight
       else MajTimer.enabled := false;
end;

procedure TGBFForm.MajSA;
var freq,Vmax : double;
begin
   MajBtn.enabled := true;
   MajTimer.enabled := true;
   AmplitudeGB.enabled := not DCbtn.down and not ArbitraireBtn.down;
   DutyGB.enabled := not DCbtn.down and not ArbitraireBtn.down;
   FrequenceGB.enabled := not DCbtn.down;
   PanelArbitraire.Visible := arbitraireBtn.Down;
     if DCBtn.down
        then OffsetGB.caption := trValeur
        else OffsetGB.caption := trOffset;
   freq := 1/(periode*NbreSA*1e-6);
   frequenceEdit.text := formatGTS(freq);
   if numSARG.ItemIndex=0
        then begin
           Vmax := 5;
           OffsetEdit.text := uniteVolt.formatUnite(OffsetScroll.position*5/255);
        end
        else begin
           Vmax := 10;
           OffsetEdit.text := uniteVolt.formatUnite((OffsetScroll.position-127)*10/255);
        end;
   DutyEdit.text := IntToStr(DutyScroll.position)+'%';
   AmplitudeEdit.text := uniteVolt.formatUnite(AmplitudeScroll.position*Vmax/255);
   oscillo.refresh;
end;

procedure TGBFForm.MajBtnClick(Sender: TObject);
begin
  FaireMaj
end;

end.
