unit GBFU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons, inifiles,
  maths, gti2_module_def, gti2Util, gti2_gts2,
  gti2_module_graphe, uniteker, ExtCtrls, gti2Const, parser10, Lcd;

type

  Tsignal = (sCarre,sTriangle,sSinus,sArbitraire);
  TGBF = class
     private
     ParserI : Tparser;
     data : vecteurGBF;
     Procedure setExpression(avalue : wideString);
     Function getExpression : wideString;
     public
     Monocoup : boolean;
     Frequence : integer;
     Amplitude,Offset,Duty : double;
     signal  : Tsignal;
     property expression : wideString read getExpression write setExpression;
     Procedure CalculValeur;
     Procedure Marche;
     Procedure Arret;
     procedure Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
     destructor Destroy;override;
     constructor Create;
  end;

var GBF : Tgbf;

implementation

Procedure TGBF.CalculValeur;

function valeurI(valeurR : double) : integer;
begin
     result := round(-valeurR*MaxiHardGBF/gammeGBF)+zeroGBF;
     if result>MaxiHardGBF then result := maxiHardGBF;
     if result<0 then result := 0;
end;

var valeurR,deltat,pente,Atriangle : double;
    posDuty,i : integer;
begin
     gti2.freqGBF := frequence;
     deltat := 1/gti2.NbreGBF;
     frequence := gti2.freqGBF; // valeur exacte
     case signal of
        sArbitraire : for i := 0 to pred(gti2.NbreGBF) do begin
                 ParserI.T := i*deltat;
                 valeurR := ParserI.Value;
                 data[i] := valeurI(valeurR);
        end;
        sSinus : for i := 0 to pred(gti2.NbreGBF) do begin
                valeurR := Amplitude*sin(2*pi*i*deltat);
                data[i] := valeurI(valeurR+Offset);
        end;
        else begin
          PosDuty := round(gti2.NbreGBF*Duty);
          if posDuty<2 then posDuty := 2;
          if posDuty>(gti2.NbreGBF-2) then posDuty := gti2.NbreGBF-2;
          pente := Amplitude*2.0/posDuty;
          for i := 0 to posDuty do begin
              if signal=sCarre
                 then valeurR := -Amplitude
                 else valeurR := -Amplitude+i*pente;
              data[i] := valeurI(valeurR+Offset);
          end;
          pente := Amplitude*2.0/(gti2.nbreGBF-posDuty);
          Atriangle  := Amplitude+posDuty*pente;
          for i := succ(posDuty) to pred(gti2.nbreGBF) do begin
              if signal=sCarre
                 then valeurR := +Amplitude
                 else valeurR := +Atriangle-i*pente;
              data[i] := valeurI(valeurR+Offset);
          end;
        end;
     end;
     for i := gti2.nbreGBF to NbreMaxGBF do data[i] := 0
end;

destructor TGBF.Destroy;
begin
    parserI.free;
    inherited destroy;
end;

constructor TGBF.Create;
begin
     inherited create;
     ParserI := Tparser.create(nil);
     ParserI.expression := 't*5';
end;

procedure TGBF.SetExpression(avalue : wideString);
begin
     ParserI.expression := avalue
end;

function TGBF.getExpression : wideString;
begin
     result := ParserI.expression
end;

procedure TGBF.Marche;
begin
     gti2.stopGenerateur; // arrt
     gti2.boucleGenerateur := not monocoup;
     gti2.lanceGenerateur(data);
end;

procedure TGBF.Arret;
begin
    gti2.stopGenerateur // arrt
end;

procedure TGBF.Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
var i : indiceVecteur;
    xi,yi : integer;
    AX,AY : double;
begin with Acanvas do begin
     brush.Style := bsSolid;
     brush.color := clWindow;
     pen.width := 1;
     pen.style := psSolid;
     pen.color := clBlack;
     rectangle(0,0,largeur,hauteur);
     pen.color := clBlue;
     AX := largeur/gti2.NbreGBF/2;
     AY := hauteur/MaxiHardGBF;
     yi := round(AY*data[0]);
     MoveTo(0,yi);
     for i := 0 to pred(gti2.NbreGBF) do begin
        yi := round(AY*data[i]);
        xi := round(AX*i);
        LineTo(xi,yi);
     end;{for i}
     for i := 0 to pred(gti2.NbreGBF) do begin
        yi := round(AY*data[i]);
        xi := round(AX*(i+gti2.NbreGBF));
        LineTo(xi,yi);
     end;{for i}
// zro
     yi := hauteur div 2;
     MoveTo(0,yi);
     pen.style := psDot;
     pen.color := clBlack;
     LineTo(largeur,yi);
// prvenir deux priodes
     xi := round(AX*gti2.NbreGBF/2);
     font.color := clRed;
     TextOut(xi,4,'Deux priodes');
end end;

initialization
  gbf := tgbf.create;

finalization
  gbf.Free;

end.


