unit GTI2_GTS2;

interface
uses Windows, Messages, classes, sysUtils,
     gti2_dll, oomisc, maths, gti2util;

const
    WM_Zresul = WM_USER + 16;
    WM_Fin_Zresul = WM_USER + 17;
    NbreMaxGBF = 16000;

type
    TRAMGTI2 = array[0..60000] of char;

    TGTI2 = class(Tobject)
          private
              FhandleGTI2 : Thandle;
              FThreadResul : Thandle;
              FhandleWindow : HWND;
              Fversion : shortString;
              FfreqGBF : integer;
              FhorlogeGBF : indiceHorloge;
              FNbreGBF : integer;
              Freload : integer;
              DataGet : Tdata_RS232;
              FValeurMot : pseudoWord;
              Fnbre : integer;
              Findex : integer;
              FnbreResul : integer;
              Fstop : boolean;
              Fdata : TRAMGTI2;
              Floop : boolean;
              function getResul : integer;
              function readChar : char;
              Procedure send(commande : shortString);
              procedure setFreqGBF(afreq : integer);
              procedure FlushInBuffer;
              procedure FlushOutBuffer;
              Procedure getValeurMot(commande : shortString;attente,count : integer);
          public
              property getChar : char read readChar;
              property NbreGBF : integer read FNbreGBF;
              property FreqGBF : integer read FFreqGBF write setFreqGBF;
              property BoucleGenerateur : boolean read Floop write Floop;
              Property output : shortString write send;
              function isOpen : boolean;
              function Open : boolean;
              procedure Close;
              function Version : shortString;
              function getFiltre : pseudoWord;
              function getWord(commande : shortString) : word;
              function getLongWord(commande : shortString) : longWord;
              function getByte(commande : shortString) : byte;
              Function getInt(commande : shortString) : integer;
              Function getReco : pseudoWord;
              procedure LanceThreadZresul(nbre : integer);
              procedure StopThreadZresul(arret : boolean);
              procedure StopThreadMagnum;
              procedure LanceGenerateur(const data : vecteurGBF);
              procedure StopGenerateur;
              procedure EcritData;
              constructor Create(ahandle : HWND);
              destructor Destroy;override;
          end;

var GTI2 : TGTI2;          

implementation

function GetResulThread : integer;stdcall;
begin
    result := gti2.getResul
end;

function TGTI2.isOpen : boolean;
begin
    result := (FhandleGTI2>0) and (_isRunThread=1)
end;

function TGTI2.Open : boolean;
begin
     if FhandleGTI2<=0 then begin
        FHandleGTI2 := _SetPortOpen('OrphyGTI2-0');
        if FhandleGTI2>0 then begin
           sleep(100);
           _ChangeVitesse(FhandleGTI2,1); // 0:9600 bauds 1:125 000 bauds
           sleep(500);
           _LanceThread(FHandleGTI2);
           sleep(100);
         end;  
     end;
     result := (FhandleGTI2>0) and (_isRunThread=1);
end;

procedure TGTI2.Close;
begin
     stopThreadZresul(false);
     if (FhandleGTI2>0) and (_isRunThread=1) then begin
          _StopThread;
          sleep(2000);
     end;
     if FhandleGTI2>0 then begin
        _SetPortClose(FHandleGTI2);
        sleep(100);
     end;
     FhandleGTI2 := 0;
end;

function TGTI2.Version : shortString;

procedure ChercheVersion;
var atimer : eventTimer;
    fini : boolean;
    longueur,i : longInt;
begin
    send('WVERSION');
    fini := false;
    newTimer(Atimer,9);
    repeat
      longueur := _GetLenH8;
      if longueur>0 then begin
         longueur := _GetH8(dataGet,longueur,0);
         for i := 0 to pred(longueur) do begin
             if dataGet.bufferC[i]>=' '
                then Fversion := Fversion+dataGet.bufferC[i]
                else if dataGet.buffer[i]=13 then fini := true;
         end;
      end;
   until fini or timerExpired(Atimer);
end;

begin
   if FhandleGTI2<=0
      then result := 'GTI II non branche ?'
      else begin
         if Fversion='' then chercheVersion;
         result := Fversion;
      end;
end;

Function TGTI2.getWord(commande : shortString) : word;
begin
     GetValeurMot(commande,4,2);
     result := FvaleurMot.mot;
end;

Function TGTI2.getFiltre : pseudoWord;
begin
     GetValeurMot(char(213),9,10);
     result := FvaleurMot;
end;

Function TGTI2.getLongWord(commande : shortString) : longWord;
begin
     GetValeurMot(commande,10,4);
     result := FvaleurMot.longMot;
end;

Function TGTI2.getByte(commande : shortString) : byte;
begin
     GetValeurMot(commande,4,1);
     result := FvaleurMot.octet;
end;

Function TGTI2.getInt(commande : shortString) : integer;
begin
     GetValeurMot(commande,4,2);
     result := FvaleurMot.entier;
end;

Procedure TGTI2.getValeurMot(commande : shortString;attente,count : integer);
var ET : eventTimer;
    indexOctet,i,longueur : integer;
begin
    flushInBuffer;
    for i := 0 to pred(count) do
        FvaleurMot.octets[i] := #0;
    indexOctet := 0;
    send(commande);
    newTimer(ET,attente);
    repeat
      longueur := _GetLenH8;
      if longueur>0 then begin
         longueur := _GetH8(dataGet,longueur,0);
         for i := 0 to pred(longueur) do begin
             FvaleurMot.octets[indexOctet] := dataGet.bufferC[i];
             inc(indexOctet);
         end;
      end;
   until (indexOctet=count) or timerExpired(ET);
end;

Procedure TGTI2.flushInBuffer;
var ET : eventTimer;
    longueur : integer;
begin
    newTimer(ET,18);
    repeat
        sleep(20);
        longueur := _GetLenH8;
        if longueur>0 then _GetH8(dataGet,longueur,0);
    until (longueur=0) or timerExpired(ET);
end;

Function TGTI2.getReco : pseudoWord;
begin
     GetValeurMot('WRECO',6,6);
     result := FvaleurMot;
end;

Procedure TGTI2.send(commande : shortString);
var i,longueur : integer;
begin
    longueur := length(commande);
    for i := 0 to pred(longueur) do
        dataGet.bufferC[i] := commande[i+1];
    if longueur>1 then begin // sinon commande rapide 
       dataGet.buffer[longueur] := 13;
       longueur := longueur+1;
    end;
    _SendH8(dataGet,longueur);
//    sleep(longueur);
    FlushOutBuffer;
end;

procedure Tgti2.FlushOutBuffer;
var ET : eventTimer;
begin
     newTimer(ET,5);
     repeat sleep(1)
     until (_emptyBuffer=0) or timerExpired(ET);
end;

constructor TGTI2.Create(ahandle : HWND);
begin
  inherited create;
  FhandleGTI2 := 0;
  FHandleWindow := ahandle;
  Fversion := '';
  Floop := true;
  FFreqGBF := 10000;
  FNbreGBF := 4800;
  Freload := 0;
  FhorlogeGBF := 0;
end;

destructor TGTI2.Destroy;
begin
    close;
    inherited destroy;
end;

function TGTI2.getResul : integer;
var IncNbre,i : LongInt;
    longueur : integer;
begin
        FNbre := 0;
        Findex := 0;
        Fstop := false;
        for i := 0 to pred(FNbreResul) do Fdata[i] := #0;
        try
        repeat
             longueur := _GetLenH8;
             if longueur>MaxDataRs232 then longueur := MaxDataRS232;
             if longueur>0 then begin
                IncNbre := _GetH8(dataGet,longueur,0);
                for i := 0 to pred(incNbre) do
                    Fdata[Fnbre+i] := dataGet.BufferC[i];
                if IncNbre>0 then begin
                   FNbre := FNbre + IncNbre;
                   PostMessage(FHandleWindow,WM_ZResul,IncNbre,0);
                end;
             end;
        until (FNbre >= FnbreResul) or Fstop;
        except
        end;
        if not Fstop then PostMessage(FHandleWindow,WM_Fin_ZResul,0,0);
        result := 0
end;

procedure TGTI2.LanceThreadZresul(nbre : integer);
var code : cardinal;
begin
      if FhandleGTI2<=0 then exit;
      try
      if FThreadResul<>0 then begin
         if getExitCodeThread(FThreadResul,code) and (code=Still_active) then exit;
         closeHandle(FThreadResul);
         FThreadResul := 0;
      end;
      FnbreResul := nbre;
      FThreadResul := CreateThread(nil,0,@GetResulThread,nil,0,code);
      except
      end;
end;

Procedure TGTI2.StopThreadMagnum;
var code : cardinal;
    acqEnCours : boolean;
    ET : eventTimer;
begin
      if FhandleGTI2<=0 then exit;
      if FThreadResul<>0 then begin
         Fstop := true;
         newTimer(ET,18);
         repeat
              AcqEnCours := getExitCodeThread(FThreadResul,code) and
                           (code=Still_active);
         until not AcqEnCours or TimerExpired(ET);
         if FNbre<FnbreResul then flushInBuffer;
         closeHandle(FThreadResul);
         FThreadResul := 0;
     end;
end;

Procedure TGTI2.StopThreadZresul(arret : boolean);
var code : cardinal;
    acqEnCours : boolean;
    ET : eventTimer;
begin
      if FhandleGTI2<=0 then exit;
      if FThreadResul<>0 then begin
         Fstop := true;
         if (FNbre<FnbreResul) then begin
             if arret then output := 'WPE';
             _stopAcquiLente;
         end;
         newTimer(ET,18);
         repeat
              AcqEnCours := getExitCodeThread(FThreadResul,code) and
                           (code=Still_active);
         until not AcqEnCours or TimerExpired(ET);
         if FNbre<FnbreResul then flushInBuffer;
         closeHandle(FThreadResul);
         FThreadResul := 0;
     end;
end;

Function TGTI2.ReadChar : char;
begin
     if (Findex<Fnbre) then begin
        result := Fdata[Findex];
        inc(Findex);
     end
     else result := #0
end;

procedure TGTI2.setFreqGBF(afreq : integer);
begin
    if afreq<1 then afreq := 1;
    if afreq>=10000 then afreq := 9999;
    FReload := 0;
    FhorlogeGBF := 0;
    FNbreGBF := freqHorloge[0] div afreq;
    if FNbreGBF<NbreMaxGBF then begin
       FfreqGBF := freqHorloge[0] div FNbreGBF;
       exit;    // 3 kHz  48 MHz
    end;
    Freload := 65536-1;
    FhorlogeGBF := 1;
    FNbreGBF := freqHorloge[1] div afreq;
    if FNbreGBF<NbreMaxGBF then begin
       FfreqGBF := freqHorloge[1] div FNbreGBF;
       exit; // 750 Hz  3 kHz
    end;
    FhorlogeGBF := 2;
    FNbreGBF := freqHorloge[2] div afreq;
    if FNbreGBF<NbreMaxGBF then begin
         FfreqGBF := freqHorloge[2] div FNbreGBF;
         exit; // 250 Hz  750 Hz
    end;
    FReload := (FNbreGBF div NbreMaxGBF) + 1;
    FNbreGBF := FNbreGBF div Freload;
    FfreqGBF := freqHorloge[FhorlogeGBF] div FNbreGBF div FReload;
    FReload := 65536-Freload;
end;

procedure TGTI2.LanceGenerateur(const data : vecteurGBF);
var i : integer;
    FdataGenerateur : Data_Generateur;
begin
    _StopThread;
    sleep(100);
    FdataGenerateur.NbreData := FnbreGBF;
    FdataGenerateur.BaseDeTemps := FhorlogeGBF;
    FdataGenerateur.Reload := Freload;
    for i := 0 to pred(FNbreGBF) do
        FdataGenerateur.bufferOut[i] := data[i];
    _LanceGenerateur(FhandleGTI2,ord(Floop),FdataGenerateur);
    sleep(100);
    _LanceThread(FHandleGTI2);
end;

procedure TGTI2.StopGenerateur;
begin
    _StopGenerateur(FhandleGTI2)
end;

procedure TGTI2.EcritData;
var i : integer;
    donnees : TstringList;
    nomFichier : string;
    valeur : pseudoWord;
begin
     Donnees := TstringList.create;
     donnees.add('Nombre='+intToStr(Fnbre div 2));
     for i := 0 to pred(FNbre div 2) do begin
         valeur.octets[0] := Fdata[2*i];
         valeur.octets[1] := Fdata[2*i+1];
         donnees.Add(intToStr(valeur.mot));
     end;
     NomFichier := paramStr(0);
     NomFichier := changeFileExt(nomFichier,'.txt');
     donnees.saveToFile(NomFichier);
     Donnees.free;
end;

end.

