unit gti2_dll;
{**************************************************************************}
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 2000 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{    Final Delphi-Jedi (Darth) command-line units edition                  }
{    Generated Date: 02/02/2006                                            }

interface

uses Windows,SysUtils;

//****************************************
// Structure de Communication avec GTI2
//**************************************

const
   MaxDataRs232 = 512;
   MaxDataGet = 252; // ??
   MaxDataGBF = 16000;
   MaxDataGTI = 256;

type
  indiceHorloge = 0..2;
  indiceVoieYD = 0..3;

  DATA_GTI = record
    DataLen: Array[indiceVoieYD] of LongInt;
    BufferIn: Array[indiceVoieYD,0..MaxDataGTI-1] of LongInt;
  end {_DATA_GTI};

  DATA_GENERATEUR = record
    NbreData: LongInt;
    BaseDeTemps: byte;
    Reload: LongInt; // 4 octets
    BufferOut: Array[0..MaxDataGBF-1] of LongInt; //( -2147483648  2147483647 )
  end {_DATA_GENERATEUR};

  ACQUISITION_VOIE = record
    On: UCHAR;
    Calibre: UCHAR;
    Differentiel: UCHAR;
  end {_ACQUISITION_VOIE};

  ACQUISITION_TRIG = record
    TrigOn: UCHAR;
    PreTrigOn: UCHAR;
    FrontMontant: UCHAR;
    Valeur: LongInt;
  end {_ACQUISITION_TRIG};

  ACQUISITION_CONFIG = record
    BaseDeTemps: UCHAR;
    Reload: UCHAR;
    UnSurN: LongInt;
  end {_ACQUISITION_CONFIG};

  DATA_ACQUISITION = record
    Calibrage: UCHAR;
    Voie: Array[indiceVoieYD] of ACQUISITION_VOIE;
    Config: ACQUISITION_CONFIG;
    Trig: ACQUISITION_TRIG;
  end {_DATA_ACQUISITION};

  TDATA_RS232 = record
  case boolean of
        false : ( Buffer: Array[0..MaxDataRs232-1] of byte;  );
        true  : ( BufferC: Array[0..MaxDataRS232-1] of char; );
  end;

const FreqHorloge : array[indiceHorloge] of LongInt = (48000000,12000000,4000000);

function _SetPortClose(hHandle: THandle): LongInt cdecl;
function _SetPortOpen(strDeviceName: WideString): THandle cdecl;
function _DefineUSB  (hHandle: THandle): LongInt cdecl;
function _GetVersion(hHandle: THandle;strVersion : Pchar): LongInt cdecl;
function _GetUSBData(hHandle: THandle;var pTransfer: DATA_GTI;
                    var pTransfer2: DATA_ACQUISITION): LongInt cdecl;
function _LanceAcqui(hHandle: THandle;var pTransfer: DATA_ACQUISITION): LongInt cdecl;
function _LanceAcquiManuel(hHandle: THandle;var pTransfer: DATA_ACQUISITION;
                           CLK,BT_Pretrig,ReloadCLK : longInt): LongInt cdecl;
function _StopAcqui(hHandle: THandle): LongInt cdecl;
function _LanceTHREAD(hHandle: THandle): LongInt cdecl;
function _StopTHREAD: LongInt cdecl; //en fait procedure function void en C ?
function _IsRunTHREAD: LongInt cdecl;
function _EmptyBuffer: LongInt cdecl;                               
procedure _SendH8(var pBuffer: Tdata_RS232;LenBuffer: LongInt) cdecl;
function _GetH8(var pBuffer: Tdata_RS232;LenBuffer: LongInt;UNICODE: BYTE): LongInt cdecl;
function _GetLenH8: LongInt cdecl;
// function _StopAcquiLENTE: LongInt  cdecl;//en fait procedure function void en C ?
function _GetPipe(hHandle: THandle;Buffer1: PChar;LenSend: LongInt;Canal: LongInt): LongInt cdecl;
function _SendPipe(hHandle: THandle;Buffer1: PChar;LenSend: LongInt;Canal: LongInt): LongInt cdecl;
function _LanceGenerateur(hHandle: THandle;Loop: Byte;var pTransfer: DATA_GENERATEUR): LongInt cdecl;
function _StopGenerateur(hHandle: THandle): LongInt cdecl;
function _ChangeVitesse(hHandel: THandle;Vitesse : byte): longInt cdecl;

implementation

function _SetPortClose; external 'GTICOMMX.DLL';
function _SetPortOpen; external 'GTICOMMX.DLL';
function _DefineUSB;external 'GTICOMMX.DLL';
function _GetVersion; external 'GTICOMMX.DLL';
function _GetUSBData; external 'GTICOMMX.DLL';
function _LanceAcqui; external 'GTICOMMX.DLL';
function _LanceAcquiManuel; external 'GTICOMMX.DLL';
function _StopAcqui; external 'GTICOMMX.DLL';
function _LanceTHREAD; external 'GTICOMMX.DLL';
function _StopTHREAD; external 'GTICOMMX.DLL';
function _IsRunTHREAD; external 'GTICOMMX.DLL';
function _EmptyBuffer; external 'GTICOMMX.DLL';
procedure _SendH8; external 'GTICOMMX.DLL';
function _GetH8; external 'GTICOMMX.DLL';
function _GetLenH8; external 'GTICOMMX.DLL';
// function _StopAcquiLENTE; external 'GTICOMMX.DLL';
function _GetPipe; external 'GTICOMMX.DLL';
function _SendPipe; external 'GTICOMMX.DLL';
function _LanceGenerateur; external 'GTICOMMX.DLL';
function _StopGenerateur; external 'GTICOMMX.DLL';
function _ChangeVitesse; external 'GTICOMMX.DLL';

end.
