unit Etalon;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils,
  maths, gtsutil, gtsdef, gtsmain, constgts, ComCtrls;

type
  TEtalonneInterDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    EditInteractif1: TEdit;
    EditInteractif2: TEdit;
    Label4: TLabel;
    Bevel3: TBevel;
    Timer: TTimer;
    Point1: TSpeedButton;
    Point2: TSpeedButton;
    Point2Manuel: TSpeedButton;
    GaugeInter1: TProgressBar;
    GaugeInter2: TProgressBar;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure Point2Click(Sender: TObject);
    procedure Point2ManuelClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    point1Actif : boolean;
    procedure finOK(Manuel : boolean);
  public
    voieCourante : Tvoie;
  end;

var
  EtalonneInterDlg: TEtalonneInterDlg;

implementation

{$R *.DFM}

procedure TEtalonneInterDlg.TimerTimer(Sender: TObject);
var zi : integer;
begin
     zi := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
     if point1Actif
        then GaugeInter1.position := zi
        else GaugeInter2.position := zi
end;

procedure TEtalonneInterDlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
     EditInteractif1.text := FormatGts(Offset);
     EditInteractif2.text := FormatGts(UnVolt);
     GaugeInter1.position := 0;
     GaugeInter2.position := 8000;
     LabelInteractif.caption := Nom+'/'+NomUnite;
     Point1.down := false;
     Point2.down := false;
     Point1Actif := true;
     timer.enabled := true;
     Point1.visible := true;
     Point2.visible := false;
     Point2Manuel.visible := false;
     EditInteractif1.setFocus;
end end;

procedure TEtalonneInterDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.finOK(Manuel : boolean);
var valeurReel,valeurCan : array[1..2] of double;
    valeurOK : boolean;
begin
     timer.enabled := false;
     try
     valeurReel[1] := GetFloat(EditInteractif1.text);
     valeurCan[1] := voieCourante.ValeurVolt(GaugeInter1.position);
     if manuel
        then begin
             valeurReel[2] := 0;
             valeurCan[2] := 0;
        end
        else begin
             valeurReel[2] := GetFloat(EditInteractif2.text);
             valeurCan[2] := voieCourante.ValeurVolt(GaugeInter2.position);
        end;
     ValeurOK := (valeurCan[1]<>sansSignif) and
                 (valeurCan[2]<>sansSignif) and
                 (valeurReel[1]<>sansSignif) and
                 (valeurReel[2]<>sansSignif) and
                 (valeurReel[2]<>valeurReel[1]);
     if not valeurOK then raise Exception.create(erEtalon);
     valeurOK := abs(valeurCan[2]-valeurCan[1]) > 5/64;
     if valeurOK
        then with voieCourante do begin
            UnVolt := (valeurReel[2]-valeurReel[1])/(valeurCan[2]-valeurCan[1]);
            Offset := valeurReel[2]-UnVolt*valeurCan[2];
        end
        else raise Exception.create(erEtalon2);
     modalResult := mrOK;
     except
        on E: Exception do begin
           afficheErreur(E.message);
           modalResult := mrNone;
           timer.enabled := true;
        end;
     end;
end;

procedure TEtalonneInterDlg.Point1Click(Sender: TObject);
begin
   point1Actif := false;
   EditInteractif2.setFocus;
   Point1.visible := false;
   Point2.visible := true;
   Point2Manuel.visible := true;
end;

procedure TEtalonneInterDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(11)
end;

procedure TEtalonneInterDlg.Point2Click(Sender: TObject);
begin
     finOK(false)
end;

procedure TEtalonneInterDlg.Point2ManuelClick(Sender: TObject);
begin
     finOK(true)
end;

procedure TEtalonneInterDlg.CancelBtnClick(Sender: TObject);
begin
    timer.enabled := false;
    close;
end;

end.
