unit GTSCFG;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs,
  gtsUtil, gtsDef, graphe, gtsmain, maths, 
  listecap, etalon, constgts, ImgList, ComCtrls;

type
  TOrphyGtsDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    CapteursBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    EtalonnageGB: TGroupBox;
    EtalonneInterBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditSignif: TEdit;
    Label3: TLabel;
    AffichageGB: TGroupBox;
    EditValeur: TEdit;
    Label6: TLabel;
    Label0V: TLabel;
    val0Edit: TEdit;
    PenteEdit: TEdit;
    PenteLabel: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CouleurCombo: TColorBox;
    LabelAide: TLabel;
    ZeroBtn: TBitBtn;
    Gauge: TProgressBar;
    EditMini: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    Bevel2: TBevel;
    EtalonCB: TCheckBox;
    PointCombo: TComboBoxEx;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure EtalonneInterBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure ManuelGridClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EditMiniKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMaxiKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMiniExit(Sender: TObject);
    procedure EditMaxiKeyPress(Sender: TObject; var Key: Char);
    procedure EtalonRGClick(Sender: TObject);
    procedure val0EditExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelMaxiClick(Sender: TObject);
    procedure val0EditKeyPress(Sender: TObject; var Key: Char);
    procedure EditMiniKeyPress(Sender: TObject; var Key: Char);
    procedure NonLineaireCBClick(Sender: TObject);
    procedure EADbtnClick(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure CapteursBtnClick(Sender: TObject);
  private
    oldActive : boolean;
    voieVolt,voieCapteur : Tvoie;
    function CalculEtalonManuel : boolean;
    procedure SetEtalonnage;
  public
    voieCourante : Tvoie;
    modif : boolean;
  end;

var
  OrphyGtsDlg: TOrphyGtsDlg;

implementation

{$R *.DFM}

const maxCalibre = 6;
      Calibre : array[0..maxCalibre] of double = (10,5,2,1,0.5,0.2,0.1);

procedure TOrphyGtsDlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := valeurParamTxt;
          LabelAide.caption := Aide;
          oldActive := active;
          caption := 'Entre analogique';
          caption := caption + TitreVoieGTI2[numOrphy];
          OKBtn.Caption := trActiver;
          EtalonCB.checked := avecCapteur;
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          EditMini.text := FormatGTS(mini);
          EditMaxi.text := FormatGTS(maxi);
          val0Edit.text := FormatGts(offset);
          penteEdit.text := FormatGts(unVolt);
          penteLabel.caption := deltaMaj+nom+'/'+DeltaMaj+'V ('+
              nomUnite+'/V)';
          if avecCapteur
             then begin
                  voieCapteur.mini := mini;
                  voieCapteur.maxi := maxi;
                  voieCapteur.nomUnite := nomUnite;
                  voieCapteur.aide := aide;
             end
             else begin
                  voieVolt.mini := mini;
                  voieVolt.maxi := maxi;
             end;
          SetEtalonnage;
          editValeur.Text := '';
          Timer.enabled := true;
          modif := false;
{
          valeurConstE.visible := gtsMainForm.nomConstante<>'';
          valeurConstE.text := FloatToStr(valeurParam);
          valeurConstE.EditLabel.caption := 'Valeur de '+gtsMainForm.nomConstante;
}
end end;

procedure TOrphyGtsDlg.SetEtalonnage;
var oldCapteur : boolean;
    hauteur : integer;
begin with voieCourante do begin
     EtalonnageGB.visible := EtalonCB.checked;
     EditMaxi.Visible := EditMini.Visible;
     hauteur := 475+(height-clientHeight);{ titre = 27 en normal }
     if EtalonnageGB.visible
        then height := hauteur
        else height := hauteur-EtalonnageGB.height;
     oldCapteur := avecCapteur;
     avecCapteur := EtalonCB.checked;
     if oldCapteur<>avecCapteur then
        if avecCapteur
           then begin
              voieVolt.mini := mini;
              voieVolt.maxi := maxi;
              voieVolt.valeurParamTxt := EditSignif.text;
              EditUnite.text := voieCapteur.nomUnite;
              EditMini.text := formatGTS(voieCapteur.mini);
              mini := voieCapteur.mini;
              EditMaxi.text := formatGTS(voieCapteur.maxi);
              maxi := voieCapteur.maxi;
              CalculEtalonManuel;
           end
           else begin
              voieCapteur.mini := mini;
              voieCapteur.maxi := maxi;
              voieCapteur.nomUnite := EditUnite.text;
              voieCapteur.valeurParamTxt := EditSignif.text;
              EditUnite.text := 'V';
              EditMini.text := formatGTS(voieVolt.mini);
              mini := voieVolt.mini;
              EditMaxi.text := formatGTS(voieVolt.maxi);
              maxi := voieVolt.maxi;
           end;
     EtalonneInterBtn.Visible := EtalonCB.checked;
     ZeroBtn.Visible := EtalonCB.checked and avecCapteur;
end end;

procedure TOrphyGtsDlg.OKBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     modif := modif or not oldActive;
     with voieCourante do begin
          AvecCapteur := EtalonCB.checked;
          Nom := EditNom.text;
          if avecCapteur 
             then NomUnite := EditUnite.text
             else NomUnite := 'V';
          if avecCapteur and (nomUnite='T')
             then if numOrphy<10
                then offset := -0.2  // direct 
                else offset := 0;  // avec adaptateur GTI
          valeurParamTxt := EditSignif.text;
          active := true;
          if avecCapteur then maxi := GetFloat(EditMaxi.text);
          if (maxi=sansSignif) then maxi := 10;
          if avecCapteur then mini := GetFloat(EditMini.text);
          if (mini=sansSignif) then mini := 10;
          if not(avecCapteur) then begin
             if maxi>+10 then maxi := +10;
             if mini<-10 then mini := -10;
          end;
          setMinMax;
          couleur := CouleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
{
          try
          valeurParam := StrToFloat(valeurConstE.text);
          except
          end;
}
     end;
end;

procedure TOrphyGtsDlg.DesactiveBtnClick(Sender: TObject);
begin
      modif := oldActive;
      voieCourante.active := false;
      modalResult := mrOK;
      close;
end;

procedure TOrphyGtsDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TOrphyGtsDlg.TimerTimer(Sender: TObject);
var valeur : integer;
begin
     try
     valeur := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
     Gauge.position := valeur;
     with voieCourante do
          EditValeur.text := formatGTS(valeurReal(valeur))+' '+nomUnite;
     except
         Gauge.position := 0
     end;
end;

procedure TOrphyGtsDlg.EditNomChange(Sender: TObject);
begin
     penteLabel.caption := deltaMaj+EditNom.text+'/'+DeltaMaj+'V ('+
        EditUnite.text+'/V)';
     AffichageGB.caption := trAffichage+EditUnite.text+')';
end;

function TOrphyGtsDlg.CalculEtalonManuel : boolean;
begin with voieCourante do begin
      try
          Offset := GetFloat(val0Edit.text);
          UnVolt := GetFloat(penteEdit.text);
          result := true;
      except
          afficheErreur(erNombre);
          result := false;
      end;
end end;

procedure TOrphyGtsDlg.EtalonneInterBtnClick(Sender: TObject);
begin with voieCourante do begin
     timer.enabled := false;
     Nom := EditNom.text;
     NomUnite := EditUnite.text;
     EtalonneInterDlg := TEtalonneInterDlg.create(self);
     EtalonneInterDlg.voieCourante := voieCourante;
     if EtalonneInterDlg.showModal=mrOK then begin
         val0Edit.text := FormatGts(offset);
         penteEdit.text := FormatGts(UnVolt);
         etalonCB.checked := true;
         setEtalonnage;
     end;
     modif := true;
     timer.enabled := true;
     EtalonneInterDlg.free;
end end;

procedure TOrphyGtsDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TOrphyGtsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(7)
end;

procedure TOrphyGtsDlg.ManuelGridClick(Sender: TObject);
begin
     Modif := true
end;

procedure TOrphyGtsDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not (key in (majuscule+minuscule+grecque+toucheEdition+chiffre)) then key := #0
end;

procedure TOrphyGtsDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     if voieCourante.active and
        EtalonCB.checked and
        not CalculEtalonManuel then begin
          afficheErreur(erEtalon);
          canClose := false;
          timer.enabled := true;
     end
     else canClose := true;
end;

procedure TOrphyGtsDlg.EditMiniKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_down then editMaxi.setFocus;
end;

procedure TOrphyGtsDlg.EditMaxiKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_up then editMini.setFocus;
end;

procedure TOrphyGtsDlg.EditMiniExit(Sender: TObject);
begin with voieCourante do begin
     try
     mini := GetFloat(EditMini.text);
     maxi := GetFloat(EditMaxi.text);
     except
     end;
end end;

procedure TOrphyGtsDlg.EditMaxiKeyPress(Sender: TObject; var Key: Char);
begin
   if key=crCR then EditMiniExit(sender)
end;

procedure TOrphyGtsDlg.EtalonRGClick(Sender: TObject);
begin
     modif := true;
     setEtalonnage;
end;

procedure TOrphyGtsDlg.val0EditExit(Sender: TObject);
begin
     CalculEtalonManuel;
end;

procedure TOrphyGtsDlg.FormCreate(Sender: TObject);
begin
     voieVolt := Tvoie.create(1);
     voieCapteur := Tvoie.create(1);
end;

procedure TOrphyGtsDlg.PanelMaxiClick(Sender: TObject);
begin
     with (Sender as Tpanel) do height := height-16;
end;

procedure TOrphyGtsDlg.val0EditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then val0EditExit(sender)
end;

procedure TOrphyGtsDlg.EditMiniKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then editMiniExit(sender)
end;

procedure TOrphyGtsDlg.NonLineaireCBClick(Sender: TObject);
begin
  setEtalonnage
end;

procedure TOrphyGtsDlg.EADbtnClick(Sender: TObject);
begin
    Application.HelpContext(21)
end;

procedure TOrphyGtsDlg.ZeroBtnClick(Sender: TObject);
var valeurI : integer;
    valeurV : double;
begin
     try
     with voieCourante do begin
          valeurI := GtsMainForm.getInt('WEA '+codeVoie);
          valeurV := valeurVolt(valeurI);
          offset := -unVolt*valeurV;
          val0Edit.text := FormatGts(offset);
     end;
     except
     end;
end;

procedure TOrphyGtsDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     if ListeCapteursDlg=nil then
        Application.CreateForm(TListeCapteursDlg, ListeCapteursDlg);
     ListeCapteursDlg.voieCourante := voieCourante;
     if ListeCapteursDlg.showModal=mrOK then begin
        etalonCB.Checked := voieCourante.avecCapteur;
        FormActivate(nil);
        modif := true;
     end;
     timer.enabled := true;
end;

end.

