unit GTSDDE;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, registry, clipbrd,
  ComCtrls, oomisc, math, gtsDef, gti2_dynamique, 
  Maths, Graphe, uniteker, constGTS, gtsutil, DdeMan;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    DdeClientConv1: TDdeClientConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
      isJunior : boolean;
      procedure AjouteConst(var donnees : TstringList);
      procedure Execute(Ordre : shortString);
  public
      procedure MajRegressi;
      procedure EnvoieDonnees(DDE : boolean;nomFichier : String);
//      function SauveDonnees : boolean;
  end;

var
  FormDDE: TFormDDE;

implementation

uses gtsMain, gtsconst;

const crTab=#9;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var Donnees : TstringList);
var strValeur : shortString;
    ConstanteOK : boolean;
    valeurConstante : double;
begin with gtsMainForm do begin
         StrValeur := ConstanteDlg.valeurConstE.text;
         TrimComplet(strValeur);
         if StrValeur=''
            then valeurConstante := sansSignif
            else valeurConstante := StrToFloatWin(strValeur);
         ConstanteOK := (nomConstante<>'') and
                        (valeurConstante<>sansSignif);
     if ConstanteOK then begin
          donnees.Add('');
          donnees.Add(nomConstante);
          donnees.Add(uniteConstante);
          donnees.Add(strValeur);
     end;
end end;

procedure TFormDDE.Execute(Ordre : shortString);
var NomCourt : shortString;

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   StrPCopy(CharVal, NomCourt);
   hSemaphore := CreateSemaphore(nil,0,1,CharVal);
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if WinExec(CharVal, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
var Buf: PChar;
begin
      Buf := StrAlloc(Succ(Length(Ordre)));
      if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
           ShowMessage(Ordre+' non excut');
      StrDispose(Buf);
      ClientDDE.closeLink;
end;

begin
     NomCourt := AnsiUpperCase(ExtractFileName(ClientDDE.ServiceApplication));
     NomCourt := ChangeFileExt(NomCourt,'');
     LanceRegressi;
     ClientDDE.SetLink(NomCourt,'ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then Lance
        else begin
             sleep(1000);
        // OpenLik false efface 
             ClientDDE.SetLink(NomCourt,'ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             if ClientDDE.OpenLink
                then Lance
                else ShowMessage('Impossible de lancer '+nomCourt);
        end;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
begin
      MajRegressi
end;

procedure TFormDDE.MajRegressi;
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
    isJunior := Ini.ReadBool('Regressi','Junior',false);
    Ini.Free;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

procedure TFormDDE.EnvoieDonnees(DDE : boolean;nomFichier : String);
var Donnees : TstringList;

procedure EnvoiePageCourante;
var i : integer;
    v : indiceVoieGTs2;
    ligne : shortString;
begin with grapheGts do begin
     if ConstanteDlg=nil then
        Application.CreateForm(TConstanteDlg, ConstanteDlg);
     if (nomFichier='') and DDE then begin
        donnees.Add(Application.exeName);
        if ConstanteDlg.NewPageCB.itemIndex = 1
            then donnees.Add('')
            else donnees.Add('Acquisition par Orphy GTS-2');
        donnees.Add(GtsMainForm.Commentaire);
     end;
     Ligne := voieTemps.nom;
     for v := voiegts2Min to voieGts2Max do with voieOrphy[v] do
         if active then
            ligne := ligne + crTab + nom;
     donnees.Add(ligne);
     Ligne := voieTemps.nomUnite;
     for v := voiegts2Min to voieGts2Max do with voieOrphy[v] do
         if active then
            ligne := ligne + crTab+ nomUnite;
     donnees.Add(ligne);
     Ligne := 'temps'; // voieOrphy[voieT].valeurParamTxt
     for v := voiegts2Min to voieGts2Max do with voieOrphy[v] do
         if active then
            ligne := ligne + crTab + valeurParamTxt;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligne := FormatTime(voieTemps.vecteurAff[i]);
         for v := voiegts2Min to voieGts2Max do
             if voieOrphy[v].active then
                ligne := ligne + crTab + FormatGTS(voieOrphy[v].vecteurAff[i]);
         donnees.Add(ligne);
     end;
     if DDE then begin
        AjouteConst(donnees);
        donnees.Add(symbReg2+intToStr(NbreVoie)+' NOMX');
        for i := 1 to NbreVoie do
            donnees.Add(voieTemps.nom);
        donnees.Add(symbReg2+intToStr(NbreVoie)+' NOMY');
        for v := voiegts2Min to voieGts2Max do with voieOrphy[v] do
            if active then
                donnees.Add(nom);
     end;
     if nomFichier<>''
        then donnees.saveToFile(NomFichier)
        else begin
           ClipBoard.AsText := Donnees.text;
           if DDE then if ConstanteDlg.NewPageCB.itemIndex = 1
              then Execute('CLIP|ADD')
              else Execute('CLIP|LOAD');
        end;
     ConstanteDlg.NewPageCB.itemIndex := 1;
end end; // EnvoiePageCourante

begin with grapheGts do begin // EnvoieDonnees
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     envoiePageCourante;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { EnvoieDonnees }

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : shortstring;
    ArgStart,ArgEnd : byte;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
           nomFichier := changeFileExt(nomFichier,'.GT12');
           if FileExists(nomFichier) then begin
              GtsMainForm.LitConfig(NomFichier);
              GtsMainForm.afficheReglage;
           end;
           exit
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
           GtsMainForm.EcritConfig(NomFichier);
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           GtsMainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           GtsMainForm.setFocus;
           exit;
       end;
       except
       end;
     end;
end;

{
function TFormDDE.SauveDonnees : boolean;

Procedure Sauve;
var i : integer;
    v : indiceVoie;
    ligne : shortString;
    nomFichier : String;
    donnees : TstringList;
begin with grapheGTS do begin // sauveDonnees
     Donnees := TstringList.create;
     NomFichier := changeFileExt(application.exeName,'.rw3');
     donnees.add('EVARISTE REGRESSI WINDOWS 1.0');
     donnees.add(symbReg+'2 NOM VAR');
     donnees.Add(voieOrphy[voieT].nom);
     donnees.Add(voieOrphy[voieA].nom);
     donnees.add(symbReg+'2 GENRE VAR');
     donnees.add('0');
     donnees.Add('0');
     donnees.add(symbReg+'2 UNITE VAR');
     donnees.add(voieOrphy[voieT].nomUnite);
     donnees.add(voieOrphy[voieA].nomUnite);
     donnees.Add(symbReg+'2 SIGNIF VAR');
     donnees.Add(voieOrphy[voieT].signif);
     donnees.Add(voieOrphy[voieA].signif);
     if gtsMainForm.nomConstante<>'' then begin
        donnees.Add(symbReg+'1 NOM CONST');
        donnees.Add(gtsMainForm.nomConstante);
        donnees.Add(symbReg+'1 UNITE CONST');
        donnees.Add(gtsMainForm.uniteConstante);
        donnees.Add(symbReg+'1 SIGNIF CONST');
        donnees.Add(gtsMainForm.signifConstante);
     end;
     if gtsMainForm.NomConstTxt<>'' then begin
        donnees.Add(symbReg+'1 NOM TC');
        donnees.Add(gtsMainForm.nomConstTxt);
        donnees.Add(symbReg+'1 SIGNIF TC');
        donnees.Add(gtsMainForm.signifConstTxt);
      end;
     donnees.Add(symbReg+'2 ACQUISITION');
     donnees.Add('EXTERNE');
     donnees.Add(application.ExeName);
     for v := voieA to voieAnaMax do with voieOrphy[v] do begin
     donnees.Add(symbReg+'1 PAGE COMMENT');
     donnees.Add(signif);
     donnees.Add(symbReg2+IntToStr(NbreAff)+' VALEUR VAR');
     for i := 0 to pred(NbreAff) do begin
         ligne := FormatTime(voieOrphy[voieT].vecteurAff[i])+' ';
         ligne := ligne + FormatGTS(vecteurAff[i]);
         donnees.Add(ligne);
     end;
     if gtsMainForm.nomConstante<>'' then begin
       donnees.add(symbReg2+'1 VALEUR CONST');
       donnees.add(FormatGTS(ValeurParam));
    end;
    if gtsMainForm.nomConstTxt<>'' then begin
       donnees.add(symbReg2+'1 TEXTE CONST');
       donnees.add(valeurParamTxt);
    end;
     end;
     donnees.saveToFile(NomFichier);
     Execute('FILE|LOAD('+NomFichier+')');
     Donnees.free;
end end; // SauveDonnees

begin
     result := false;
     if grapheGTS.NbreAff<minPointsTemps then exit;
     result := true;
     Screen.Cursor := crHourGlass;
     try
     Sauve;
     except
        result := false; // Pb de protection en criture ?
     end;
     Screen.Cursor := crDefault;
end; // SauveDonnees
}

end.
