unit GTSMAIN;

interface

uses
   SysUtils, Windows, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Registry,
   ComCtrls, ToolWin, ImgList, AwWin32, Math, WinHelpViewer,
   AdPort, oomisc, awuser, spin, clipBrd, inifiles, MMSystem,
   gtsUtil, uniteker, gtsdef, maths, graphe,
   gtsdde, constGts, about, XPMan, Grids, shellApi,
   gti2_dynamique, gti2comp;

const
   DeltatLent = 1;

type
   tModifBaseDeTemps = (mDuree, mDeltat, mNombre, mNbreVoies);

type
   TGTSmainForm = class(TForm)
      OpenDialog:     TOpenDialog;
      SaveDialog:     TSaveDialog;
      PanelVoies:     TPanel;
      GroupBox5:      TGroupBox;
      Label1:         TLabel;
      GroupBox1:      TGroupBox;
      Label2:         TLabel;
      GroupBox2:      TGroupBox;
      Label3:         TLabel;
      GroupBox4:      TGroupBox;
      Label5:         TLabel;
      PanelMode:      TPanel;
      BalayageGB:     TGroupBox;
      DureeEdit:      TEdit;
      DureeSpin:      TSpinButton;
      NbreEdit:       TEdit;
      Timer:          TTimer;
      Oscillo:        TPaintBox;
      NbreSpin:       TSpinButton;
      OrphyAbsent:    TPanel;
      Label6:         TLabel;
      ComBtn:         TSpeedButton;
      Header:         TStatusBar;
      GroupBox6:      TGroupBox;
      Label8:         TLabel;
      EscapeBtn:      TSpeedButton;
      DeltatEdit:     TEdit;
      DeltatSpin:     TSpinButton;
      Label12:        TLabel;
      Label14:        TLabel;
      Label15:        TLabel;
      Menu:           TPopupMenu;
      AproposItem:    TMenuItem;
      ImageList:      TImageList;
      Label7:         TLabel;
      OptionsItem:    TMenuItem;
      XPManifest1:    TXPManifest;
      ResetOrphy:     TMenuItem;
      ConfigActuelle: TMenuItem;
      ToolBar1:       TToolBar;
      EnregistreBtn:  TToolButton;
      StopBtn:        TToolButton;
      ResetBtn:       TToolButton;
      RegSaveBtn:     TToolButton;
      HelpBtn:        TToolButton;
      ExitBtn:        TToolButton;
      PlusBtn:        TToolButton;
      Gauge:          TProgressBar;
      ClipSaveBtn:    TToolButton;
      FileMenu:       TPopupMenu;
      Ouvrirconfig1:  TMenuItem;
      EnregistrerConfig1: TMenuItem;
      FileSaveItem:   TMenuItem;
      ToolButton2:    TToolButton;
      CapteursItem:   TMenuItem;
      GroupBox3:      TGroupBox;
      Label4:         TLabel;
      GroupBox7:      TGroupBox;
      Label9:         TLabel;
      GroupBox8:      TGroupBox;
      Label10:        TLabel;
      GroupBox9:      TGroupBox;
      Label11:        TLabel;
      GroupBox10:     TGroupBox;
      Label13:        TLabel;
      GroupBox11:     TGroupBox;
      Label16:        TLabel;
      GroupBox12:     TGroupBox;
      Label17:        TLabel;
      SynchroGB:      TGroupBox;
      MonocoupCB:     TCheckBox;
      SensSynchroRG:  TRadioGroup;
      AllBtn: TToolButton;
    synchroRG: TRadioGroup;
    SeuilGB: TGroupBox;
    RazSeuilBtn: TSpeedButton;
    SeuilEdit: TEdit;
    SpinButton1: TSpinButton;
      procedure FormCreate(Sender: TObject);
      procedure ShowHint(Sender: TObject);
      procedure ActivateApp(Sender: TObject);
      procedure FileOpen(Sender: TObject);
      procedure FileSaveAs(Sender: TObject);
      procedure FileExit(Sender: TObject);
      procedure HelpAbout(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure TimerTimer(Sender: TObject);
      procedure EnregistreBtnClick(Sender: TObject);
      procedure OscilloPaint(Sender: TObject);
      procedure NombreDownClick(Sender: TObject);
      procedure NombreUpClick(Sender: TObject);
      procedure DureeSpinDownClick(Sender: TObject);
      procedure DureeSpinUpClick(Sender: TObject);
      procedure VoieAnaClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure RegSaveBtnClick(Sender: TObject);
      procedure ClipSaveBtnClick(Sender: TObject);
      procedure FileSaveBtnClick(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure HelpBtnClick(Sender: TObject);
      procedure CapteursItemClick(Sender: TObject);
      procedure ComBtnClick(Sender: TObject);
      procedure EscapeBtnClick(Sender: TObject);
      procedure DeltatSpinDownClick(Sender: TObject);
      procedure DeltatSpinUpClick(Sender: TObject);
      procedure DureeEditKeyPress(Sender: TObject; var Key: char);
      procedure NbreEditKeyPress(Sender: TObject; var Key: char);
      procedure DeltatEditKeyPress(Sender: TObject; var Key: char);
      procedure DureeEditExit(Sender: TObject);
      procedure NbreEditExit(Sender: TObject);
      procedure DeltatEditExit(Sender: TObject);
      procedure FormResize(Sender: TObject);
      procedure OptionsItemClick(Sender: TObject);
      procedure FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure VoltmetreItemClick(Sender: TObject);
      procedure MonocoupCBClick(Sender: TObject);
      procedure ResetOrphyClick(Sender: TObject);
      procedure MenuPopup(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure ConfigActuelleClick(Sender: TObject);
      procedure SynchroRGClick(Sender: TObject);
      procedure SensSynchroRGClick(Sender: TObject);
      procedure RazSeuilBtnClick(Sender: TObject);
      procedure ConfigPages1Click(Sender: TObject);
      procedure AllBtnClick(Sender: TObject);
    procedure SeuilEditExit(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
   private
      etatAcq:           TetatAcq;
      OrphyPresent:      boolean;
      chaineLue:         shortString;
      PremiereAcquisition, PremierPassage: boolean;
      premiereFois: boolean;
      ReactiverGTS:      boolean;
      ValeurMot:         pseudoWord;
      isXP, sauveTimer:  boolean;
      dureeResulMax:     double;
      synchroDetecte:    boolean;
      initialisation: boolean;
      procedure MajEtatEcran;
      procedure MarquePointCourant;
      procedure EffacePointCourant;
      procedure InitAttente;
      procedure LitPointAttente;
      procedure LanceAcqTemps;
      procedure testOrphy;
      procedure SetBoutons;
      procedure MajTemps;
      procedure SetDuree(modif: tModifBaseDeTemps);
      procedure SetDeltat;
      procedure AjusteDeltat(modif: tModifBaseDeTemps);
      procedure setNombre;
      procedure SetSizeVoie;
      procedure DesactiveBtn;
      procedure NbreAffNul;
      procedure DeltaSeuil(signe : integer);
   public
      etatAvail:      TetatAvail;
      SauverConfig:   boolean;
      nomConstante:   strUnite;
      uniteConstante: strUnite;
      signifConstante: shortString;
      nomConstTxt:   strUnite;
      signifConstTxt: shortString;
      commentaire:    shortString;
      DebutAcquisition : TdateTime;
      VersionOrphy:   shortString;
      NumeroVersion:  integer;
      procedure ecritOrphy(ordre: shortString);
      procedure LitConfig(NomFichier: string);
      procedure EcritConfig(nomFichier: string);
      procedure AfficheReglage;
      procedure DebutLectureParametres;
      procedure FinLectureParametres;
      procedure videOutBuffer;
      function getLongWord(commande: shortString): longword;
      function getWord(commande: shortString): word;
      function getByte(commande: shortString): byte;
      function getInt(commande: shortString): integer;
   protected
      procedure WMSetFocus(var Msg: Tmessage); message wm_SetFocus;
   end;

var
   GTSmainForm: TGTSmainForm;

implementation

uses gtscfg, gtsconst, optPro,
   choixCap, SysInfoCtrls, ToutesVoiesU;

{$R *.DFM}

const
   NumeroVersionGTI2 = 104;

procedure TGTSmainForm.LitConfig(NomFichier: string);
var
   Fichier: tMemIniFile;
   voie: indiceVoieGTS2;
   sd: integer;
begin
   nomFichier := changeFileExt(nomFichier, '.GT12');
   if not FileExists(nomFichier) then
      exit;
   Fichier := tMemIniFile.Create(NomFichier);
   try
   with Fichier, grapheGTS do
   begin
      nomConstante := readString('Constante', 'Nom', '');
      uniteConstante := readString('Constante', 'Unite', '');
      signifConstante := readString('Constante', 'Signif', '');
      nomConstTxt := readString('ConstTxt', 'Nom', '');
      signifConstTxt := readString('ConstTxt', 'Signif', '');
      commentaire := readString('Regressi', 'Commm', '');
      oTraceLigne := ReadBool('Affichage', 'Ligne', True);
      oTracePoints := ReadBool('Affichage', 'Points', False);
      quadrillage := ReadBool('Affichage', 'Grille', False);
      AnalyseurLogique := ReadBool('Affichage', 'AnalLog', False);
      debutAcquisition := readDateTime('Balayage', 'DebutAcq', now);
      BaseDeTemps.DureeBalayage := ReadFloat('Balayage', 'Dure', 1.0);
      NbreInter := readInteger('Balayage', 'Nombre', 128);
      BaseDeTemps.Deltat := BaseDeTemps.DureeBalayage / NbreInter;
      gti2.montant := readBool('Synchro', 'Montant', True);
      sensSynchroRG.ItemIndex := Ord(gti2.montant);
      Monocoup := ReadBool('Synchro', 'Monocoup', True);
      MonocoupCB.checked := Monocoup;
      AvecUnAxe := ReadBool('Affichage', 'AxeY', True);
      sd := 2048;
      gti2.seuilVolt := readFloat('Synchro', 'Seuil', sd);
      synchroRG.itemIndex := readInteger('Synchro', 'Mode', 3);
      gti2.voieSynchro := synchroRG.itemIndex;
      dimPoint := readInteger('Affichage', 'DimPoint', dimPoint);
      for voie := voieGTS2Min to VoieGTS2Max do
         with voieOrphy[voie] do
            load('V' + IntToStr(voie), fichier);
   end;
   AjusteDeltat(mDuree);
   except
   end;
   fichier.Free;
   NbreAffNul;
end; // litConfig

procedure TGTSmainForm.EcritConfig(nomFichier: string);
   var Fichier: tMemIniFile;
       voie: indiceVoieGTS2;
   begin
   nomFichier := ChangeFileExt(nomFichier, '.GT12');
   try
   Fichier := tMemIniFile.Create(nomFichier);
   with fichier, grapheGTS do begin
         WriteString('Constante', 'Nom', nomConstante);
         WriteString('Constante', 'Unit', UniteConstante);
         WriteString('Constante', 'Signif', signifConstante);
         WriteString('ConstTxt', 'Nom', nomConstTxt);
         WriteString('ConstTxt', 'Signif', signifConstTxt);
         WriteString('Regressi', 'Comm', Commentaire);
         WriteBool('Affichage', 'Ligne', oTraceLigne);
         WriteBool('Affichage', 'Points', oTracePoints);
         WriteFloat('Balayage', 'Dure', BaseDeTemps.DureeBalayage);
         WriteInteger('Balayage', 'Nombre', NbreInter);
         writeDateTime('Balayage', 'DebutAcq', debutAcquisition);
         WriteBool('Synchro', 'Monocoup', monocoup);
         WriteBool('Synchro', 'Montant', gti2.montant);
         WriteBool('Affichage', 'AxeY', avecUnAxe);
         WriteBool('Affichage', 'Grille', quadrillage);
         WriteBool('Affichage', 'AnalLog', AnalyseurLogique);
         WriteInteger('Affichage', 'DimPoint', dimPoint);
         WriteFloat('Synchro', 'Seuil', gti2.seuilVolt);
         WriteInteger('Synchro', 'Mode', gti2.voieSynchro);
         for voie := voieGts2Min to VoieGts2Max do
             voieOrphy[voie].store('V' + IntToStr(voie), fichier);
      end;
      Fichier.UpdateFile;
      Fichier.Free;
   except
   end;
end;// SauveConfig

procedure TgtsMainForm.LanceAcqTemps;
begin
   etatAvail := eaNone;
   timer.Enabled := False;
   etatAcq := eaAttenteResul;
   GrapheGts.NbreCourant := 0;
   Gauge.position := 0;
   debutAcquisition := now;
   DureeResulMax := grapheGTS.NbreInter * grapheGTS.NbreVoie * 2  +
      BaseDeTemps.dureeBalayage + 2;
   SynchroDetecte := False;
   Header.Panels[0].Text := NomEtatAcq(eaAttenteResul);
   EnregistreBtn.Visible := False;
   stopBtn.Visible := True;
   timer.Enabled := True;
   Header.Panels[1].Text := '';
end; // LanceAcqTemps

procedure TgtsMainForm.LitPointAttente;
   var
      voie: indiceVoieGTS2;
      mesure: integer;
   begin
      timer.Enabled := False;
      for voie := voiegts2Min to voieGTs2Max do
         with grapheGts.voieOrphy[voie] do
         begin
            if active then
            begin // sinon fait par Wreco
               mesure := getInt('WEA ' + codeVoie);
               valeurCourante := valeurReal(mesure);
               if etatAcq = eaAttenteResul then
                  break;
            end;
         end;
      //   Application.ProcessMessages; // ??
      if etatAcq <> eaAttenteResul then
      begin
         effacePointCourant;
         for voie := voieGTS2Min to voieGTS2Max do
            with grapheGts.voieOrphy[voie] do
               valeurAff := valeurCourante;
         marquePointCourant;
      end;
   timer.Enabled := True;
end; {litPointAttente}

procedure TgtsMainForm.AjusteDeltat(modif: tModifBaseDeTemps);
var
   deltatMin: double;
   voie: indiceVoieGTS2;
begin
   with grapheGTS, baseDeTemps do
   begin
      NbreVoie := 0;
      for voie := voieGTs2Min to voieGTS2Max do
         if voieOrphy[voie].active then
            Inc(NbreVoie);
      if DureeBalayage > 3600 then
         NbreInter := trunc(DureeBalayage / Deltat)
      else
      begin
         Deltat := DureeBalayage / NbreInter;
         if Deltat > deltatMax then
            deltat := DeltatMax;
         DeltatMin := deltatOrphy * NbreVoie;
         if deltat < deltatMin then
            deltat := deltatMin;
         deltat := deltatOrphy * round(deltat / deltatOrphy);
         case modif of
            mDuree, mNbreVoies: NbreInter := trunc(DureeBalayage / deltat);
            mNombre: DureeBalayage := NbreInter * deltat;
            mDeltat: ;
         end;
      end;
   end;
end;

procedure TGTSmainForm.FormCreate(Sender: TObject);

   procedure ValeurDefaut;
   var
      FichierIni: TRegIniFile;
      winVersion: shortString;
      carac: char;
      numVersion: integer;
   begin
      Application.HelpFile := ChangeFileExt(Application.ExeName,'.HLP');
      isXP := False;
      winVersion := winInfo.winVerNo;
      if length(winVersion) >= 3 then
      begin
         carac := winVersion[1];
         if carac in ['0'..'9'] then
            numVersion := 10 * (Ord(carac) - Ord('0'))
         else
            numVersion := 0;
         carac := winVersion[3];
         if carac in ['0'..'9'] then
            numVersion := numVersion + Ord(carac) - Ord('0');
         isXP := numVersion >= 51;
      end;
      debutAcquisition := now;
      ReactiverGTS := False;
      grapheGTS.NbreInter := 128;
      BaseDeTemps.DureeBalayage := 1.0;
      BaseDeTemps.Deltat := BaseDeTemps.DureeBalayage / GrapheGTS.NbreInter;
      nomConstante := '';
      uniteConstante := '';
      commentaire := '';
      PremiereFois := True;
      orphyPresent := False;
      etatAcq := eaTerminee;
      try
         FichierIni := TRegIniFile.Create(RegistreGTS);
         sauverConfig := FichierIni.readBool('Acquisition', 'Defaut', False);
         FichierIni.Free;
      except
      end;
   end;

var
   i: integer;
   voie: indiceVoieGts2;
begin
   Application.OnHint := ShowHint;
   Application.OnActivate := ActivateApp;
   grapheGts := TgrapheGts.Create;
   grapheGts.canvas := oscillo.canvas;
   oscillo.canvas.font.Name := 'Regressi';
   if gti2permis then
      GTI2 := Tgti2.Create;
   ValeurDefaut;
   with PanelVoies do
      for i := 0 to pred(controlCount) do
      begin
         voie := TGroupBox(Controls[i]).tag;
         with grapheGTS.voieOrphy[voie] do
         begin
            GBvoie := TgroupBox(Controls[i]);
            LabelVoie := Tlabel(TgroupBox(Controls[i]).Controls[0]);
            if not isXP then
            begin
               LabelVoie.Font.color := clWhite;
               GBVoie.Font.color := clWhite;
            end;
         end;
      end;
   i := Height - clientHeight;{ 27=normal ; 30=grande police }
   if i < 28 then
      font.Size := 8
   else
      font.Size := 10;
end;

procedure TGTSmainForm.ShowHint(Sender: TObject);
begin
   if Application.Hint = '' then
      Caption := trAcqGTI2
   else
      Caption := Application.Hint;
end;

procedure TGTSmainForm.SpinButton1DownClick(Sender: TObject);
begin
    deltaSeuil(-1)
end;




procedure TGTSmainForm.SpinButton1UpClick(Sender: TObject);
begin
    deltaSeuil(-1)
end;

procedure TGTSmainForm.FileOpen(Sender: TObject);
begin
   DebutLectureParametres;
   OpenDialog.filter := trFiltreGTS;
   if OpenDialog.Execute then
   begin
      LitConfig(OpenDialog.FileName);
      afficheReglage;
   end
   else
      finLectureParametres;
end;

procedure TGTSmainForm.FileSaveAs(Sender: TObject);
begin
   saveDialog.defaultExt := 'gt12';
   saveDialog.filter := trFiltreGTS;
   sauveTimer := timer.Enabled;
   timer.Enabled := False;
   if SaveDialog.Execute then
      EcritConfig(SaveDialog.FileName);
   timer.Enabled := sauveTimer;
end;

procedure TGTSmainForm.FileExit(Sender: TObject);
begin
   Close;
end;

procedure TGTSmainForm.HelpAbout(Sender: TObject);
begin
   DebutLectureParametres;
   AboutBox := TAboutBox.Create(self);
   AboutBox.ShowModal;
   AboutBox.Free;
   FinLectureParametres;
end;

procedure TGTSmainForm.ecritOrphy(ordre: shortString);
begin
   if OrphyPresent then
      GTI2.output := ordre
end;

procedure TGTSmainForm.DebutLectureParametres;
begin
   sauveTimer := Timer.Enabled;
   Timer.Enabled := False;
   etatAvail  := eaNone;
   if (etatAcq = eaAttenteResul) and (OrphyPresent) then
   begin
//      gti2.stopAcq;
      etatAcq := eaTerminee;
   end;
end;

procedure TGTSmainForm.FinLectureParametres;
begin
   Timer.Enabled := sauveTimer;
   oscillo.refresh;
   if resetBtn.Visible then
      resetBtnClick(nil)
   else
      initAttente;
end;

procedure tGTSmainForm.MarquePointCourant;
var
   voie: indiceVoieGTS2;
begin
   with grapheGts do
   begin
      canvas := oscillo.canvas;
      for voie := voieGts2Min to VoieGTS2Max do
         with voieOrphy[voie] do
            if active then
               LabelVoie.Caption := AffVoltmetre;
      if ReticuleTrace then
         exit;
      with oscillo.canvas.pen do
      begin
         mode  := pmNotXor;
         Width := 3;
         style := psSolid;
      end;
      for voie := voieGTs2Min to VoieGts2Max do
         with voieOrphy[voie] do
            if active then
               traceReticule(voie);
      with oscillo.canvas.pen do
      begin
         mode  := pmCopy;
         Width := 1;
      end;
      ReticuleTrace := True;
   end;
end;

procedure tGTSmainForm.EffacePointCourant;
var voie: indiceVoieGTS2;
begin
   with grapheGts do
   begin
      if not ReticuleTrace then
         exit;
      with oscillo.canvas.pen do
      begin
         mode  := pmNotXor;
         Width := 3;
         style := psSolid;
      end;
      for voie := voieGts2Min to VoieGts2Max do
         with voieOrphy[voie] do
            if active then
               traceReticule(voie);
      with oscillo.canvas.pen do
      begin
         mode  := pmCopy;
         Width := 1;
      end;
      ReticuleTrace := False;
   end;
end;

procedure tGTSmainForm.AfficheReglage;

procedure AfficheSynchro;
var
   i: integer;
   voie: indiceVoieGts2;
begin
   with grapheGts do
   begin
      with BaseDeTemps do
         for i := 0 to MaxVecteur do
            vecteurAff[i] := mini + deltat * i; { seconde }
      gti2.voieSynchro := synchroRG.ItemIndex;
      if gti2.voieSynchro=0 then begin
            Monocoup := True;
            sensSynchroRG.Visible := False;
            seuilGB.Visible := False;
         end
         else begin
            gti2.montant  := boolean(sensSynchroRG.ItemIndex);
            monocoup := MonocoupCB.Checked;
            sensSynchroRG.Visible := True;
            seuilGB.Visible := True;
            for voie := voieGts2Min to VoieGts2Max do
               grapheGts.voieOrphy[voie].LabelVoie.Caption := '';
         end;
      monocoupCB.Visible := (gti2.voieSynchro<>0);
   end;
end; // afficheSynchro

   procedure AfficheVoieX;
   begin
      with grapheGts do
      begin
         MonocoupCB.Checked := Monocoup;
         if not oTraceLigne and not oTracePoints then
            oTracePoints := True;
         NbreInter := NbreInter; { force les vrifications }
         DureeEdit.Text := chaineDuree(BaseDeTemps.DureeBalayage);
         NbreEdit.Text := IntToStr(NbreInter);
         DeltatEdit.Text := chaineDuree(BaseDeTemps.deltat);
         Gauge.position := 0;
         Gauge.Max := NbreInter;
         DeltatEdit.Enabled := True;
         NbreEdit.Enabled := True;
      end;
   end; // afficheVoieX

   procedure AfficheStatus;
   var
      voie: indiceVoieGts2;
   begin
      for voie := voieGts2Min to VoieGts2Max do
         with grapheGTS.voieOrphy[voie] do begin
            GBvoie.Caption := nom + '(' + nomVoieOrphy + ')' + calibreVoie;
            GBvoie.hint := trHintClicParam;
            LabelVoie.hint := GBvoie.hint;
            LabelVoie.Caption := '';
         end;
      SetSizeVoie;
   end; // afficheStatus

var
   voie: indiceVoieGts2;
begin
   initialisation := true;
   with grapheGTS do
   begin // afficheReglage
      NbreVoie := 0;
      for voie := voieGts2Min to voieGts2Max do
         if voieOrphy[voie].active then
            Inc(NbreVoie);
      if NbreVoie = 0 then
      begin
         voieOrphy[voieGts2Min].active := True;
         Inc(NbreVoie);
      end;
      AfficheVoieX;
      AfficheStatus;
      AfficheSynchro;
      if (BaseDeTemps.DureeBalayage > 20) and not (monocoup) then
      begin
         afficheErreur(erMonocoup);
         monocoup := True;
         monocoupCB.Checked := True;
      end;
      if resetBtn.Visible then
         resetBtnClick(nil)
      else
      begin
         PremiereAcquisition := True;
         initAttente;
      end;
   end;
   initialisation := false;
end;{afficheReglage}

procedure tGTSmainForm.InitAttente;
begin
   with grapheGTS do
   begin
      PremierPassage := True;
      etatAvail := eaNone;
      if gti2.voieSynchro=0 then begin
            Header.Panels[0].Text := hSynchroClavier;
            etatAcq := eaAttenteSynchro;
         end
         else begin
            litPointAttente; { affiche les valeurs avant la demande de synchro }
            lanceAcqTemps;
         end;
      timer.Enabled := orphyPresent;
      setBoutons;
      DureeSpin.Enabled := True;
      Header.Panels[1].Text := '';
      oscillo.refresh;
   end;
end; {initAttente}

procedure TGTSmainForm.SynchroRGClick(Sender: TObject);
var newSynchro : integer;
begin
    if initialisation then exit;
    newSynchro := synchroRG.itemIndex;
    if (newSynchro>0) and not gti2.active[newSynchro-1]
        then synchroRG.itemIndex := gti2.voieSynchro
              // Synchro sur voie non active interdit
        else if gti2.voieSynchro<>synchroRG.itemIndex then afficheReglage;
//    edit1.setFocus;
end;

procedure TGTSmainForm.FormActivate(Sender: TObject);
var
   Ini: tRegIniFile;
   h: integer;
begin
   if premiereFois then
   begin
      premiereFois := False;
      h := Height - clientHeight;{ 27=normal ; 30=grande police }
      if h < 28 then
         PanelMode.font.Size := 8
      else
      PanelMode.font.Size := 10;
      try
         Ini  := TregIniFile.Create(RegistreGTS);
         WindowState := TwindowState(Ini.ReadInteger('Window', 'State', Ord(wsNormal)));
         Height := Ini.ReadInteger('Window', 'Height', Height);
         Width := Ini.ReadInteger('Window', 'Width', Width);
         Top  := Ini.ReadInteger('Window', 'Top', top);
         Left := Ini.ReadInteger('Window', 'Left', left);
         Ini.Free;
      except
      end;
      LitConfig(MesDocsDir+'gti2_16.gt16');
   end;{premierefois}
   if not OrphyPresent then TestOrphy;
end;

procedure TGTSmainForm.DesactiveBtn;
begin
   ResetBtn.Visible := False;
   EnregistreBtn.Visible := False;
   StopBtn.Visible  := False;
   RegSaveBtn.Visible := False;
   ClipSaveBtn.Visible := False;
end;

procedure TGTSmainForm.TestOrphy;

   procedure testGTI2;
   var
      posOrphy: integer;
   begin
      if not GTI2.Open then
         exit;
      chaineLue := GTI2.Version;
      posOrphy := pos('GTI2', chaineLue);
      orphyPresent := posOrphy <> 0;
      if not orphyPresent then
         GTI2.Close;
   end; // testGTI2

   procedure setGTI2Present;
   var
      posVersion: integer;
      NumeroVersionTxt: shortString;
   begin
      OrphyPresent := True;
      screen.cursor := crHourGlass;
      OrphyAbsent.Visible := False;
      versionOrphy := chaineLue;
      posVersion := pos('V', chaineLue);
      NumeroVersionTxt := Copy(chaineLue, posVersion + 1, 4);
      NumeroVersion := round(100 * strToFloatWin(NumeroVersionTxt));
      ecritOrphy('WRESET');
      Header.Panels[0].Text := trYesOrphyGTI2;
   end;// setGTI2Present

begin { testOrphy }
   screen.cursor := crHourGlass;
   Header.Panels[0].Text := trVerifGTS;
   if gti2permis then testGTI2;
   if OrphyPresent then begin
      setGTI2present;
      ecritOrphy('WBIN');
      afficheReglage;
   end
   else
   begin
      if gti2permis then
         Header.Panels[0].Text := trNotOrphy;
      DesactiveBtn;
      OrphyAbsent.Visible := True;
      OrphyAbsent.SetFocus;
   end;
   screen.cursor := crDefault;
end; { testOrphy }

procedure TGTSmainForm.TimerTimer(Sender: TObject);

   procedure TimerTemps;
   var
      Rafraichir: boolean;
      voie: indiceVoieGts2;
      dureeResul: double;
      i: integer;
   begin
      with GrapheGTS do
      begin
         if NbreCourant > 0 then
         begin
            if PremiereAcquisition then
            begin
               Rafraichir := (NbreAff = 0) or (NbreAff > NbreCourant);
               CourantVersAff;
               if rafraichir then
               begin
                  if gti2.VoieSynchro>0 then begin
                        debutAcquisition := now;
                        synchroDetecte := True;
                     end;
                  Oscillo.refresh;
               end
               else
                  traceCourbes;
            end
            else if not SynchroDetecte and
               (gti2.VoieSynchro>0) and
               (NbreCourant > 0) then
            begin
               debutAcquisition := now;
               synchroDetecte := True;
            end;
            if ((gti2.voieSynchro=0) or SynchroDetecte) and
               not monocoup then
            begin
               dureeResul := (now - debutAcquisition) * 24 * 3600;
               if dureeResul > dureeResulMax then
               begin
                  for i := succ(NbreCourant) to pred(NbreInter) do
                     for voie := voieGts2Min to voieGts2Max do
                        voieOrphy[voie].vecteurCourant[i] := 0;
                  NbreCourant := NbreInter;
                  etatAcq := eaMajResul;
                  etatAvail := eaNone;
               end;
            end;
            if (BaseDeTemps.deltat > deltatLent) and (NbreAff > 0) then
            begin
               effacePointCourant;
               for voie := voieGts2Min to voieGts2Max do
                  with voieOrphy[voie] do
                     valeurAff := vecteurAff[pred(NbreAff)];
               marquePointCourant;
            end
            else
               for voie := voieGts2Min to VoieGts2Max do
                  with voieOrphy[voie] do
                     if active then
                        LabelVoie.Caption := AffVoltmetre;
            Gauge.position := NbreCourant;
         end;
      end;
   end; // TimerTemps

   procedure MajResulTemps;
   var
      voie: indiceVoieGts2;
   begin
      with grapheGTS do
      begin
         timer.Enabled := False;
         EtatAcq := eaTerminee;
         CourantVersAff;
         Gauge.Position := pred(NbreInter);
         Header.Panels[0].Text := NomEtatAcq(eaTerminee);
         Oscillo.refresh;
         if NbreAff > 0 then
            for voie := voieGts2Min to VoieGts2Max do
               with grapheGts.voieOrphy[voie] do
                  if active then
                  begin
                     valeurAff := vecteurAff[pred(NbreAff)];
                     LabelVoie.Caption := AffVoltmetre;
                  end;
         if gti2.voieSynchro=0 then
            EtatAcq := eaAttenteSynchro
         else if not Monocoup then
         begin
            PremiereAcquisition := False;
            LanceAcqTemps;
         end;
         setBoutons;
      end;
   end;  // MajResulTemps

begin
   with grapheGTS do
   begin
      case etatAcq of
         eaAttenteSynchro: if gti2.voieSynchro=0 then
               LitPointAttente;
         eaAttenteResul: TimerTemps;
         eaMajResul: MajResulTemps;
         eaTerminee: ;
      end;
   end;
end;

procedure TGTSmainForm.AllBtnClick(Sender: TObject);
begin
   if ToutesVoiesDlg.showModal=mrOK then afficheReglage
end;

procedure TGTSmainForm.EnregistreBtnClick(Sender: TObject);
begin
    LanceAcqTemps // synchro clavier
end;

procedure TGTSmainForm.SensSynchroRGClick(Sender: TObject);
begin
    if gti2.montant<>(sensSynchroRG.itemIndex=1) and
       not initialisation then afficheReglage;
end;

procedure TGTSmainForm.SetBoutons;
begin
   with grapheGTS do
   begin
      ResetBtn.Visible := NbreAff > 0;
      EnregistreBtn.Visible := True;
      StopBtn.Visible := False;
      ResetBtn.Visible := Monocoup and (etatAcq = eaTerminee) and (NbreAff > 0);
      EnregistreBtn.Visible :=
         (gti2.voieSynchro=0) and (etatAcq = eaAttenteSynchro);
      Timer.Enabled := orphyPresent and
         (EnregistreBtn.Visible or (etatAcq = eaAttenteResul));
      EnregistreBtn.hint := hStart;
      StopBtn.Visible := etatAcq = eaAttenteResul;
      if etatAcq = eaAttenteSynchro then
         if gti2.voieSynchro=0
            then Header.Panels[0].Text := hSynchroClavier
            else Header.Panels[0].Text := NomEtatAcq(etatAcq)
         else Header.Panels[0].Text := NomEtatAcq(etatAcq);
      RegSaveBtn.Visible := NbreAff >= MinPointsTemps;
      ClipSaveBtn.Visible := RegSaveBtn.Visible;
   end;
end; // setBoutons

procedure TGTSmainForm.OscilloPaint(Sender: TObject);
var
   voie: indiceVoieGts2;
begin
   if OrphyAbsent.Visible then
      exit;
   with grapheGts do
   begin
      canvas := oscillo.canvas;
      limiteFenetre := rect(0, 0, oscillo.Width, oscillo.Height);
      oscillo.Canvas.brush.Color := clWindow;
      oscillo.Canvas.FillRect(limiteFenetre);
      draw;
      with voieTemps do
         valeurAff := mini;
      for voie := voieGts2Min to VoieGTs2Max do
         with voieOrphy[voie] do
            if (valeurCourante <> sansSignif) and
               (valeurCourante < maxi) and (valeurCourante > mini)
            then
               valeurAff := valeurCourante
            else
               valeurAff := (mini + maxi) / 2;
   end;
end;

procedure TGTSmainForm.NombreDownClick(Sender: TObject);
begin
   GrapheGTS.NbreInter := grapheGTS.NbreInter div 2;
   SetNombre;
end;

procedure TGTSmainForm.NombreUpClick(Sender: TObject);
begin
   GrapheGTS.NbreInter := 2 * GrapheGTS.NbreInter;
   SetNombre;
end;

procedure TGTSmainForm.DureeSpinUpClick(Sender: TObject);
begin
   DebutLectureParametres;
   BaseDeTemps.DureeBalayage := duree125(2.15 * BaseDeTemps.DureeBalayage);
   SetDuree(mduree);
end;

procedure TGTSmainForm.DureeSpinDownClick(Sender: TObject);
begin
   DebutLectureParametres;
   BaseDeTemps.DureeBalayage := duree125(BaseDeTemps.DureeBalayage / 2.15);
   SetDuree(mduree);
end;

procedure TGTSmainForm.SetNombre;
begin
   DebutLectureParametres;
   BaseDeTemps.deltat := BaseDeTemps.dureeBalayage / GrapheGTS.NbreInter;
   AjusteDeltat(mNombre);
   MajTemps;
end;

procedure TGTSmainForm.MajTemps;
var
   i: integer;
begin
   with BaseDeTemps do
   begin
      deltatEdit.Text := chaineDuree(deltat);
      NbreAffNul;(**)
      NbreEdit.Text  := IntToStr(GrapheGTS.NbreInter);
      DureeEdit.Text := chaineDuree(DureeBalayage);
      for i := 0 to MaxVecteur do
         vecteurAff[i] := mini + deltat * i;
      Gauge.position := 0;
      Gauge.Max := GrapheGTS.NbreInter;
      PremiereAcquisition := True;
      initAttente;
   end;
end;// MajTemps

procedure TGTSmainForm.SetDuree;
begin
   AjusteDeltat(modif);
   GrapheGTS.NbreInter := round(BaseDeTemps.DureeBalayage / BaseDeTemps.deltat);
   BaseDeTemps.Deltat  := BaseDeTemps.DureeBalayage / GrapheGTS.NbreInter;
   MajTemps;
end;

procedure TGTSmainForm.VoieAnaClick(Sender: TObject);
var
   v: indiceVoieGts2;
begin
   v := (Sender as TComponent).tag;
   DebutLectureParametres;
   OrphyGtsDlg.voieCourante := grapheGTS.voieOrphy[v];
   OrphyGtsDlg.ShowModal;
   if OrphyGtsDlg.modif then
   begin
      NbreAffNul;
      AjusteDeltat(mNbreVoies); // variation du nombre de voies
      afficheReglage;
   end
   else
   begin
      finLectureParametres;
      setSizeVoie;
   end;
end;


procedure TGTSmainForm.FormClose(Sender: TObject; var Action: TCloseAction);

   procedure WriteFormPlacement;
   var
      ini: TregIniFile;
   begin
      try
         Ini := TregIniFile.Create(RegistreGTS);
         Ini.WriteInteger('Window', 'State', Ord(WindowState));
         Ini.WriteInteger('Window', 'Height', Height);
         Ini.WriteInteger('Window', 'Width', Width);
         Ini.WriteInteger('Window', 'Top', top);
         Ini.WriteInteger('Window', 'Left', left);
         Ini.Free;
      except
      end;
   end;

   procedure sauveExtension;
   var
      regist: Tregistry;
   begin
      try
         Regist := TRegistry.Create;
         Regist.RootKey := HKey_Classes_Root;
         if Regist.OpenKey('\.gt16', True) then
         begin
            Regist.WriteString('', 'gt16File');
            Regist.WriteString('Content Type', 'application\gt16');
         end;
         if Regist.OpenKey('\gt16File', True) then
         begin
            Regist.WriteString('', 'Fichier config. GTI2_16');
            Regist.WriteString('IsShortcut', '');
            if Regist.OpenKey('\Gt16File\shell', True) then
               Regist.WriteString('', 'open');
            if Regist.OpenKey('\Gt16File\shell\open\command', True) then
               Regist.WriteString('', '"' + application.exename + '" "%1"');
            if Regist.OpenKey('\Gt16File\shell\open\ddeExec', True) then
               Regist.WriteString('', 'FILE|LOAD(%1)');
            if Regist.OpenKey('\Gt16File\shell\open\ddeExec\topic', True) then
               Regist.WriteString('', 'ServeurDDE');
            if Regist.OpenKey('\Gt16File\shell\open\ddeExec\application', True) then
               Regist.WriteString('', 'GTS12');
         end;
         regist.Free;
      except
      end;
   end;

   procedure SauveConfigLoc;
   var
      FichierIni: TRegIniFile;
   begin
      try
         FichierIni := TRegIniFile.Create(RegistreGTS);
         FichierIni.writeBool('Acquisition', 'Defaut', sauverConfig);
         FichierIni.Free;
      except
      end;
      if sauverConfig then
         EcritConfig(MesDocsDir+'gti2_16.gt16');
   end;

begin
   if not OrphyAbsent.Visible then
   begin
      debutLectureParametres;
      if StopBtn.Visible then StopBtnClick(nil);
      Timer.Enabled := False;
   end;
   SauveExtension;
   SauveConfigLoc;
   WriteFormPlacement;
end;

procedure TGTSmainForm.RegSaveBtnClick(Sender: TObject);
begin
      DebutLectureParametres;
      if ConstanteDlg.showModal = mrOk then
      begin
         FormDDE.EnvoieDonnees(True, '');
         MonocoupCB.Checked := True;
         ReactiverGTS := True;
      end
      else
         finLectureParametres;
end;

procedure TGTSmainForm.ClipSaveBtnClick(Sender: TObject);
begin
   FormDDE.EnvoieDonnees(False, '');
end;

procedure TGTSmainForm.FileSaveBtnClick(Sender: TObject);
begin
   DebutLectureParametres;
   saveDialog.defaultExt := 'txt';
   saveDialog.filter := TrFormatTableur + ' |*.txt';
   if saveDialog.Execute then
      FormDDE.EnvoieDonnees(False, saveDialog.FileName);
   finLectureParametres;
end;

procedure TGTSmainForm.StopBtnClick(Sender: TObject);
begin
   with GrapheGts do
   begin
      if Sender <> nil then
      begin
         MonocoupCB.Checked := True;
         Monocoup := True;
      end;
      if (baseDeTemps.DureeBalayage > 0.1) or (gti2.voieSynchro>0) or
         not premiereAcquisition then
      begin
         debutLectureParametres;
         etatAcq := eaTerminee;
         SetBoutons;
      end;
      ResetBtn.Visible  := NbreAff > 0;
      DureeSpin.Enabled := True;
   end;
end;

procedure TGTSmainForm.ResetBtnClick(Sender: TObject);
begin
   if (Sender = nil) or OKreg(trDelAcq) then
   begin
      if Sender <> nil then
         NbreAffNul;
      oscillo.refresh;
      if monocoupCB.Checked and not grapheGTS.monocoup then
         monocoupCB.Checked := False;
      initAttente;
   end;
end;

procedure TGTSmainForm.HelpBtnClick(Sender: TObject);
begin
   application.HelpFile := ChangeFileExt(Application.ExeName, '.HLP');
   application.HelpShowTableOfContents;
end;

procedure TGTSmainForm.CapteursItemClick(Sender: TObject);
begin
   DebutLectureParametres;
   ChoixCapteursDlg := TChoixCapteursDlg.Create(self);
   ChoixCapteursDlg.showModal;
   ChoixCapteursDlg.Free;
   finLectureParametres;
end;

procedure TGTSmainForm.ComBtnClick(Sender: TObject);
begin
   testOrphy;
end;

procedure TGTSmainForm.EscapeBtnClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TGTSmainForm.DeltatSpinDownClick(Sender: TObject);
begin
   DebutLectureParametres;
   BaseDeTemps.deltat := duree125(BaseDeTemps.deltat / 2.15);
   SetDeltat;
end;

procedure TGTSmainForm.SetDeltat;
begin
   GrapheGTS.NbreInter := round(BaseDeTemps.DureeBalayage / BaseDeTemps.deltat);
   SetDuree(mdeltat);
end;

procedure TGTSmainForm.DeltatSpinUpClick(Sender: TObject);
begin
   DebutLectureParametres;
   BaseDeTemps.deltat := duree125(2.15 * BaseDeTemps.deltat);
   SetDeltat;
end;

procedure TGTSmainForm.ActivateApp(Sender: TObject);
begin
   if ReactiverGTS then
      with grapheGts do
      begin
         ReactiverGTS  := False;
         Timer.Enabled := orphyPresent and sauveTimer;
         resetBtn.Visible := True;
      end;
end;

procedure TGTSmainForm.WMSetFocus(var Msg: Tmessage);
begin
   activateApp(nil);
   Msg.Result := 0;
end;

procedure TGTSmainForm.DureeEditKeyPress(Sender: TObject; var Key: char);
begin
   case key of
      crCR:
      begin
         try
            BaseDeTemps.DureeBalayage := dateTimeToFloat(dureeEdit.Text);
            setDuree(mDuree);
         except
            DureeEdit.Text := chaineDuree(BaseDeTemps.DureeBalayage);
         end;
      end;
      '.', ',': key := decimalSeparator;
      '0'..'9', 'm', '', 's', 'i', 'n': ;
      crDroite, crGauche, crSuppr, crSupprArr: ;
      else
         key := #0
   end;
end;

procedure TGTSmainForm.NbreEditKeyPress(Sender: TObject; var Key: char);
begin
   case key of
      crCR:
      begin
         try
            GrapheGTS.NbreInter := StrToInt(NbreEdit.Text);
            setNombre;
         except
         end;
      end;
      '0'..'9': ;
      crDroite, crGauche, crSuppr, crSupprArr: ;
      else
         key := #0;
   end;
end;

procedure TGTSmainForm.DeltatEditKeyPress(Sender: TObject; var Key: char);
begin
   case key of
      crCR:
      begin
         try
            BaseDeTemps.Deltat := DateTimeToFloat(deltatEdit.Text);
            setDeltat;
         except
            DeltatEdit.Text := chaineDuree(BaseDeTemps.deltat);
         end;
      end;
      ',', '.': key := decimalSeparator;
      '0'..'9', '-', '+', 'E', 'm', '', 's', 'i', 'n': ;
      crDroite, crGauche, crSuppr, crSupprArr: ;
      else
         key := #0
   end;
end;

procedure TGTSmainForm.DureeEditExit(Sender: TObject);
var
   newMaxi: double;
begin
   try
      newMaxi := dateTimeToFloat(dureeEdit.Text);
      if newMaxi <> BaseDeTemps.DureeBalayage then
      begin
         BaseDeTemps.DureeBalayage := newMaxi;
         setDuree(mDuree);
      end;
   except
      DureeEdit.Text := chaineDuree(BaseDeTemps.DureeBalayage);
   end;
end;

procedure TGTSmainForm.NbreEditExit(Sender: TObject);
var
   newNbre: integer;
begin
   try
      newNbre := StrToInt(NbreEdit.Text);
      if NewNbre <> GrapheGTS.NbreInter then
      begin
         GrapheGTS.NbreInter := NewNbre;
         setNombre;
      end;
   except
      NbreEdit.Text := IntToStr(GrapheGTS.NbreInter);
   end;
end;

procedure TGTSmainForm.DeltatEditExit(Sender: TObject);
var
   newDeltat: double;
begin
   try
      NewDeltat := DateTimeToFloat(deltatEdit.Text);
      if newDeltat <> BaseDeTemps.Deltat then
      begin
         BaseDeTemps.Deltat := NewDeltat;
         setDeltat;
      end;
   except
      DeltatEdit.Text := chaineDuree(BaseDeTemps.deltat);
   end;
end;

procedure TGTSmainForm.MajEtatEcran;
begin
   Oscillo.Align := alClient;
   PanelVoies.Align := alRight;
   PanelMode.Align := alRight;
   PanelVoies.Width := 150;
   PanelMode.Width := 150;
   setSizeVoie;
   refresh;
end;

procedure TGTSmainForm.FormResize(Sender: TObject);
begin
   Header.Panels[0].Width := ClientWidth div 2;
   SetSizeVoie;
end;

procedure TGTSmainForm.OptionsItemClick(Sender: TObject);
begin
   DebutLectureParametres;
   if OptionsDlg = nil then
      Application.CreateForm(TOptionsDlg, OptionsDlg);
   OptionsDlg.showModal;
   finLectureParametres;
end;

procedure TGTSmainForm.SetSizeVoie;
var
   voie:  indiceVoieGts2;
   Fsize: integer;
begin
   if Height > 600 then
      Fsize := 14
   else if Height > 480 then
      Fsize := 12
   else
      Fsize := 10;
   with grapheGTS do
      for voie := voieGts2Min to voieGTs2Max do
         with voieOrphy[voie] do
            if active then
            begin
               if isXP then
               begin
                  GBvoie.color := clWhite;
                  LabelVoie.font.color := couleur;
                  GBvoie.font.color := couleur;
               end
               else
                  GBvoie.color := couleur;
               GBvoie.Height := 4 * Fsize;
               Gbvoie.font.size := Fsize;
               Gbvoie.font.Name := 'Regressi';
               LabelVoie.font.Name := 'Courier';
               LabelVoie.font.size := Fsize + 2;
               LabelVoie.top := 3 * Fsize div 2;
               LabelVoie.Caption := '';
               GBvoie.Caption := nom + '(' + nomVoieOrphy + ')' + calibreVoie;
            end
            else
            begin
               GBvoie.color  := clBtnFace;
               GBvoie.Height := 2 * Fsize;
               GBvoie.font.size := Fsize - 2;
               GBvoie.Caption := nom + '(' + nomVoieOrphy + ')';
            end;
end;

procedure TGTSmainForm.SeuilEditExit(Sender: TObject);
var newSeuil : double;
begin
    try
       newSeuil := strToFloatWin(Seuiledit.text);
       gti2.seuilVolt := newSeuil;
//       grapheGTS.seuilSynchro := gti2.seuilVolt;
    except
    end;
    if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
end;

procedure TGTSmainForm.FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
   if key = vk_space then
      if EnregistreBtn.Visible then
      begin
         if gti2.voieSynchro=0 then
            enregistreBtnClick(Sender);
         key := 0;
      end
      else if ResetBtn.Visible then
         resetBtnClick(Sender)
      else if StopBtn.Visible then
         stopBtnClick(Sender);
end;

procedure TGTSmainForm.VoltmetreItemClick(Sender: TObject);
begin
   majEtatEcran;
end;

function WordPosition(const N: integer; const S: shortString;
   const WordDelims: TCharSet): integer;
var
   Count, I: integer;
begin
   Count := 0;
   I := 1;
   Result := 0;
   while (I <= Length(S)) and (Count <> N) do
   begin
      { skip over delimiters }
      while (I <= Length(S)) and (S[I] in WordDelims) do
         Inc(I);
      { if we're not beyond end of S, we're at the start of a word }
      if I <= Length(S) then
         Inc(Count);
      { if not finished, find the end of the current word }
      if Count <> N then
         while (I <= Length(S)) and not (S[I] in WordDelims) do
            Inc(I)
      else
         Result := I;
   end;
end;


procedure TGTSmainForm.MonocoupCBClick(Sender: TObject);
begin
   grapheGTS.Monocoup := MonocoupCB.Checked;
   if not grapheGTS.monocoup then
   begin
      PremiereAcquisition := True;
      initAttente;
   end;
end;

procedure TGTSmainForm.NbreAffNul;
begin
   grapheGts.NbreAff  := 0;
   RegSaveBtn.Visible := False;
   ClipSaveBtn.Visible := False;
   PremiereAcquisition := True;
end;

procedure TGTSmainForm.VideOutBuffer;
begin
end;

procedure TGTSmainForm.ResetOrphyClick(Sender: TObject);
begin
   Timer.Enabled := False;
   ecritOrphy('WPE');
   ecritOrphy('WRESET');
   delayTicks(5, False);
   TestOrphy;
end;

procedure TGTSmainForm.RazSeuilBtnClick(Sender: TObject);
begin
     SeuilEdit.Text := '0';
     gti2.seuilVolt := 0;
//     grapheGTS.seuilSynchro := 0;
     oscillo.refresh;
//  if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
end;

procedure TGTSmainForm.MenuPopup(Sender: TObject);
begin
   FileSaveItem.Visible := grapheGTS.NbreAff >= MinPointsTemps;
   ClipSaveBtn.Visible  := FileSaveItem.Visible;
end;

procedure TGTSmainForm.FormDestroy(Sender: TObject);
begin
   gti2.Free;
end;

procedure TGTSmainForm.ConfigActuelleClick(Sender: TObject);
begin
   SauverConfig := False;
   EcritConfig(MesDocsDir+'gti2_16.gt16');
end;

procedure TGTSmainForm.ConfigPages1Click(Sender: TObject);
begin
	ToutesVoiesDlg.showModal;
end;

procedure TGTSMainForm.DeltaSeuil(signe : integer);
begin
    gti2.seuilVolt := gti2.seuilVolt+signe*deltaVSynchro;
//    grapheGTS.seuilSynchro := gti2.seuilVolt;
    seuilEdit.text := FormatSynchro(gti2.seuilVolt);
    Oscillo.refresh;
//    if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
//    edit1.setFocus;
end;

function tGTSmainForm.getWord(commande: shortString): word;
begin
   gti2.GetValeurMot(commande, 5, 2);
   Result := valeurMot.mot;
end;

function TgtsMainForm.getLongWord(commande: shortString): longword;
begin
   gti2.GetValeurMot(commande, 10, 4);
   Result := ValeurMot.LongMot;
end;

function tGTSmainForm.getByte(commande: shortString): byte;
begin
  gti2.GetValeurMot(commande, 5, 1);
   Result := valeurMot.octet;
end;

function tGTSmainForm.getInt(commande: shortString): integer;
begin
   gti2.GetValeurMot(commande, 5, 2);
   Result := valeurMot.entier;
end;

end.

