unit GTSUTIL;

interface

uses
  SysUtils, Windows, Messages, Classes, Dialogs,
  Graphics, Forms, printers, controls, consts,  oomisc, awUser, awWin32,
  Math, Maths, StdCtrls, registry, constgts, inifiles, ShlObj;

const
        WM_Acq_PointAttente = WM_USER + 4;
        DureeMinDeconnect = 10*60;   // dix minutes
        crCR = #13;
        RegistreGTS = 'Software\GT16';
        PrecisionGTS = 5;
        PrecisionTime = 7;
        LongUnite = 20;
        SymbReg : char = '';
        SymbReg2 : char = '&';
        UnJour : double = 24*3600.0;
        UneHeure : double = 3600.0;
        QuartdHeure : double = 15*60.0;
        UneMinute : double = 60.0;
        DureeResul : array[0..3] of single = (0.001,0.0005,0.00025,0.00015);
        PrecisionSynchro = 3; // 12 bits

        alpha = #128;
        beta = #129;
        chi = #130;
        delta = #131;
        deltaMaj = #150;
        epsilon = #132;
        phi = #133; phiMaj = #151;
        gamma = #134; gammaMaj = #152;
        eta = #135;
        plusExp = #184;
        moinsExp = #170;
        lambda = #136; lambdaMaj = #153;
        nu = #138;
        piMin = #139;piMaj = #154;
        theta = #140;thetaMaj = #155;
        rho = #141;
        sigma = #142;sigmaMaj = #156;
        tau = #143;
        omega = #144;omegaMaj = #157;
        xi = #147;xiMaj = #158;
        psi = #148;psiMaj = #159;
        zeta = #149;
        mu = #181;
        vide = #248;videMaj = #216;

       ChiffreExp : array['0'..'9'] of char =
  (#186,#185,#178,#179,#165,#169,#172,#173,#174,#188);

type
    EGetFloatError = class(Exception);
    ChaineAzt = array[0..255] of char;
    TcharSet = set of char;
    strUnite = string[LongUnite];
    CoefUnite = (zero,yocto,zepto,atto,femto,pico,nano,micro,milli,
               nulle,kilo,mega,giga,tera,peta,exa,zetta,yotta,infini);
    pseudoWord = record case byte of
             0 : (octets : array[0..11] of char);
             1 : (mot : word);
             2 : (entier : smallInt);
             3 : (longMot : longWord);
             4 : (octet : byte);
             5 : (indexG,indexH : byte;valeurG,valeurH : word);
             6 : (Entre,Sortie,phase,Freq,Nombre : word);
             7 : (index : array[1..4] of byte;valeur : array[1..4] of smallInt);
    end;

Const
        Digits : array[0..$F] of Char = '0123456789ABCDEF';
        crSupprArr = char(vk_back);
        crSuppr = char(vk_clear);
        crHaut = char(vk_up);
        crBas = char(vk_down);
        crGauche = char(vk_left);
        crDroite = char(vk_right);
        crHome = char(vk_home);
        crEnd = char(vk_end);
        crLF = #10;
        crESC = #27;
        crTab = char(vk_tab);
        Separateur : TCharSet = [' ',crTab,','];
        Majuscule   : TcharSet = ['A'..'Z'];
        Minuscule   : TcharSet = ['a'..'z'];
        Grecque  : TcharSet = [alpha,beta,gamma,gammaMaj,delta,deltaMaj,chi,
              epsilon,phi,phiMaj,eta,psi,psiMaj,lambda,lambdaMaj,mu,nu,
              piMin,piMaj,theta,thetaMaj,rho,sigma,sigmaMaj,tau,omega,omegaMaj,
              xi,xiMaj,zeta];
        CharGetFloat : TcharSet = ['0'..'9','+','-','e','E','.',',',
            'm','','n','f','k','M','G','T',
            '(',')',crSupprArr,crTab,crCR];
        ToutCarac   : TcharSet = [#032..#151,#224..#250];
        Chiffre     : TcharSet = ['0'..'9'];
        ChiffrePuiss : TcharSet = [#186,#185,#178,#179,#165,#169,#172,#173,#174,#188];
        ChiffreEtc : TcharSet = ['0'..'9','+','-','e','E','.'];
        ChiffreWin : TcharSet = ['0'..'9','+','-','e','E','.',','];
        ToucheEdition : TcharSet = [crSupprArr,crGauche,crDroite,crHome,crEnd,crSuppr];

	caracPrefixe : TcharSet =
	   ['y','z','a','f','p','n','','m','k','M','G','T','P','E'];
	caracUnite : TcharSet =
	   ['A'..'Z','a'..'z',OmegaMaj,'1'..'3','-','.','/',''];

	prefixeUnite : array[coefunite] of char =
	       ('0','y','z','a','f','p','n','','m',
                ' ','k','M','G','T','P','E','Z','Y','');
	valUnite : array[coefunite] of double =
	       (1E-27,1E-24,1E-21,1E-18,1E-15,1E-12,1E-9,1E-6,1E-3,
                1,1E+3,1E+6,1E+9,1E+12,1E+15,1E+18,1E+21,1E+24,1E+27);
	puissanceUnite : array[coefunite] of shortInt =
	       (-27,-24,-21,-18,-15,-12,-9,-6,-3,
                0,+3,+6,+9,+12,+15,+18,+21,+24,+27);
	expUnite : array[coefUnite] of string[4] =
	       ('E-27','E-24','E-21','E-18','E-15','E-12','E-9','E-6','E-3',
                '','E+3','E+6','E+9','E+12','E+15','E+18','E+21','E+24','E+27');

Procedure afficheErreurStr(texte : shortString);
Function ToucheValidation(key : word) : boolean;
Procedure TrimComplet(var S : shortString);
Function Pad(S : shortString;Len : byte) : shortString;
Function ConvertitChaine(nombre : strUnite;var valeur : double) : boolean;
Function FormatGTS(nombre : double) : strUnite;
Function FormatTime(nombre : double) : strUnite;
Function PuissToStr(puiss : integer) : strUnite;
Function CompareStr(s1,s2 : shortString) : boolean;
Function GetFloat(Nombre : ShortString) : double;
Function StrToFloatWin(nombre : strUnite) : double;
Function EncodeDuree(duree : LongInt) : TdateTime;
Function DureeEcoulee(InstantDebut : TdateTime) : double;
Function CaracToChiffre(carac : char) : byte;
Procedure ConvertitPrefixe(var nombre : strUnite);
Procedure VerifKeyGetFloat(var key : char);
Function DateTimeToFloat(nombre : strUnite) : double;
Function stOuiNon(isOui : boolean) : shortString;
Function FormatSynchro(Nombre : double) : strUnite;

var
     mesDocsDir : String;

implementation

Procedure UpCaseStr(var s : shortString);
var i : byte;
begin
     for i := 1 to length(s) do s[i] := UpCase(S[i])
end;

Procedure TrimComplet(var s : shortString);
var longueur,posCourant : byte;
begin
	longueur := Length(s);
	posCourant := 1;
	while (posCourant<=longueur) do
		if ord(s[posCourant])<=32
			then begin
			   Delete(s,posCourant,1);
			   dec(longueur);
			end
			else inc(posCourant);
end;

Function StrToFloatWin(nombre : strUnite) : double;
var posSeparator : byte;
begin
   trimComplet(nombre);
   if decimalSeparator='.'
      then begin
        posSeparator := pos(',',nombre);
        if posSeparator>0 then Nombre[posSeparator] := decimalSeparator;
      end
      else begin
        posSeparator := pos('.',nombre);
        if posSeparator>0 then Nombre[posSeparator] := decimalSeparator;
      end;
   ConvertitPrefixe(nombre);
   try
   StrToFloatWin := strToFloat(nombre);
   except
   StrToFloatWin := sansSignif;    
   end;
end;

Function ConvertitChaine(nombre : strUnite;var valeur : double) : boolean;
begin
   if (upcase(nombre[1])='E')
	  then nombre := '1'+nombre
	  else if (nombre[1]='.') or (nombre[1]=',') 
		  then nombre := '0'+nombre;
   convertitPrefixe(nombre);
   convertitChaine := true;
   try
   valeur := StrToFloatWin(nombre);
   except
      convertitChaine := false;
   end;
end;

Function FormatGeneral(Nombre : double;Nchiffres : integer) : strUnite;
var Nexp : integer;
    posSeparator : integer;
begin
     if Nombre=sansSignif then begin
        FormatGeneral := ' ';
        exit;
     end;
     if abs(Nombre)<1e-10
         then Nexp := 2
         else if abs(Nombre)<1e+10
              then Nexp := 1
              else Nexp := 2;
      result := FloatToStrF(nombre,ffGeneral,Nchiffres,Nexp);
      if decimalSeparator<>'.' then begin
         posSeparator := pos(decimalSeparator,result);
        if posSeparator>0 then result[posSeparator] := '.';
      end;
end;

Function FormatGTS(Nombre : double) : strUnite;
begin
     result := FormatGeneral(Nombre,PrecisionGTS)
end;

Function FormatTime(Nombre : double) : strUnite;
begin
     FormatTime := FormatGeneral(Nombre,PrecisionTime)
end;

procedure afficheErreurStr(texte : shortstring);
var SauveCursor : Tcursor;
begin
     SauveCursor := Screen.cursor;
     Screen.cursor := crDefault;
     MessageDlg(texte,mtError,[mbOK],0);
     Screen.cursor := SauveCursor;
end;

Function PuissToStr(puiss : integer) : strUnite;
var dest : strUnite;
    i : byte;
begin
      if puiss=0
         then dest := ''
         else dest := IntToStr(puiss);
      for i := 1 to length(dest) do
          case dest[i] of
               '0'..'9' : dest[i] := chiffreExp[dest[i]];
               '+' : dest[i] := PlusExp;
               '-' : dest[i] := MoinsExp;
          end;
      PuissToStr := dest
end;

Procedure ConvertitPrefixe(var nombre : strUnite);
var u : coefUnite;
    c : char;
begin
   c := nombre[length(nombre)];
   if c in caracPrefixe then begin
        u := zero;
        repeat inc(u) until (c=prefixeUnite[u]);
        delete(nombre,length(nombre),1);
        nombre := nombre+expUnite[u];
   end;
end;

Function CompareStr(s1,s2 : shortstring) : boolean;
begin
    upCaseStr(s1);
    upCaseStr(s2);
    compareStr := s1=s2;
end;

Function ToucheValidation(key : word) : boolean;
begin
    ToucheValidation := key in [vk_tab,vk_left,vk_right,vk_down,vk_up,vk_return]
end;

function Pad(S : shortstring;Len : Byte) : shortstring;
{-Return a string right-padded to length len with ' '}
var
  o : shortstring;
  Slen : byte;
begin
   Slen := length(S);
   if SLen>Len then S := copy(S,1,Len);
   setLength(o,len);
   Move(S[1], o[1], SLen);
   FillChar(o[Succ(SLen)], Len-SLen,' ');
   Pad := o;
end;

Function EncodeDuree(duree : LongInt) : TdateTime;
var h,m,s,ms : word;
begin
    h := duree div 3600;
    duree := duree-h*3600;
    m := duree div 60;
    duree := duree-m*60;
    s := duree;
    ms := 0;
    EncodeDuree := EncodeTime(h,m,s,ms);
end;

Function DureeEcoulee(InstantDebut : TdateTime) : double;
var h,m,s,ms : word;
begin
      decodeTime(now-instantDebut,h,m,s,ms);
      DureeEcoulee := h*3600.0+m*60.0+s*1.0+ms*0.001;
end;

Function CaracToChiffre(carac : char) : byte;
begin
      if carac in chiffre
         then result := ord(carac)-ord('0')
         else case carac of
              #186 : result := 0;
              #185 : result := 1;
              #178 : result := 2;
              #179 : result := 3;
              #165 : result := 4;
              #169 : result := 5;
              #172 : result := 6;
              #173 : result := 7;
              #174 : result := 8;
              #188 : result := 9;
              else result := 0;
         end;
end;

Function WordToInt(V : word) : integer; { de -512  +512 }
begin
     if V=65535
        then  result := 0
        else if V<32768
          then result := V div 64  { 0  512 }
          else result := V div 64 - 1024 { -512  -1 }
end;

Function IntToWord(V : integer) : word;
begin
     if V=0
        then result := 65535
        else if V<0
           then result := (V+1024)*64 { 32768  65472 }
           else result := V*64 { 0  32704 }
end;

function PosN(const C : shortString;S : shortString;const K : Integer): Integer;
var
  P : Integer;
begin
  Result := 0;
  if K>0 then Delete(S,1,K);
  P := Pos(C, S);
  if P>0 then result := K+P;
end;

Function DateTimeToFloat(nombre : strUnite) : double;
var i,Njour : integer;
begin
     result := 0;
     trimComplet(nombre);
     i:=pos(':',nombre);
     if i>0
        then begin
           i:=pos('j',nombre);
           Njour := 0;
           if i>0
               then begin
                 if i>1 then begin
                   try
                   Njour := StrToInt(copy(nombre,1,pred(i)));
                   except
                   end;
                 end; { i>1 }
                 delete(nombre,1,i);
               end { i>0 }
               else begin
                   i := posN(':',nombre,2);
                   if i=0 then nombre := '0:'+nombre;
               end;
           try
           result := (StrToTime(nombre)+Njour)*60*60*24;
           except
           end;
        end {i>0}
        else begin
        i:=pos('j',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := StrToInt(copy(nombre,1,pred(i)))*60*24*60;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('h',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToInt(copy(nombre,1,pred(i)))*60*60;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('min',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToFloatWin(copy(nombre,1,pred(i)))*60;
              except
              end;
           end;
           delete(nombre,1,i+2);
        end;
        i:=pos('m',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToFloatWin(copy(nombre,1,pred(i)))*1e-3;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('',nombre);
        if i>0 then begin
           if i>1 then begin
               try
               result := result+StrToFloatWin(copy(nombre,1,pred(i)))*1e-6;
               except
               end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('s',nombre);
        if i>0 then delete(nombre,i,1);
        if nombre<>'' then begin
            try
            result := result+strToFloatWin(nombre);
            except
            end;
        end;
        if result = 0 then result := 0.1;
     end;
end;

Function GetFloat(Nombre : ShortString) : double;
Const
    MaxPile = 10;
    CaracCte : TcharSet = [piMin,piMaj,'P','I','p','i'];
type
    IndicePile  = 1..MaxPile;
Var
    Pile : Array[IndicePile] of double;
    IndicePileCourant : 0..MaxPile;
    CaracCourant   : char;
    PointeurExp : byte;

Procedure suivant;
{Lit le prochain caractre et l'assigne  caracCourant}
{Le caracCourant est toujours extrait avant appel d'un analyseur}
begin
    inc(pointeurExp);
    if pointeurExp<=length(Nombre)
       then caracCourant := Nombre[pointeurExp]
       else caracCourant := #0;
end;

Procedure InitFonctor;
Begin
  pointeurExp := 0;
  indicePileCourant := 0;
  suivant;
end;{ InitFonctor }

{Les procdures LireXXX extraient un XXX de la chaine Nombre  partir du
 pointeur courant }

Function LireNombre : double;
    Var PointeurChiffre : byte;
        Valeur : double;
        NombreLoc : ShortString;

    Procedure lireEntier;
    begin
       While ( caracCourant in chiffre ) do suivant
    end;

    Begin
        PointeurChiffre := PointeurExp;{pointe le premier chiffre du nombre}
        lireEntier;
        If ( caracCourant in ['.',','] ) {C'est un nombre dcimal}
           Then begin
              suivant;{on saute le .}
              lireEntier
           end;
        If ( upcase(caracCourant) = 'E' ) {puissance de 10}
           then begin
              suivant;{on saute le E}
              if (caracCourant='+') or (caracCourant='-')  then suivant;
              lireEntier
           end
           else if caracCourant in caracPrefixe then suivant {coeff unit};
        NombreLoc := copy(nombre,pointeurChiffre,pointeurExp-PointeurChiffre);
        if not ConvertitChaine(nombreLoc,valeur)
           then raise EGetFloatError.Create('Erreur nombre');
        LireNombre := valeur;
   end; { lireNombre }

Function LireIdEnt : ShortString;
Var PointeurIdent : byte;
Begin
  PointeurIdent := pointeurExp;
  While (caracCourant in CaracCte) do suivant;
  if (pointeurExp-pointeurIdent)>longUnite then raise EGetFloatError.Create('Identificateur trop long (>8)');
  LireIdent := copy(nombre,pointeurIdent,pointeurExp-pointeurIdent)
End;{LireIdEnt}

Procedure Depile(Var P : double);
Begin
  if indicePileCourant=0
    then raise EGetFloatError.Create('Erreur interne')
    else begin
      P := Pile[indicePileCourant];
      dec(indicePileCourant);
   end;
End;

Procedure Empile(P : double);
Begin
  if indicePileCourant=MaxPile
    then raise EGetFloatError.Create('Trop complexe')
    else begin
      inc(indicePileCourant);
      Pile[indicePileCourant] := P;
   end;
End;

Function CalcOperateur(C : char;PG,PD : double) : double;
begin
   case C of
         '+'  : calcOperateur := PG+PD;
         '-'  : calcOperateur := PG-PD;
         '/'  : calcOperateur := PG/PD;
         '*'  : calcOperateur := PG*PD;
         else CalcOperateur := 0;
   end;
end;

Procedure AnalyseExpression;Forward;

Procedure E;
{E=(.Expression.)}
Begin
  If caracCourant='('
    Then Begin
        suivant;
        AnalyseExpression;
        case caracCourant of
             ')'  : suivant;
             #0 : ; { fin => on ajoute ) manquante }
             else raise EGetFloatError.Create('Erreur )');
        end;{case}
    End
    Else raise EGetFloatError.Create('Erreur (')
End;{E}

Procedure AnalyseElement;
{Element = E/nombre}
Var
  U : ShortString;
Begin
  If (caracCourant in [piMin,piMaj,'P','p'])
    Then Begin
        U := LireIdent;
        U := AnsiUpperCase(U);
        if (U=piMin) or (U='PI')or (U=piMaj)
           then Empile(pi)
           else raise EGetFloatError.Create('Erreur nombre')
    End {Then}
    Else If caracCourant in Chiffre+['-','+','.']
        Then Empile(LireNombre)
        Else E
End;{analyseElement}

Procedure AnalyseTerme;
{terme = facteur.[* ou /].element}
Var
  C        : Char;
  T1,T2    : double;
Begin
  AnalyseElement;
  While (caracCourant='*') or (caracCourant='/') do Begin
       C:=caracCourant;
       suivant;
       AnalyseElement;
       depile(T2);
       depile(T1);
       Empile(CalcOperateur(C,T1,T2));
    End {while}
End; { AnalyseTerme }

Procedure AnalyseExpression;
{Expression = [+ ou - ou rien].Terme.[+ ou -].terme}
Var
  C      : Char;
  T1,T2  : double;
Begin
  If (caracCourant='+') or (caracCourant='-')
     Then Begin
        C:=caracCourant;
        suivant
     end
     Else C:='+';
  AnalyseTerme;
  If C='-' Then begin
         depile(T1);
         Empile(-T1)
  end;
  While (caracCourant='+') or (caracCourant='-') do Begin
      C:=caracCourant;
      suivant;
      AnalyseTerme;
      depile(T2);
      depile(T1);
      Empile(CalcOperateur(C,T1,T2));
  End {while}
End;{AnalyseExpression}

var posVirgule : integer;
Begin {getFloat}
  trimComplet(Nombre);
  if nombre='' then begin
     result := sansSignif;
     exit;
  end;
  posVirgule := pos(',',nombre);
  while posVirgule>0 do begin
      Nombre[posVirgule] := '.';
      posVirgule := pos(',',nombre);      
  end;
  InitFonctor;
  AnalyseExpression;
  if pred(pointeurExp)<>length(nombre) then
     raise EGetFloatError.Create('Erreur nombre');
  result := Pile[1];
end;{getFloat}

Procedure VerifKeyGetFloat(var key : char);
begin
     if key in [',','.']
        then key := decimalSeparator
        else if not ( key in CharGetFloat ) then key := #0
end;

Function AddBackSlash(aPath : String):String;
Begin
  Result := EmptyStr;
  If (aPath <> '') and (aPath[Length(aPath)] <> '\') Then
    Result := aPath + '\';
End;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
Function GetFolder(CSIDLValue: integer): String;
Var
  IdList            : PITEMIDLIST;
  Folder            : Array[0..MAX_PATH] Of Char;
Begin
  if Not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
    End;
End;

Function stOuiNon(isOui : boolean) : shortString;
begin
    if isOui then result := 'Oui' else result := 'Non'
end;

Function FormatSynchro(Nombre : double) : strUnite;
begin
     result := FormatGeneral(Nombre,PrecisionSynchro)
end;

Initialization
   mesDocsDir := GetFolder(CSIDL_Personal);
   if not DirectoryExists(MesDocsDir + 'Regressi') then
      createDir(MesDocsDir + 'Regressi');
   mesDocsDir := MesDocsDir + 'Regressi\';
end.


