unit Initio;

interface

uses sysutils, classes;

type
   Tconstructeur = (cDin,cDB15,cDavisual,cMesura,cInitio,cAutre);
   Tinitio = record
        origineC,penteC : double;
        constructeur : Tconstructeur;
        nomC,nomUniteC,signifC : shortString;
        maxiC,miniC : double;
    end;

const maxInitio = 5;
var
    ListeInitio : array[0..MaxInitio] of TInitio;

implementation

Procedure InitCapteurs;
begin
    with ListeInitio[0] do begin
        origineC := 0;
        constructeur := cDavisual;
        penteC := 1;
        miniC := 0;
        maxiC := 2;
        nomC := 'V';
        nomUniteC := 'V';
        signifC := 'Voltmtre';
    end;
    with ListeInitio[1] do begin
        origineC := 0;
        constructeur := cDavisual;
        penteC := 7;
        miniC := 0;
        maxiC := 14;
        nomC := 'pH';
        nomUniteC := '';
        signifC := 'pHmtre';
    end;
    with ListeInitio[2] do begin
        origineC := 0;
        penteC := 1000;
        miniC := 0;
        maxiC := 2000;
        nomC := 'P';
        constructeur := cDavisual;
        nomUniteC := 'hPa';
        signifC := 'Pressiomtre';
    end;
    with ListeInitio[3] do begin
        origineC := 0;
        penteC := 1;
        miniC := 0;
        maxiC := 2;
        nomC := 'C';
        nomUniteC := 'mS';
        signifC := 'Conductimtre';
    end;
    with ListeInitio[4] do begin
        origineC := 0;
        penteC := 12.5;
        miniC := 0;
        constructeur := cDavisual;
        maxiC := 25;
        nomC := 'O2';
        nomUniteC := '%';
        signifC := '% de dioxygne';
    end;
    with ListeInitio[5] do begin
        origineC := 0;
        penteC := 50;
        miniC := 0;
        constructeur := cDavisual;        
        maxiC := 100;
        nomC := 'h';
        nomUniteC := '%';
        signifC := 'Hygromtre';
    end;
end;

Initialization
   initCapteurs

end.
