Unit Maths;

Interface

uses WinTypes,WinProcs,SysUtils,math;

const
     MaxVecteur = 16384;
     MaxVecteurGTS2 = 60000;
     NbreMaxGBF = 16000;

type
     IndiceVecteur = 0..MaxVecteur;
     IndiceGTS2 = 0..MaxVecteurGTS2;
     Vecteur = array[IndiceVecteur] of double;
     VecteurInt = array[IndiceVecteur] of smallInt;
     VecteurWord = array[IndiceVecteur] of word;
     VecteurByte = array[IndiceVecteur] of byte;
     VecteurGTS2 = array[IndiceGTS2] of char;
     VecteurGBF = array[0..NbreMaxGBF] of integer; // 32 bits
     VecteurGBFReal = array[0..NbreMaxGBF] of double;

const
     SansSignif : double = 1e-26;

Function Dix(x : integer) : double;
Function Log(x : double) : double;
Procedure GetMinMax(const V : vecteur;N : indiceVecteur;var mini,maxi : double);
Procedure VerifMinMaxInt(var mini,maxi : integer);
Procedure VerifMinMaxDouble(var mini,maxi : double);

Implementation

function Dix(x : integer) : double;
Begin
    Dix := Power(10,X)
end;

Procedure VerifMinMaxInt(var mini,maxi : integer);
var z : integer;
begin
   if Maxi<Mini then begin
	  z := Maxi;
	  Maxi := Mini;
	  Mini := z;
   end;
end;

Procedure VerifMinMaxDouble(var mini,maxi : double);
var z : double;
begin
   if Maxi<Mini then begin
	  z := Maxi;
	  Maxi := Mini;
	  Mini := z;
   end;
end;

Procedure GetMinMax(const V : vecteur;N : indiceVecteur;var mini,maxi : double);
var i : indiceVecteur;
begin
     Mini := V[0];
     Maxi := V[0];
     for i := 1 to pred(N) do
         if V[i]>Maxi
            then Maxi := V[i]
            else if V[i]<Mini
               then Mini := V[i]
end;

Function Log(X:double):double;
Begin
   Log := Log10(X)
End;

end.

