unit gti2_osc_DDE;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry,
  Maths_osc, gti2_dll, gti2_osc_Graphe,
  UniteKer, gti2_osc_util, clipbrd, gti2_osc;

type
  TDDEForm = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    donnees : TstringList;
    procedure AjouteConst;
    procedure Execute(Ordre : shortString);
  public
      procedure EnvoieDonneesOsc;
  end;

var
  DDEForm: TDDEForm;

implementation

uses gti2_osc_Main, gti2_osc_Const, gti2_osc_Reg;

const crTab=#9;

{$R *.DFM}

procedure TDDEForm.AjouteConst;
begin with ConstanteDlg do
     if (valeurConstEdit.text<>'') and
        (nomConstEdit.text<>'') then begin
        Donnees.Add('');
        Donnees.Add(nomConstEdit.text);
        Donnees.Add(uniteConstEdit.text);
        Donnees.Add(valeurConstEdit.text);
     end;
end;

procedure TDDEForm.Execute(Ordre : shortString);

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   StrPCopy(CharVal, 'Regressi');
   hSemaphore := CreateSemaphore(nil,0,1,CharVal);
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if WinExec(CharVal, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
var Buf: PChar;
begin
      Buf := StrAlloc(Succ(Length(Ordre)));
      if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
           ShowMessage(Ordre+' non excut');
      StrDispose(Buf);
      ClientDDE.closeLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then lance
        else begin
             sleep(1000);
        // OpenLik false efface
             ClientDDE.SetLink('Regressi','ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             if ClientDDE.OpenLink
                then Lance
                else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TDDEForm.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','regressi.exe');
    Ini.Free;
end;

procedure TDDEForm.EnvoieDonneesOsc;
var i,N : integer;
    v : indiceVoieYD;
    v2 : indiceVoieGTS2;
    ligne : shortString;
    code : char;
begin with grapheOsc do begin
     Screen.Cursor := crHourGlass;
     if modeAcq<>mTemps then begin
        iDebut := 0;
        iFin := pred(nbre);
     end;
     avecGTS2 := gti2.Gts2Permis and (gti2.NbreVoiesGTS2>0);
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if ConstanteDlg.NewPageCB.itemIndex=1
        then Donnees.Add('')
        else Donnees.Add('Acquisition par Orphy GTI2');
     Donnees.Add(ConstanteDlg.editComm.text);
     N := 0;
     if modeAcq=mClavier
        then ligne := entreeClavier.nom
        else ligne := voieTemps.nom;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then begin
            ligne := ligne + crTab + voieOrphy[v].nom;
            if v<>voieAbscisse then inc(N);
         end;
     if avecGts2 then for v2 := low(indiceVoieGTS2) to high(indiceVoieGTS2) do
         if voieGTS2[v2].active then begin
            ligne := ligne + crTab + voieGTS2[v2].nom;
            inc(N);
         end;
     Donnees.Add(ligne);
     if modeAcq=mClavier
        then ligne := entreeClavier.nomUnite
        else ligne := voieTemps.nomUnite;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then
            ligne := ligne + crTab + voieOrphy[v].nomUnite;
     if avecGts2 then for v2 := low(indiceVoieGTS2) to high(indiceVoieGTS2) do
         if voieGTS2[v2].active then
            ligne := ligne + crTab + voieGTS2[v2].nomUnite;
     Donnees.Add(ligne);
     if modeAcq=mClavier
        then ligne := entreeClavier.signif
        else ligne := voieTemps.signif;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then
            ligne := ligne + crTab + voieOrphy[v].signif;
     if avecGts2 then for v2 := low(indiceVoieGTS2) to high(indiceVoieGTS2) do
         if voieGTS2[v2].active then
            ligne := ligne + crTab + voieOrphy[v2].signif;
     Donnees.Add(ligne);
     if idebut<0 then idebut := 0;
     if ifin>=Nbre then ifin := pred(nbre);
     for i := idebut to ifin do begin
         if modeAcq=mClavier
            then ligne := FloatToStrPoint(entreeClavier.vecteurAff[i])
            else ligne := FloatToStrPoint(voieTemps.vecteurAff[i]);
         for v := low(indiceVoieYD) to high(indiceVoieYD) do
             if voieOrphy[v].active then
                ligne := ligne + crTab + FloatToStrPoint(voieOrphy[v].vecteurAff[i]);
         if avecGTS2 then for v2 := low(indiceVoieGTS2) to high(indiceVoieGTS2) do
             if voieGTS2[v2].active then
                ligne := ligne + crTab + FloatToStrPoint(voieGTS2[v2].vecteurAff[i]);
         Donnees.Add(ligne);
     end;
     AjouteConst;
     Donnees.Add(symbReg2+intToStr(N)+' NOMX');
     case modeAcq of
          mPointParPoint : for i := 1 to N do Donnees.Add(voieOrphy[voieAbscisse].nom);
          mClavier : for i := 1 to N do Donnees.Add(entreeClavier.nom);
          mTemps : for i := 1 to N do Donnees.Add(voieTemps.nom);
     end;
     Donnees.Add(symbReg2+intToStr(N)+' NOMY');
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active and
            ((modeAcq<>mPointParPoint) or (v<>voieAbscisse)) then
            Donnees.Add(voieOrphy[v].nom);
     if avecGTS2 then for v2 := low(indiceVoieGTS2) to high(indiceVoieGTS2) do
         if voieGTS2[v2].active then
            Donnees.Add(voieGTS2[v2].nom);
     donnees.Add(symbReg2+intToStr(N)+' LIGNE');
     if modeAcq=mTemps then code := '2' else code := '1';
     for i := 1 to N do donnees.Add(code);
     ClipBoard.asText := donnees.text;
     if ConstanteDlg.NewPageCB.itemIndex=1
          then Execute('CLIP|ADD')
          else Execute('CLIP|LOAD');
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Screen.Cursor := crDefault;
     Donnees.Free;
end end; // EnvoieDonneesOsc 

procedure TDDEForm.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : shortstring;
    ArgStart,ArgEnd : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if CompareText('CONFIG|LOAD',Fonction) = 0 then exit;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then exit;
       if CompareText('FOCUS',Fonction) = 0 then begin
           GTI2MainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 1;
           GTI2MainForm.setFocus;
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

end.
