unit yd_CFG_OSC;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs, ComCtrls, ImgList,
  gti2_osc_util, gti2_osc_graphe, gti2_osc_main, maths, gti2_osc;

type
  TOrphyGti2Dlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    EditSignif: TEdit;
    Label3: TLabel;
    DesactiveBtn: TBitBtn;
    CouleurCombo: TColorBox;
    ZeroBtn: TBitBtn;
    Label4: TLabel;
    WidthCourbeSE: TSpinEdit;
    CalibreCB: TComboBox;
    Label5: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure ZeroBtnClick(Sender: TObject);
  private
  public
    calibre : Tcalibre;
    voieCourante : TcourbeOsc;
    modifZero : boolean;
  end;

var
  OrphyGti2Dlg: TOrphyGti2Dlg;

implementation

{$R *.DFM}

procedure TOrphyGti2Dlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          CouleurCombo.selected := couleur;
          if diffRG.itemIndex=0
             then caption := 'YD'+intTostr(numero)
             else caption := 'Y'+intTostr(numero)+' BNC';
          modifZero := false;
          widthCourbeSE.value := GrapheOsc.penWidth;
          calibreCB.itemIndex := ord(calibre);
end end;

procedure TOrphyGti2Dlg.OKBtnClick(Sender: TObject);
begin with voieCourante do begin
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditSignif.text;
          voieCourante.couleur := couleurCombo.selected;
          GrapheOsc.penWidth := widthCourbeSE.value;
          maxi := valeurCalibre[Tcalibre(calibreCB.itemIndex)];
end end;

procedure TOrphyGti2Dlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not (key in (majuscule+minuscule+grecque+toucheEdition+chiffre)) then key := #0
end;

procedure TOrphyGti2Dlg.ZeroBtnClick(Sender: TObject);
var signal : boolean;
begin with voieCourante do begin
     if messageDlg('Court-circuitez '+caption,mtConfirmation,
          [mbOK, mbCancel],0)=mrCancel then exit;
     screen.Cursor := crHourGlass;
     modifZero := true;
     gti2.EtalonneZero(numero,diffRG.itemIndex=0,signal);
     if signal then showMessage('Vous n''avez pas court-circuit ?');
     screen.Cursor := crDefault;
end end;

end.

