unit yd_CFG_point;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs, ComCtrls, ImgList,
  gti2_osc, gti2Util_osc, gti2_osc_graphe, maths;

type
  TConfigVoiePointDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    EditSignif: TEdit;
    Label3: TLabel;
    DesactiveBtn: TBitBtn;
    CouleurCombo: TColorBox;
    ImagePoint: TImageList;
    PointCombo: TComboBoxEx;
    Label4: TLabel;
    WidthCourbeSE: TSpinEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure DesactiveBtnClick(Sender: TObject);
  private
  public
    voieCourante : TcourbeOsc;
  end;

var
  ConfigVoiePointDlg: TConfigVoiePointDlg;

implementation

{$R *.DFM}

procedure TConfigVoiePointDlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          widthCourbeSE.value := GrapheOsc.penWidth;
          if diffRG.itemIndex=0
             then caption := 'Y'+intTostr(numero)+' BNC GTI2'
             else caption := 'YD'+intTostr(numero)+' GTI2';
end end;

procedure TConfigVoiePointDlg.OKBtnClick(Sender: TObject);
begin with voieCourante do begin
          Nom := EditNom.text;
          active := true;
          NomUnite := EditUnite.text;
          Signif := EditSignif.text;
          voieCourante.couleur := couleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
          grapheOsc.penWidth := widthCourbeSE.value;
          couleur := CouleurCombo.selected;
end end;

procedure TConfigVoiePointDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not (key in (majuscule+minuscule+grecque+toucheEdition+chiffre)) then key := #0
end;

procedure TConfigVoiePointDlg.DesactiveBtnClick(Sender: TObject);
begin
    voieCourante.active := false
end;

end.

