unit yd_EAD_OSC;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs, ComCtrls, ImgList,
  gti2_osc_util, gti2_osc_graphe, gti2_osc_main, maths,
  gti2_osc;

type
  TOrphyGts2Dlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    EditSignif: TEdit;
    Label3: TLabel;
    DesactiveBtn: TBitBtn;
    CouleurCombo: TColorBox;
    Label4: TLabel;
    WidthCourbeSE: TSpinEdit;
    CapteursBtn: TBitBtn;
    VoltBtn: TBitBtn;
    BitBtn1: TBitBtn;
    EtalonneInterBtn: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure CapteursBtnClick(Sender: TObject);
    procedure EtalonCBClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure EtalonneInterBtnClick(Sender: TObject);
  private
  public
    voieCourante : TcourbeGTS2;
  end;

var
  OrphyGts2Dlg: TOrphyGts2Dlg;

implementation

{$R *.DFM}

uses listeCap, ETALON;

procedure TOrphyGts2Dlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          CouleurCombo.selected := couleur;
          caption := TitreVoieGTI2[gti2.connectique,numero];
          widthCourbeSE.value := GrapheOsc.penWidth;
          capteursBtn.visible := (indexCapteurAuto=0);
          voltBtn.Visible := (indexCapteurAuto=0) and avecCapteur;
end end;

procedure TOrphyGts2Dlg.OKBtnClick(Sender: TObject);
begin with voieCourante do begin
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditSignif.text;
          voieCourante.couleur := couleurCombo.selected;
          GrapheOsc.penWidth := widthCourbeSE.value;
end end;

procedure TOrphyGts2Dlg.BitBtn1Click(Sender: TObject);
begin
    voieCourante.active := false; 
end;

procedure TOrphyGts2Dlg.CapteursBtnClick(Sender: TObject);
begin
     if ListeCapteursDlg=nil then
        Application.CreateForm(TListeCapteursDlg, ListeCapteursDlg);
     ListeCapteursDlg.voieCourante := voieCourante;
     if ListeCapteursDlg.showModal=mrOK then
        FormActivate(nil);
end;

procedure TOrphyGts2Dlg.EtalonCBClick(Sender: TObject);
begin with voieCourante do 
     if avecCapteur then begin
              mini := -10;
              maxi := +10;
              nomUnite := 'V';
              signif := 'tension';
              avecCapteur := false;
              FormActivate(nil);
     end;
end;

procedure TOrphyGts2Dlg.EtalonneInterBtnClick(Sender: TObject);
begin with voieCourante do begin
//     timer.enabled := false;
     Nom := EditNom.text;
     NomUnite := EditUnite.text;
     EtalonneInterDlg := TEtalonneInterDlg.create(self);
     EtalonneInterDlg.voieCourante := voieCourante;
     if EtalonneInterDlg.showModal=mrOK then begin
//         val0Edit.text := FormatGts(offset);
//         penteEdit.text := FormatGts(UnVolt);
//         etalonCB.checked := true;
//         setEtalonnage;
     end;
//     timer.enabled := true;
     EtalonneInterDlg.free;
end end;
procedure TOrphyGts2Dlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not (key in (majuscule+minuscule+grecque+toucheEdition+chiffre)) then key := #0
end;

end.

