unit ETALONAuto;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
     StdCtrls, ExtCtrls, Sysutils, ComCtrls,
     maths, gti2_dll, gti2_osc, gti2_osc_util, gti2_osc_graphe;

type
  TEtalonneAutoDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    PotarTab: TTabControl;
    Memo: TMemo;
    EtalonBtn: TSpeedButton;
    EtalonLabel: TLabel;
    OKbtn: TBitBtn;
    Gauge: TProgressBar;
    PotarPB: TProgressBar;
    Label1: TLabel;
    EditNom: TEdit;
    Label3: TLabel;
    EditSignif: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PotarTabChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKbtnClick(Sender: TObject);
  private
    Pcourant : integer;
    indexCapteur : integer;
    codePotar : char;
  public
    voieCourante : indiceVoieYD;
  end;

var
  EtalonneAutoDlg: TEtalonneAutoDlg;

implementation

{$R *.DFM}


procedure TEtalonneAutoDlg.FormActivate(Sender: TObject);
var i : integer;
begin
     caption := 'Etalonnage capteur prise '+char(voieCourante+ord('G')-voieG);
     indexCapteur := grapheOsc.voieDB15[voieCourante].indexCapteurAuto;
     with listeCapteursAuto[indexCapteur] do if avecEtalonnage then begin
        PotarTab.tabs.clear;
        for i := 0 to maxPotarAuto do
            if potarActif[i] then PotarTab.tabs.add(nomPotar[i]);
        PotarTab.TabIndex := 0;
        PotarTabChange(nil);
        gauge.position := 0;
     end;
     codePotar := numToCodePotar(voieCourante);
     EditNom.text := grapheOsc.voieDB15[voieCourante].Nom;
     EditSignif.text := grapheOsc.voieDB15[voieCourante].Signif;
     PotarTab.visible := listeCapteursAuto[indexCapteur].avecEtalonnage;
     gauge.visible := PotarTab.visible;
     gti2.openGTS2;
end;

procedure TEtalonneAutoDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	gti2.closeGTS2
end;

procedure TEtalonneAutoDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(11)
end;

procedure TEtalonneAutoDlg.OKbtnClick(Sender: TObject);
begin
      grapheOsc.voieDB15[voieCourante].Nom := EditNom.text;
      grapheOsc.voieDB15[voieCourante].Signif := EditSignif.text;
      listeCapteursAuto[indexCapteur].EtalonnageFait := true;
end;

procedure TEtalonneAutoDlg.PotarTabChange(Sender: TObject);
var N,i : integer;
begin
    N := 0;
    for i := 0 to maxPotarAuto do
        if ListeCapteursAuto[indexCapteur].potarActif[i] then begin
           if PotarTab.tabIndex=N then Pcourant := i;
           inc(N);
        end;
    memo.text := ListeCapteursAuto[indexCapteur].aidePotar[Pcourant];
    EtalonLabel.Visible := false;
    EtalonBtn.Enabled := true;
    EtalonBtn.visible := true;
    PotarPB.position := ListeCapteursAuto[indexCapteur].valeurPotar[Pcourant];
    gauge.position := 0;
end;

procedure TEtalonneAutoDlg.EtalonBtnClick(Sender: TObject);

function IsGreater(P : integer) : boolean;
const
    attenteMin = 5; { 0,5 seconde }
    attenteMax = 20; { 2 secondes }
var oldzi,i,zi : integer;
    zr : double;
begin with listeCapteursAuto[indexCapteur] do begin
     PotarPB.position := P; 
     GTI2.output := 'WEPOTAR '+codePotar+' '+intToStr(Pcourant)+' '+intToStr(P);
     zi := 40000;
     i := 0;
     repeat
        oldzi := zi;
        sleep(50); // ms
        zi := Gti2.getInt('WEA '+intToStr(voieCourante-voieG+8));
        inc(i);
     until ((abs(zi-oldzi)<8) and (i>attenteMin)) or (i>attenteMax);
     zr := valeurReal(zi);
     result := zr>valeurAttendue[Pcourant];
end end;

var mini,maxi,testP,testV,i : integer;
    valeurCAN : double;
begin with ListeCapteursAuto[indexCapteur] do begin
      cursor := crHourGlass;
      EtalonBtn.Enabled := false;
      testP := valeurPotar[Pcourant];
      if isGreater(testP)
         then begin
            maxi := testP;
            mini := 0;
         end
         else begin
            mini := testP;
            maxi := 1024; // 2^10
         end;
      i := 0;
      repeat
           gauge.position := i;
           testP := (mini+maxi) div 2;
           if isGreater(testP)
              then maxi := testP
              else mini := testP;
           inc(i);
      until (maxi-mini)<2;
      Gti2.output := 'WMPOTAR '+codePotar+' '+intToStr(Pcourant);
      valeurPotar[Pcourant] := testP;
      if PCourant in [2,3] then begin
           sleep(100);
           testV := Gti2.getInt('WEA '+intToStr(voieCourante-voieG+8));
           valeurCAN := grapheOsc.voieDB15[voieCourante].ValeurVolt(testV);
           if PCourant=3 then
              grapheOsc.voieDB15[voieCourante].UnVolt := (valeurAttendue[3]-offsetC)/valeurCan;
           if PCourant=2 then // rsidu d'offset  corriger
              grapheOsc.voieDB15[voieCourante].offset := valeurAttendue[2]-UnVoltC*valeurCan;
      end;
      EtalonBtn.visible := false;
      EtalonLabel.Visible := true;
      if (testP>1020) or (testP<4)
         then EtalonLabel.caption := 'Etalonnage impossible'
         else EtalonLabel.caption := 'Etalonnage effectu';
      gauge.position := gauge.max;
      cursor := crDefault;
end end;

end.
