unit GTI2_osc_Main;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, Registry,
  spin, clipBrd, ComCtrls, ToolWin, ImgList, XPMan, Lcd, inifiles,
  uniteKer, math, fft, gti2_dll, gti2_osc, printers,
  GTI2_osc_util, maths_osc, GTI2_osc_Graphe, GTI2_point_Graphe,
  gti2_osc_About, gti2_osc_Dde, gti2_osc_Const, gbf_osc, Grids;

const
  maxVoieOrphyClavier = 2;
  baseDeTempsLente = b200m;

type
  tLedGBF = (lGray,lRed,lGreen);
  tModeAcq = (mTemps,mPointparPoint,mClavier);
  TEtatAcqLente = (eaEnCours,eaTerminee,eaAttente);

  TGTI2MainForm = class(TForm)
    PanelCourbe: TPanel;
    TempsPaintBox: TPaintBox;
    ToolBar1: TToolBar;
    ImageList: TImageList;
    ExitBtn: TToolButton;
    RegSaveBtn: TToolButton;
    HelpBtn: TToolButton;
    PlusBtn: TToolButton;
    XPManifest1: TXPManifest;
    Header: TStatusBar;
    PanelVoies: TPanel;
    GroupBox1: TGroupBox;
    Shape4: TShape;
    GroupBox6: TGroupBox;
    Shape1: TShape;
    GroupBox7: TGroupBox;
    Shape2: TShape;
    PanelTemps: TPanel;
    SynchroGB: TGroupBox;
    SynchroRG: TRadioGroup;
    SensRG: TRadioGroup;
    MonocoupCB: TCheckBox;
    BaseDeTempsGB: TGroupBox;
    DureeEdit: TLabeledEdit;
    DureeUpDown: TUpDown;
    FechEdit: TLabeledEdit;
    GroupBox2: TGroupBox;
    Shape3: TShape;
    Timer: TTimer;
    GBFPanel: TPanel;
    DB15Panel: TPanel;
    GbfPB: TPaintBox;
    DutyGB: TGroupBox;
    DutyEdit: TEdit;
    DutyScroll: TScrollBar;
    AmplitudeGB: TGroupBox;
    AmplitudeEdit: TEdit;
    AmplitudeScroll: TScrollBar;
    OffsetGB : TGroupBox;
    OffsetEdit: TEdit;
    OffsetScroll: TScrollBar;
    signalRG: TRadioGroup;
    FrequencePanel: TPanel;
    SpeedButton5: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton6: TSpeedButton;
    LabelHz: TLabel;
    MajGbfBtn: TSpeedButton;
    LCD10k: TLCD99;
    ExpressionPanel: TPanel;
    ExpressionEdit: TLabeledEdit;
    GBFbtn: TToolButton;
    LabelX: TLabel;
    LabelY: TLabel;
    PreAcqCB: TCheckBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    OrphyAbsent: TPanel;
    Label6: TLabel;
    ComBtn: TSpeedButton;
    EscapeBtn: TSpeedButton;
    Label7: TLabel;
    NbreEdit: TLabeledEdit;
    ShapeCurseur: TShape;
    OffsetNulBtn: TBitBtn;
    Duty50Btn: TBitBtn;
    AutoSetBtn: TToolButton;
    SeuilGB: TGroupBox;
    ProgressBarGTI2: TProgressBar;
    TimerGBF: TTimer;
    SeuilEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EnregistreBtn: TToolButton;
    ComboBox0: TComboBox;
    CheckBox10: TCheckBox;
    ComboBox1: TComboBox;
    CheckBox5: TCheckBox;
    ComboBox2: TComboBox;
    CheckBox6: TCheckBox;
    ComboBox3: TComboBox;
    CheckBox7: TCheckBox;
    Edit1: TEdit;
    PanelDuree: TPanel;
    SpinButton1: TSpinButton;
    NbreSpin: TSpinButton;
    SaveDialog1: TSaveDialog;
    UndoBtn: TToolButton;
    ResetBtn: TToolButton;
    PointGB: TGroupBox;
    DeltaPointSE: TSpinEdit;
    TimerPoint: TTimer;
    ModePpPRG: TRadioGroup;
    LabelAuto: TLabel;
    MajArbitrBtn: TSpeedButton;
    PanelDureePoint: TPanel;
    AbscisseRG: TRadioGroup;
    FrequenceTB: TScrollBar;
    RazSeuilBtn: TSpeedButton;
    FFTbtn: TToolButton;
    FFTPaintBox: TPaintBox;
    Splitter: TSplitter;
    LabelFFTx: TLabel;
    LabelFFTy: TLabel;
    FFTgb: TGroupBox;
    FFTperiode: TCheckBox;
    FreqAutoBtn: TSpeedButton;
    avecSegmentLabel: TLabel;
    Help_GBF_btn: TSpeedButton;
    MonoGBFbtn: TSpeedButton;
    monocoupGBFCB: TCheckBox;
    NbreFreqSE: TSpinEdit;
    PopupMenu1: TPopupMenu;
    OuvrirConfig: TMenuItem;
    EnregistrerConfig: TMenuItem;
    OpenDialog1: TOpenDialog;
    ConfigDefaut: TMenuItem;
    ToolButton1: TToolButton;
    OptionsItem: TMenuItem;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    GroupBox5: TGroupBox;
    Label9: TLabel;
    GroupBox8: TGroupBox;
    Label10: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ProgressBar3: TProgressBar;
    ProgressBar4: TProgressBar;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Btn1: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    PanelGTS2: TPanel;
    GroupBox9: TGroupBox;
    Shape5: TShape;
    ComboBox4: TComboBox;
    CheckBox1: TCheckBox;
    GroupBox10: TGroupBox;
    Shape6: TShape;
    ComboBox5: TComboBox;
    CheckBox2: TCheckBox;
    GroupBox11: TGroupBox;
    Shape7: TShape;
    ComboBox6: TComboBox;
    CheckBox3: TCheckBox;
    GroupBox12: TGroupBox;
    Shape8: TShape;
    ComboBox7: TComboBox;
    CheckBox4: TCheckBox;
    TimerGTS2: TTimer;
    RadioGroup5: TRadioGroup;
    RadioGroup6: TRadioGroup;
    RadioGroup7: TRadioGroup;
    RadioGroup8: TRadioGroup;
    EnregistrePointBtn: TToolButton;
    Image2: TImage;
    Image1: TImage;
    Image3: TImage;
    Image4: TImage;
    AcquisitionversGBF1: TMenuItem;
    MonocoupGBF_EAD_CB: TCheckBox;
    MonoGBF_EAD_Btn: TSpeedButton;
    EAD_GBF: Tpanel;
    LabelFreq: TLabel;
    LabelDuree: TLabel;
    GainGBF: TTrackBar;
    ClavierGB: TGroupBox;
    Label13: TLabel;
    ClavierGrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure TempsPaintBoxPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EscapeBtnClick(Sender: TObject);
    procedure OptionsBtnClick(Sender: TObject);
    procedure DureeUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure SynchroRGClick(Sender: TObject);
    procedure SensRGClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TempsPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure TempsPaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TempsPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MonocoupCBClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure GBFbtnClick(Sender: TObject);
    procedure GbfPBPaint(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure signalRGClick(Sender: TObject);
    procedure ExpressionEditChange(Sender: TObject);
    procedure ExpressionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MajGbfBtnClick(Sender: TObject);
    procedure voie_gti2Click(Sender: TObject);
    procedure PreAcqCBClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ComBtnClick(Sender: TObject);
    procedure OffsetNulBtnClick(Sender: TObject);
    procedure Duty50BtnClick(Sender: TObject);
    procedure ExpressionEditExit(Sender: TObject);
    procedure OffsetScrollScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure AutoSetBtnClick(Sender: TObject);
    procedure TimerGBFTimer(Sender: TObject);
    procedure SeuilEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SeuilEditExit(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure ComboBox0Change(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure NbreSpinDownClick(Sender: TObject);
    procedure NbreSpinUpClick(Sender: TObject);
    procedure NbreEditExit(Sender: TObject);
    procedure NbreEditKeyPress(Sender: TObject; var Key: Char);
    procedure UndoBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure TimerPointTimer(Sender: TObject);
    procedure ModePpPRGClick(Sender: TObject);
    procedure AbscisseRGClick(Sender: TObject);
    procedure FrequenceTBScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure RazSeuilBtnClick(Sender: TObject);
    procedure FFTbtnClick(Sender: TObject);
    procedure FFTPaintBoxPaint(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure OffsetScrollChange(Sender: TObject);
    procedure FFTPaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FFTPaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FFTPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FFTperiodeClick(Sender: TObject);
    procedure FreqAutoBtnClick(Sender: TObject);
    procedure AmplitudeScrollChange(Sender: TObject);
    procedure DutyScrollChange(Sender: TObject);
    procedure OffsetEditExit(Sender: TObject);
    procedure AmplitudeEditExit(Sender: TObject);
    procedure OffsetEditKeyPress(Sender: TObject; var Key: Char);
    procedure AmplitudeEditKeyPress(Sender: TObject; var Key: Char);
    procedure Help_GBF_btnClick(Sender: TObject);
    procedure FechEditKeyPress(Sender: TObject; var Key: Char);
    procedure MonoGBFbtnClick(Sender: TObject);
    procedure monocoupGBFCBClick(Sender: TObject);
    procedure NbreFreqSEChange(Sender: TObject);
    procedure OuvrirConfigClick(Sender: TObject);
    procedure EnregistrerConfigClick(Sender: TObject);
    procedure ConfigDefautClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure DB15Click(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure Shape6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerGTS2Timer(Sender: TObject);
    procedure RadioGroup5Click(Sender: TObject);
    procedure EnregistrePointBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure AcquisitionversGBF1Click(Sender: TObject);
    procedure MonocoupGBF_EAD_CBClick(Sender: TObject);
    procedure EA_GTS2Click(Sender: TObject);
    procedure ClavierGBClick(Sender: TObject);
    procedure ClavierGridExit(Sender: TObject);
    procedure ClavierGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: string);
    procedure ClavierGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ClavierGridKeyPress(Sender: TObject; var Key: Char);
    procedure ClavierGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    private
      Curseur : Tcurseur;
      PointCurseur : Tpoint;
      fermeture : boolean;
      initialisation : boolean;
      LedGBF : TledGBF;
      autoSetEnCours : boolean;
      autoSetYD : boolean;
      compteurGBF : word;
      premiereFois : boolean;
      DebutAcquisition : TdateTime;
      AcqPointEnCours : boolean;
      AvecSegment,PremierTrace : boolean;
      EchelleFreq : boolean;
      xCurseurEchelleFreq : integer;
      monocoupTemporaire : boolean;
      FFTok : boolean;
      MonoForcePermis : boolean;
      ReticuleTrace : boolean;
      isXP : boolean;
      stopEnCours : boolean;
      acqSuffisante : boolean;
      dureeMini : double;

// Clavier
      NbreVoieOrphyClavier : integer;
      voieOrphyClavier : array[0..MaxVoieOrphyClavier] of TcourbePoint;
      RowEdit : integer;

    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure SetLedGBF(etat : TledGBF);
    Procedure LanceAcq;
    procedure AfficheReglage;
    procedure MajGBF(etat : TledGBF);
    Procedure SetNbreDDE(newNbre : integer);
    procedure Autoset;
    procedure DeltaSeuil(signe : integer);
    procedure CacheCurseur;
// point par point
    Procedure EnregistrePointCourant;
    Procedure EffacePointCourant;
    Procedure MarquePointCourant;
    Procedure affecteFreqGBF(freq : double);
    procedure LitConfig(NomFichier : string);
    procedure EcritConfig(NomFichier : string);
    procedure DebutLectureParametres;
    procedure FinLectureParametres;
    function Reconnaissance : boolean;
    procedure MajDB15;
    procedure AfficheDB15;
    procedure affecteStop(stop : boolean);
    procedure SetValeurClavier(sortie : boolean);
    Procedure SetFocusGrid;    
  public
    modeAcq : TmodeAcq;
    sauverConfig : boolean;
    NbreHarmoniqueAff,NbreFreqAff : integer;
    Xa : vecteurFFT;
  protected
  end;

var
  GTI2MainForm: TGTI2MainForm;

implementation

uses gti2_osc_Reg, options, yd_CFG_OSC, yd_CFG_point, gbf_syntaxe,
     SysInfoCtrls, etalonAuto, yd_EAD_OSC, gti2_EAD_SA, CLAVIER;

{$R *.DFM}

const DeltatLent = 0.1;
      TexteAvecSegment : array[boolean] of string[32] =
    ('Affichage diffr','Affichage temps rel');


procedure TGTI2MainForm.AppMessage(var Msg: TMsg; var Handled: Boolean);

function NonCouperCopier : boolean;
var EditCtrl : TcustomEdit;
begin
   NonCouperCopier := true;
   if ( (msg.Wparam=24) or (msg.Wparam=3) ) and
      (Screen.ActiveControl is TCustomEdit)
      then begin
          EditCtrl := Screen.ActiveControl as TCustomEdit;
          if EditCtrl.SelLength > 0 then begin
             case msg.Wparam of
                 24 : EditCtrl.CutToClipBoard;
                 3 :  EditCtrl.CopyToClipBoard;
             end;
             Handled := true;
             NonCouperCopier := false;
          end;
   end;
end;

const
         GrecMaj : array[1..26] of char =
  ('A','B','C',deltaMaj,'E',phiMaj,gammaMaj,'H','I',psiMaj,'K',lambdaMaj,
   'M','N',videMaj,piMaj,thetaMaj,'R',sigmaMaj,'T','U','V',omegaMaj,xiMaj,'Y','Z');

        GrecMin : array[1..26] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,'i',psi,'k',lambda,
   mu,nu,vide,piMin,theta,rho,sigma,tau,'u','v',omega,xi,'y',zeta);

begin with Msg do
     if Message=wm_char then begin
            if (Wparam>0) and (Wparam<=26) then
             if (GetKeyState(vk_control)<0) then
                 if (GetKeyState(vk_shift)<0) or
                    (GetKeyState(vk_capital)<0)
                    then Wparam := ord(GrecMaj[Wparam])
                    else if (Wparam<>22) and NonCouperCopier
                      { Edition Windows copier coller couper }
                         then Wparam := ord(GrecMin[Wparam]);
    end;
end;

procedure TGTI2MainForm.LitConfig(NomFichier : string);
var Fichier : TIniFile;
    voie : indiceVoieYD;
    section : shortString;
    i : integer;
begin
     NomFichier := ChangeFileExt(NomFichier,'.GTI2');
     try
     Fichier := TIniFile.create(NomFichier);
     with Fichier do begin
     DureeUpDown.position := ReadInteger('Temps','Duree',0);
     gti2.baseDeTemps := TbaseDeTemps(DureeUpDown.Position);
     ModeAcq := TmodeAcq(ReadInteger('Mode','Point',0));
     grapheOsc.interpolation := Tinterpolation(ReadInteger('GTI2','Interpolation',0));     
     gti2.withGTS2 := TorphyGTS2(ReadInteger('Mode','GTS2',0));
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
         section := 'Voie'+intToStr(voie);
     with graphePoint.voieOrphy[voie] do begin
         active := ReadBool(section,'ActiveP',voie=0);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         if not active
            then calibreCB.ItemIndex := 6
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         nom := ReadString(section,'NomP',nom);
     end;
     with grapheOsc.voieOrphy[voie] do begin
         active := ReadBool(section,'Active',voie=0);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         if not active
            then calibreCB.ItemIndex := 6
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         grapheFFT.voieOrphy[voie].active := active;
         grapheFFT.voieOrphy[voie].maxi := maxi;
         nom := ReadString(section,'Nom',nom);
     end;
     section := 'VoieGTS'+intToStr(voie);
     with grapheOsc.voieGTS2[voie] do begin
         active := ReadBool(section,'Active',false);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-5);
         Maxi := ReadFloat(section,'Maxi',+5);
         if not active
            then calibreCB.ItemIndex := 6
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         grapheFFT.voieGTS2[voie].active := active;
         grapheFFT.voieGTS2[voie].maxi := maxi;
         nom := ReadString(section,'Nom',nom);
     end;
     end;// for voie

     signalRG.ItemIndex := ReadInteger('GBF','Signal',0);
     amplitudeScroll.position := ReadInteger('GBF','Amplitude',100);
     dutyScroll.position := ReadInteger('GBF','Duty',50);
     offsetScroll.position := ReadInteger('GBF','Offset',0);
     monocoupgbfCB.checked := ReadBool('GBF','Monocoup',false);
     LCD10k.value := ReadString('GBF','Frequence','1000');
     ExpressionEdit.text := ReadString('GBF','Expression','t*5');
//     GBFbtn.Down := ReadBool('GBF','Actif',false);
     GBFbtn.Down := false;
     ExpressionPanel.Visible := signalRG.itemIndex=ord(sArbitraire);
     EAD_GBF.Visible := signalRG.itemIndex=ord(sData);
     if signalRG.itemIndex=ord(sData) then begin
          gbf.nbreData := ReadInteger('GBF','NbreData',1024);
          gbf.gainData := ReadInteger('GBF','GainData',1);          
          gbf.freqEchData := ReadInteger('GBF','FreqEch',100000);
          for i := 0 to pred(gbf.NbreData) do
              gbf.dataReal[i] := ReadFloat('GBF','Data'+intToStr(i),0);
     end;

     synchroRG.ItemIndex := ReadInteger('Synchro','Mode',0);
     if synchroRG.itemIndex=0
        then grapheOsc.voieSynchro := voieT
        else grapheOsc.voieSynchro := synchroRG.itemIndex-1;
     gti2.seuilVolt := ReadFloat('Synchro','Seuil',0);
     grapheOsc.seuilSynchro := gti2.seuilVolt;
     sensRG.ItemIndex := ReadInteger('Synchro','Sens',0);
     preAcqCB.checked := ReadBool('Synchro','PreAcq',false);
     MonocoupCB.checked := ReadBool('Synchro','Monocoup',false);
     grapheOsc.monocoup := MonocoupCB.checked;
     end;
     fichier.free;
     except
     end;
end;

procedure TGTI2MainForm.FormCreate(Sender: TObject);

procedure SetDefaut;
var voie : indiceVoieYD;
begin
     monocoupTemporaire := true;
     grille := true;
     ModePpPRG.itemIndex := 0;
     DeltaPointSE.value := 1;
     WidthCursor := 3;
     graphePoint.voieAbscisse := 0;
     graphePoint.Nbre := 0;
     NbreHarmoniqueAff := 64;
     NbreFreqAff := 1024;
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do
     with graphePoint.voieOrphy[voie] do begin
         active := voie<2;
         if active
            then diffRG.itemIndex := 0
            else diffRG.itemIndex := 2;
         Mini := -15;
         Maxi := +15;
         calibreCB.ItemIndex := 6;
         zeroCB.checked := false;
     end;
     DimPoint := 3;
     with grapheOsc do begin
         AnalyseurLogique := false;
         Nbre := 0;
         NbreMaxi := 1000;
     end;
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
     with grapheOsc.voieOrphy[voie] do begin
         active := voie=0;
         if active
            then diffRG.itemIndex := 0
            else diffRG.itemIndex := 2;
         Mini := -15;
         Maxi := +15;
         calibreCB.ItemIndex := 6;
         zeroCB.checked := false;
     end;
     with grapheOsc.voieGTS2[voie] do begin
         active := false;
         diffRG.itemIndex := 2;
         Mini := -5;
         Maxi := +5;
         calibreCB.ItemIndex := 4;
         zeroCB.checked := false;
     end;
     end;
     synchroRG.ItemIndex := 0;
     grapheOsc.voieSynchro := voieT;
     gti2.seuilVolt := 0;
     grapheOsc.seuilSynchro := gti2.seuilVolt;
     sensRG.ItemIndex := 0;
     preAcqCB.checked := false;
     MonocoupCB.checked := false;
     grapheOsc.monocoup := false;
     DureeUpDown.position := 8;
     gti2.baseDeTemps := TbaseDeTemps(DureeUpDown.Position);
     PanelDuree.visible := gti2.baseDeTemps>b5;
     gti2.offsetSeuil[false] := 0;
     gti2.offsetSeuil[true] := 0;
     MonoForcePermis := true;

     signalRG.ItemIndex := 0;
     EAD_GBF.Visible := false;
     dutyScroll.position := 50;
     offsetScroll.position := 0;
     ExpressionEdit.text := 't*5';
     GBFbtn.Down := false;

     gti2.baseDeTemps := TbaseDeTemps(DureeUpDown.Position);
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
         grapheFFT.voieOrphy[voie].active := grapheOsc.voieOrphy[voie].active;
         grapheFFT.voieOrphy[voie].maxi := grapheOsc.voieOrphy[voie].maxi;
         grapheFFT.voieGTS2[voie].active := grapheOsc.voieGTS2[voie].active;
         grapheFFT.voieGTS2[voie].maxi := grapheOsc.voieGTS2[voie].maxi;
     end;
     amplitudeScroll.position := amplitudeScroll.max div 2;
     monocoupgbfCB.checked := false;
     LCD10k.value := '1000';
     ExpressionPanel.Visible := false;

end; // setDefaut

procedure LitConfigReg;
var Fichier : TRegistryIniFile;
    i,va : integer;
    voie : indiceVoieYD;
    section : shortString;
begin
  try
  Fichier := TRegistryIniFile.create(RegistreGTI2);
  With Fichier do begin
     grapheOsc.NbreMaxi := readInteger('Oscillo','NbreMaxi',1000);
     grille := readBool('Affichage','Grille',true);
     ModePpPRG.itemIndex := ReadInteger('Point','Auto',0);
     NbreHarmoniqueAff := ReadInteger('FFT','NbreAff',64);
     NbreFreqAff := ReadInteger('FFT','NbreFreq',1024);
     DeltaPointSE.value := ReadInteger('Point','PourCent',1);
     WidthCursor := readInteger('Affichage','WidthCursor',3);
     DimPoint := readInteger('Affichage','DimPoint',dimPoint);
     AnalyseHarmonique := ReadBool('FFT','Harmonique',true);
     grapheOsc.TestPente := ReadBool('Synchro','TestPente',false);
     va := readInteger('Affichage','Abscisse',0);
     if (va<low(indiceVoieYD)) or (va>high(indiceVoieYD)) then va := 0;
     with grapheOsc do begin
         PenWidth := readInteger('Affichage','PenWidth',1);
         AnalyseurLogique := ReadBool('Oscillo','AnalLog',false);
         Nbre := 0;
     end;
     graphePoint.penWidth := grapheOsc.penWidth;
     graphePoint.voieAbscisse := va;
     graphePoint.Nbre := 0;
     for i := 0 to MaxVecteur do
         graphePoint.entreeClavier.vecteurAff[i] := sansSignif;
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
         section := 'Voie'+intToStr(voie);
     with graphePoint.voieOrphy[voie] do begin
         active := ReadBool(section,'ActiveP',voie=0);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         if not active
            then calibreCB.ItemIndex := 6
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         nom := ReadString(section,'NomP',nom);
     end;
     with grapheOsc.voieOrphy[voie] do begin
         active := ReadBool(section,'Active',voie=0);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         if not active
            then calibreCB.ItemIndex := 6
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         grapheFFT.voieOrphy[voie].active := active;
         grapheFFT.voieOrphy[voie].maxi := maxi;
         nom := ReadString(section,'Nom',nom);
     end;
     end;// for voie
     with graphePoint.entreeClavier do begin
         section := 'Clavier';
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         nom := ReadString(section,'NomP',nom);
     end;
     for voie := voieG to voieJ do begin
     section := 'VoieGTS'+intToStr(voie);
     with grapheOsc.voieGTS2[voie] do begin
         active := ReadBool(section,'Active',false);
         if not active
            then diffRG.itemIndex := 2
            else diffRG.itemIndex := ReadInteger(section,'Diff',0);
         Mini := ReadFloat(section,'Mini',-15);
         Maxi := ReadFloat(section,'Maxi',+15);
         if not active
            then calibreCB.ItemIndex := 5
            else calibreCB.ItemIndex := ReadInteger(section,'Calibre',6);
         zeroCB.checked := ReadBool(section,'Positif',false);
         grapheFFT.voieGTS2[voie].active := active;
         grapheFFT.voieGTS2[voie].maxi := maxi;
         nom := ReadString(section,'Nom',nom);
     end;
     end;// for voie
     if fileExists(FichierConfigAdmin)
        then litConfig(fichierConfigAdmin)
        else if fileExists(FichierConfig) then litConfig(fichierConfig);
  end; // with fichier
  fichier.free;
  gti2.load;
  except
  end;
end; // litConfigReg

procedure InitPoint;
begin
  graphePoint := TgraphePoint.create;
  graphePoint.canvas := TempsPaintBox.canvas;
  graphePoint.paintBox := TempsPaintBox;

  graphePoint.voieOrphy[0].diffRG := radioGroup1;
  graphePoint.voieOrphy[0].calibreCB := comboBox0;
  graphePoint.voieOrphy[0].zeroCB := checkBox10;
  graphePoint.voieOrphy[0].GBvoie := groupBox6;
  graphePoint.voieOrphy[0].labelValeur := label2;
  graphePoint.voieOrphy[0].shape := shape1;

  graphePoint.voieOrphy[1].diffRG := radioGroup2;
  graphePoint.voieOrphy[1].calibreCB := comboBox1;
  graphePoint.voieOrphy[1].zeroCB := checkBox5;
  graphePoint.voieOrphy[1].GBvoie := groupBox7;
  graphePoint.voieOrphy[1].labelValeur := label1;
  graphePoint.voieOrphy[1].shape := shape2;

  graphePoint.voieOrphy[2].diffRG := radioGroup3;
  graphePoint.voieOrphy[2].calibreCB := comboBox2;
  graphePoint.voieOrphy[2].zeroCB := checkBox6;
  graphePoint.voieOrphy[2].GBvoie := groupBox2;
  graphePoint.voieOrphy[2].labelValeur := label4;
  graphePoint.voieOrphy[2].shape := shape3;

  graphePoint.voieOrphy[3].diffRG := radioGroup4;
  graphePoint.voieOrphy[3].calibreCB := comboBox3;
  graphePoint.voieOrphy[3].zeroCB := checkBox7;
  graphePoint.voieOrphy[3].GBvoie := groupBox1;
  graphePoint.voieOrphy[3].labelValeur := label5;
  graphePoint.voieOrphy[3].shape := shape4;

end;

procedure initDB15;
var i,j : integer;
    voie : indiceVoieYD;
begin
    with DB15Panel do
    for i := 0 to pred(controlCount) do begin
         voie := TGroupBox(controls[i]).tag;
         with grapheOsc.voieDB15[voie] do begin
            GBvoie := TgroupBox(controls[i]);
            for j := 0 to pred(GBvoie.controlCount) do begin
                if GBvoie.controls[j] is Tlabel then LabelVoie := Tlabel(GBvoie.controls[j]);
                if GBvoie.controls[j] is TprogressBar then BarVoie := TprogressBar(GBvoie.controls[j]);
                if GBvoie.controls[j] is Tbevel then BevelVoie := Tbevel(GBvoie.controls[j]);
                if GBvoie.controls[j] is TspeedButton then SpeedVoie := TspeedButton(GBvoie.controls[j]);                                
            end;
            if not isXP then begin
               LabelVoie.Font.color := clWhite;
               GBVoie.Font.color := clWhite;
            end;
         end;
    end;
end;

var voie : indiceVoieYD;
    calibre : Tcalibre;
    winVersion : shortString;
    numVersion : integer;
    carac : char;
begin
   isXP := false;
   winVersion := winInfo.winVerNo;
   if length(winVersion)>=3 then begin
          carac := winVersion[1];
          if carac in ['0'..'9']
             then numVersion := 10*(ord(carac)-ord('0'))
             else numVersion := 0;
          carac := winVersion[3];
          if carac in ['0'..'9'] then numVersion := numVersion+ord(carac)-ord('0');
          isXP := numVersion>=51;
   end;
  initialisation := true;
  premiereFois := true;
  LedGBF := lGray;
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  DureeUpDown.Max := ord(high(TbaseDeTemps));

  grapheFFT := TgrapheOsc.create;
  grapheFFT.trace := tLigne;
  grapheFFT.canvas := FFTPaintBox.canvas;
  grapheFFT.paintBox := FFTPaintBox;
  grapheFFT.voieTemps.nom := 'f';
  grapheFFT.voieTemps.nomUnite := 'Hz';
  grapheFFT.voieTemps.mini := 0;
  grapheFFT.nbre := 64;
  grapheFFT.voieSynchro := voieT;
  grapheFFT.AnalyseurLogique := true;
  for voie := low(indiceVoieYD) to high(indiceVoieYD) do
      grapheFFT.voieOrphy[voie].Mini := 0;

  grapheOsc := TgrapheOsc.create;
  grapheOsc.canvas := TempsPaintBox.canvas;
  grapheOsc.paintBox := TempsPaintBox;

  gti2 := TGTI2.create;
  grapheOsc.voieOrphy[0].diffRG := radioGroup1;
  grapheOsc.voieOrphy[0].shape := shape1;
  grapheOsc.voieOrphy[0].calibreCB := comboBox0;
  grapheOsc.voieOrphy[0].zeroCB := checkBox10;
  grapheOsc.voieOrphy[0].GBvoie := groupBox6;
  grapheOsc.voieOrphy[0].labelValeur := label2;

  grapheOsc.voieOrphy[1].diffRG := radioGroup2;
  grapheOsc.voieOrphy[1].shape := shape2;
  grapheOsc.voieOrphy[1].calibreCB := comboBox1;
  grapheOsc.voieOrphy[1].zeroCB := checkBox5;
  grapheOsc.voieOrphy[1].GBvoie := groupBox7;
  grapheOsc.voieOrphy[1].labelValeur := label1;

  grapheOsc.voieOrphy[2].diffRG := radioGroup3;
  grapheOsc.voieOrphy[2].shape := shape3;
  grapheOsc.voieOrphy[2].calibreCB := comboBox2;
  grapheOsc.voieOrphy[2].zeroCB := checkBox6;
  grapheOsc.voieOrphy[2].GBvoie := groupBox2;
  grapheOsc.voieOrphy[2].labelValeur := label4;

  grapheOsc.voieOrphy[3].diffRG := radioGroup4;
  grapheOsc.voieOrphy[3].shape := shape4;
  grapheOsc.voieOrphy[3].calibreCB := comboBox3;
  grapheOsc.voieOrphy[3].zeroCB := checkBox7;
  grapheOsc.voieOrphy[3].GBvoie := groupBox1;
  grapheOsc.voieOrphy[3].labelValeur := label5;

  grapheOsc.voieGTS2[voieG].diffRG := radioGroup5;
  grapheOsc.voieGTS2[voieG].shape := shape6;
  grapheOsc.voieGTS2[voieG].calibreCB := comboBox5;
  grapheOsc.voieGTS2[voieG].zeroCB := checkBox2;
  grapheOsc.voieGTS2[voieG].GBvoie := groupBox10;

  grapheOsc.voieGTS2[voieH].diffRG := radioGroup6;
  grapheOsc.voieGTS2[voieH].shape := shape7;
  grapheOsc.voieGTS2[voieH].calibreCB := comboBox6;
  grapheOsc.voieGTS2[voieH].zeroCB := checkBox3;
  grapheOsc.voieGTS2[voieH].GBvoie := groupBox11;

  grapheOsc.voieGTS2[voieI].diffRG := radioGroup7;
  grapheOsc.voieGTS2[voieI].shape := shape8;
  grapheOsc.voieGTS2[voieI].calibreCB := comboBox7;
  grapheOsc.voieGTS2[voieI].zeroCB := checkBox4;
  grapheOsc.voieGTS2[voieI].GBvoie := groupBox12;

  grapheOsc.voieGTS2[voieJ].diffRG := radioGroup8;
  grapheOsc.voieGTS2[voieJ].shape := shape5;
  grapheOsc.voieGTS2[voieJ].calibreCB := comboBox4;
  grapheOsc.voieGTS2[voieJ].zeroCB := checkBox1;
  grapheOsc.voieGTS2[voieJ].GBvoie := groupBox9;

  for voie := low(indiceVoieYD) to high(indiceVoieYD) do
      with grapheOsc.voieOrphy[voie].calibreCB do begin
           items.clear;
           for calibre := low(Tcalibre) to high(Tcalibre) do
               items.add(calibreStr[calibre]);
      end;
  for voie := voieG to voieJ do
      with grapheOsc.voieGTS2[voie].calibreCB do begin
           items.clear;
           for calibre := low(Tcalibre) to high(Tcalibre) do
               items.add(calibreStr[calibre]);
      end;
  InitPoint;
  InitDB15;
  setDefaut;
  LitConfigReg;
  initialisation := false;
end;

procedure TGTI2MainForm.ShowHint(Sender: TObject);
begin
   if Application.Hint=''
      then Caption := 'Acquisition par GTI II pour Regressi'
      else begin
          Caption := Application.Hint;
          Header.SimpleText := Application.Hint;
      end
end;

procedure TGTI2MainForm.FileExit(Sender: TObject);
begin
   Close
end;

procedure TGTI2MainForm.HelpAbout(Sender: TObject);
begin
    GTI2AboutBox.ShowModal
end;

procedure tGTI2MainForm.AfficheReglage;

procedure AfficheReglagePoint;
var voie : indiceVoieYD;
    calibre : Tcalibre;
    i : integer;
begin with graphePoint do begin
   avecClavier := false;
   FFTbtn.Visible := false;
   FFTbtn.down := false;
   abscisseRG.Visible := true;
   affecteStop(false);
   ProgressBarGTI2.visible := false;
   GbfBtn.down := false;
   GbfBtn.visible := false;
   GBFPanel.Visible := false;
   majGbfBtn.visible := false;
   timerGBF.Enabled := false;
   PointGB.Visible := true;
   ClavierGB.visible := false;
   PanelTemps.Visible := false;
   EnregistreBtn.visible := false;
   EnregistrePointBtn.visible := true;
   EnregistrePointBtn.enabled := true;
   case ModePpPRG.ItemIndex of
          0 : begin
              Header.simpleText := hPointManuel;
              LabelAuto.caption := 'Clic ou barre';
          end;
          1 : begin
               Header.simpleText := hPointAttente;
               LabelAuto.caption := 'Variation (%)';
          end;
          2 : begin
               Header.simpleText := hPointAttente;
               LabelAuto.caption := 'Deltat (s)';
          end;
   end;
   DeltaPointSE.Visible := ModePpPRG.itemIndex>0;
   EnregistrePointBtn.caption := 'Enregistrer';
   if ModePpPRG.itemIndex=0
      then EnregistrePointBtn.hint := 'Enregistrer le point courant'
      else EnregistrePointBtn.hint := 'Lancer l''acquisition';
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       with voieOrphy[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
   undoBtn.visible := ModePpPRg.itemIndex<>2;
   resetBtn.visible := true;
   undoBtn.enabled := Nbre>0;
   resetBtn.enabled := Nbre>0;
   voieAbscisse := abscisseRG.ItemIndex;
   NbreCourbes := 0;
   PanelDureePoint.Caption := '';
   PanelDureePoint.visible := ModePpPRG.itemIndex=2;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
       voieOrphy[voie].active := voieOrphy[voie].diffRG.itemIndex<2;
       if voieOrphy[voie].active then inc(NbreCourbes);
   end;
   if nbreCourbes<2 then
      for voie := low(indiceVoieYD) to high(indiceVoieYD) do
          with voieOrphy[voie] do if not active then begin
                 active := true;
                 DiffRg.ItemIndex := 0;
                 inc(NbreCourbes);
                 if NbreCourbes>=2 then break;
          end;
   if not(voies[voieAbscisse].active) then begin
          voieAbscisse := 0;
          while not voies[voieAbscisse].active do
                  inc(voieAbscisse);
   end;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       with voieOrphy[voie] do begin
          gti2.active[voie] := active;
          LabelValeur.Visible := active;
          calibreCB.visible := active;
          zeroCB.visible := active;
          shape.visible := active;
       if active then begin
          gti2.differentiel[voie] := diffRG.itemIndex=0;
          shape.brush.color := couleur;
          LabelValeur.font.Color := couleur;
          gti2.calibre15V[voie] := maxi>5;
          GBvoie.Caption := 'Voie '+intTostr(voie)+' : '+nom;
       end
       else begin
          shape.brush.color := clBtnFace;
          GBvoie.Caption := 'Voie '+intTostr(voie);
       end;
   end;
   for i := 0 to 3 do
       case voieOrphy[i].diffRG.itemIndex of
          0 : abscisseRG.Items[i] := 'YD'+intTostr(i);
          1 : abscisseRG.Items[i] := 'Y'+intTostr(i)+' BNC';
          2 : abscisseRG.Items[i] := '';
       end;
   if ModePpPRG.itemIndex=2
      then begin
          if abscisseRG.items.count=4 then abscisseRG.Items.Add('Temps');
      end
      else begin
          if abscisseRG.items.count=5 then abscisseRG.Items.Delete(4);
      end;
   voies[4].active := ModePpPRG.itemIndex=2;
   TempsPaintBox.refresh;
   edit1.SetFocus;
   gti2.lanceAcqLente;
   timerPoint.enabled := true;
   premierTrace := true;
   initialisation := false;
   autosetBtn.visible := false;
end end; // afficheReglagePoint

procedure AfficheReglageClavier;
var voie : indiceVoieYD;
    calibre : Tcalibre;
    i : integer;
begin with graphePoint do begin
   avecClavier := true;
   NbreVoieOrphyClavier := 0;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do with voieOrphy[voie] do begin
       active := diffRG.itemIndex<2;
       if active then begin
             voieOrphyClavier[NbreVoieOrphyClavier] := voieOrphy[voie];
             inc(NbreVoieOrphyClavier);
             if NbreVoieOrphyClavier>maxVoieOrphyClavier then break;
        end;
   end;
   if nbreVoieOrphyClavier=0 then begin
      voie := low(indiceVoieYD);
      with voieOrphy[voie] do begin
           active := true;
           voieOrphyClavier[0] := voieOrphy[voie];
           DiffRg.ItemIndex := 0;
           NbreVoieOrphyClavier := 1;
      end;
   end;
   NbreCourbes := NbreVoieOrphyClavier;
   ClavierGrid.DefaultColWidth := ClavierGrid.width div (NbreVoieOrphyClavier+1);
   ClavierGrid.colCount := NbreVoieOrphyClavier+1;
   ClavierGrid.cells[0,0] := entreeClavier.nom;
   for i := 0 to pred(NbreVoieOrphyClavier) do
       ClavierGrid.cells[i+1,0] := voieOrphyClavier[i].nom;
   ClavierGB.caption := entreeClavier.nom+' au clavier';
   ClavierGB.visible := true;
   setFocusGrid;
   FFTbtn.Visible := false;
   FFTbtn.down := false;
   abscisseRG.Visible := false;
   affecteStop(false);
   ProgressBarGTI2.visible := false;
   GbfBtn.down := false;
   GbfBtn.visible := false;
   GBFPanel.Visible := false;
   majGbfBtn.visible := false;
   timerGBF.Enabled := false;
   PointGB.Visible := false;
   PanelTemps.Visible := false;
   EnregistreBtn.visible := false;
   EnregistrePointBtn.visible := false;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       with voieOrphy[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
   undoBtn.visible := true;
   resetBtn.visible := true;
   undoBtn.enabled := Nbre>0;
   resetBtn.enabled := Nbre>0;
   PanelDureePoint.visible := false;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       with voieOrphy[voie] do begin
          gti2.active[voie] := active;
          LabelValeur.Visible := active;
          calibreCB.visible := active;
          zeroCB.visible := active;
          shape.visible := active;
       if active then begin
          gti2.differentiel[voie] := diffRG.itemIndex=0;
          shape.brush.color := couleur;
          LabelValeur.font.Color := couleur;
          gti2.calibre15V[voie] := maxi>5;
          GBvoie.Caption := 'Voie '+intTostr(voie)+' : '+nom;
       end
       else begin
          shape.brush.color := clBtnFace;
          GBvoie.Caption := 'Voie '+intTostr(voie);
       end;
   end;
   for i := 0 to 3 do
       case voieOrphy[i].diffRG.itemIndex of
          0 : abscisseRG.Items[i] := 'YD'+intTostr(i);
          1 : abscisseRG.Items[i] := 'Y'+intTostr(i)+' BNC';
          2 : abscisseRG.Items[i] := '';
       end;
   TempsPaintBox.refresh;
   edit1.SetFocus;
   gti2.lanceAcqLente;
   timerPoint.enabled := true;
   premierTrace := true;
   initialisation := false;
   autosetBtn.visible := false;
end end; // afficheReglageClavier

Procedure AfficheReglageOsc;
var voie : indiceVoieYD;
    calibre : Tcalibre;
    i : integer;
begin with grapheOsc do begin
   avecGTS2 := gti2.withGTS2=gts2_EAD;
   GbfBtn.visible := true;
   ClavierGB.visible := false;
   FFTperiode.checked := fft.AnalyseHarmonique;
   FFTbtn.visible := true;
   FFTgb.Visible := FFTbtn.Down;
   UndoBtn.Visible := false;
   abscisseRG.Visible := false;
   ResetBtn.Visible := false;
   PanelTemps.Visible := true;
   ProgressBarGTI2.visible := true;
   PointGB.Visible := false;
   if stopEnCours then stopBtnClick(nil);
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
       with voieOrphy[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
       with voieGTS2[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
   end;
   GBFPanel.Visible := GbfBtn.down;
   if not GBFPanel.visible then begin
      timerGBF.Enabled := false;
      majGbfBtn.visible := false;
   end;
   PanelDureePoint.visible := false;
   dureeEdit.Text := BaseDeTempsStr[gti2.baseDeTemps];
   grapheOsc.NbreMaxi := gti2.nbrePoints;
   FechEdit.Text := frequence.formatUnite(gti2.freqEch);
   nbreEdit.text := intToStr(gti2.nbrePoints);
   EnregistrePointBtn.visible := false;
   EnregistreBtn.visible := true;   
   EnregistreBtn.caption := 'Enregistrer';
   NbreCourbes := 0;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
         with voieOrphy[voie] do begin
              LabelValeur.Visible := active and (gti2.baseDeTemps>b1);
              LabelValeur.caption := '';
              if active then inc(NbreCourbes);
        end;
    if nbreCourbes=0 then with voieOrphy[0] do begin
       active := true;
       DiffRG.itemIndex := 0;
       LabelValeur.Visible := gti2.baseDeTemps>b1;
       LabelValeur.caption := '';
       NbreCourbes := 1;
    end;
    gti2.voieSynchro := synchroRG.itemIndex;
    gti2.montant := sensRG.itemIndex=1;
    preAcqCB.Visible := gti2.voieSynchro>0;
    MonocoupCB.visible := gti2.voieSynchro>0;
    if synchroRG.itemIndex>0
        then begin
            synchroRG.hint := trModifSeuil+trDuGraphe;
            voieSynchro := synchroRG.itemIndex-1;
            grapheFFT.voieSynchro := voieSynchro;
            if not voieOrphy[voieSynchro].active then begin
               voieSynchro := 0;
               while not voieOrphy[voieSynchro].active do
                     inc(voieSynchro);
               synchroRG.itemIndex := 1+voieSynchro;
            end;
            seuilGB.Caption := 'Seuil : '+voieOrphy[voieSynchro].nom+' (V)';
            if voieSynchro<>voieT then
              with voieOrphy[grapheOsc.voieSynchro] do begin
                 seuilEdit.text := FormatSynchro(seuilSynchro);
                 seuilEdit.font.Color := Couleur;
               end;
        end
        else begin
            grapheOsc.voieSynchro := voieT;
            grapheFFT.voieSynchro := voieT;
            synchroRG.hint := '';
        end;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
       with voieOrphy[voie] do begin
          calibreCB.visible := active;
          zeroCB.visible := active;
          gti2.active[voie] := active;
          shape.visible := active;
          grapheFFT.voieOrphy[voie].active := active;
          grapheFFT.voieOrphy[voie].maxi := maxi;
       if active then begin
          gti2.differentiel[voie] := diffRG.itemIndex=0;
          shape.brush.color := couleur;
          gti2.calibre15V[voie] := maxi>5;
          GBvoie.Caption := 'Voie '+intTostr(voie)+' : '+nom;
       end
       else begin
          shape.brush.color := clBtnFace;
          GBvoie.Caption := 'Voie '+intTostr(voie);
       end;
       end;
       with voieGTS2[voie] do begin
          calibreCB.visible := active;
          zeroCB.visible := active;
          gti2.activeGts2[voie] := active;
          shape.visible := active;
          grapheFFT.voieGTS2[voie].active := active;
          grapheFFT.voieGTS2[voie].maxi := maxi;
       if active then begin
          gti2.diffGts2[voie] := diffRG.itemIndex=0;
          shape.brush.color := couleur;
          GBvoie.Caption := 'Prise '+char(voie-voieG+ord('G'))+' : '+nom;
          inc(NbreCourbes);
       end
       else begin
          shape.brush.color := clBtnFace;
          GBvoie.Caption := 'Voie prise '+char(voie-voieG+ord('G'));
       end;
       end;
   end;
   preTrig := preAcqCB.visible and preAcqCB.checked;       
   montant := sensRG.itemIndex=1;
   MonocoupCB.visible := synchroRG.itemIndex>0;
   grapheOsc.monocoup := MonocoupCB.visible and MonocoupCB.checked;
   sensRG.Visible := synchroRG.itemIndex>0;
   seuilGB.Visible := synchroRG.itemIndex>0;
   if pretrig
      then voieTemps.Mini := -dureeBalayage[gti2.baseDeTemps]/10 // 500/5000 = 10%
      else voieTemps.Mini := 0;
   voieTemps.Maxi := voieTemps.Mini + dureeBalayage[gti2.baseDeTemps];
   for i := 1 to 4 do
       case voieOrphy[i-1].diffRG.itemIndex of
          0 : synchroRG.Items[i] := 'YD'+intTostr(i-1);
          1 : synchroRG.Items[i] := 'Y'+intTostr(i-1)+' BNC';
          2 : synchroRG.Items[i] := '';
       end;
   avecSegment := (monocoupCB.checked or not monocoupCB.visible) and
       (gti2.baseDeTemps>baseDeTempsLente);
   avecSegmentLabel.caption := TexteAvecSegment[avecSegment];
   TempsPaintBox.refresh;
   gti2.etalonnage := true;
   EnregistreBtn.Enabled := monocoupCB.checked or
                           (synchroRG.itemIndex=0) or
                            monocoupTemporaire;
// pour lancement par clavier
   initialisation := false;
   autosetBtn.visible := true;
   if monocoupCB.visible // sinon lancement par clavier
      and not monocoupCB.checked
          then lanceAcq;
end end; // afficheReglageOsc

begin
   PanelGTS2.Visible := (gti2.withGTS2=gts2_EAD) and
                        (modeAcq=mTemps) and
                        (synchroRG.itemIndex>0);
   GBFPanel.Visible := (modeAcq=mTemps) and GbfBtn.down;
   if GBFPanel.visible
   then MajGBF(lGreen)
   else begin
      GbfBtn.down := false;
      majGbfBtn.visible := false;
   end;
   initialisation := true;
   timer.enabled := false;
   timerPoint.enabled := false;
   timerGBF.enabled := false;
   case modeAcq of
      mPointParPoint : AfficheReglagePoint;
      mTemps : afficheReglageOsc;
      mClavier : afficheReglageClavier;
   end;
   monocoupTemporaire := false;
end; // afficheReglage

procedure TGTI2MainForm.TempsPaintBoxPaint(Sender: TObject);

procedure CalculSpectre;
var voie : indiceVoieYD;
    deltaF : double;
    nbreF,i : integer;
begin
       for voie := low(indiceVoieYD) to high(indiceVoieYD) do
           if grapheOsc.voieOrphy[voie].active then
                spectreAmplitude(grapheOsc.Nbre,
                                 grapheOsc.voieOrphy[voie].vecteurAff,
                                 grapheFFT.voieOrphy[voie].vecteurAff,
                                 grapheFFT.voieTemps.vecteurAff,NbreF);
       grapheFFT.Nbre := NbreF div 2;
       grapheFFT.NbreAff := NbreFreqAff;                                 
       deltaF := gti2.FreqEch/NbreF;
       grapheFFT.voieTemps.maxi := grapheFFT.NbreAff*deltaF;
       with grapheFFT.voieTemps do
            for i := 0 to pred(NbreF) do
                vecteurAff[i] := vecteurAff[i]*deltaF;
       FFTok := true;                
       FFTPaintBox.refresh;
end;

procedure CalculHarmoniques;
var indexPeriode : integer;
    periode,deltaF : double;
    xint : integer;
    voie : indiceVoieYD;
    i,nbreF : integer;
begin
        calculAutoCorrelation(grapheOsc.Nbre,
              grapheOsc.voieOrphy[grapheOsc.voieSynchro].vecteurAff,Xa,indexPeriode);
        if indexPeriode>64 then begin
             grapheOsc.SetIndexPeriode(indexPeriode);
             periode := indexPeriode/gti2.Freqech;
             xint := grapheOsc.voieTemps.Xwindow(periode);
             TempsPaintBox.Canvas.pen.Style := psDot;
             TempsPaintBox.Canvas.pen.Color := clHotLight;
             TempsPaintBox.Canvas.MoveTo(xint,0);
             TempsPaintBox.Canvas.LineTo(xint,TempsPaintBox.height);
             for voie := low(indiceVoieYD) to high(indiceVoieYD) do
                 with grapheOsc.voieOrphy[voie] do if active then
                      spectreAmplitude(indexPeriode,vecteurAff,
                                       grapheFFT.voieOrphy[voie].vecteurAff,
                                       grapheFFT.voieTemps.vecteurAff,nbreF);
             deltaF := 1/periode;
             grapheFFT.Nbre := NbreF;
             grapheFFT.NbreAff := NbreHarmoniqueAff;
             grapheFFT.voieTemps.maxi := NbreHarmoniqueAff*deltaF;
             with grapheFFT.voieTemps do
                  for i := 0 to pred(NbreF) do
                      vecteurAff[i] := vecteurAff[i]*deltaF;
             FFTok := true;
             FFTPaintBox.refresh;
          end
          else begin
              FFTok := false;
              FFTPaintBox.canvas.Brush.Color := clWindow;
              FFTPaintBox.canvas.FillRect(FFTPaintBox.clientRect);
              FFTPaintBox.canvas.textOut(FFTPaintBox.width div 3,
                                         FFTPaintBox.height div 2,
                                         'Priode non trouve')
          end;
end;

begin
     case modeAcq of
        mPointParPoint : begin
           graphePoint.draw;
           ReticuleTrace := false;
           marquePointCourant;
        end;
        mTemps : begin
           grapheOsc.draw;
           if FFTbtn.down and
              (grapheOsc.Nbre>512) and
              (grapheOsc.voieSynchro<>voieT) then if analyseHarmonique
                 then calculHarmoniques
                 else calculSpectre;
           CacheCurseur;
       end;
       mClavier : begin
           graphePoint.draw;
           ReticuleTrace := false;
           marquePointCourant;
       end;
     end;
end; // TempsPaintBoxPaint

procedure TGTI2MainForm.EcritConfig(NomFichier : string);
var Fichier : TMemIniFile;
    voie : indiceVoieYD;
    section : shortString;
    i : integer;
begin
    NomFichier := ChangeFileExt(NomFichier,'.GTI2');
    try
    Fichier := TMemIniFile.create(NomFichier);
    with Fichier do begin
       for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
       section := 'Voie'+intToStr(voie);
       with grapheOsc.voieOrphy[voie] do begin
           WriteBool(section,'Active',active);
           WriteInteger(section,'Diff',DiffRG.itemIndex);
           WriteInteger(section,'Calibre',calibreCB.ItemIndex);
           WriteBool(section,'Positif',zeroCB.checked);
           WriteString(section,'Nom',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       with graphePoint.voieOrphy[voie] do begin
           WriteBool(section,'ActiveP',active);
           WriteString(section,'NomP',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       section := 'VoieGTS'+intToStr(voie);
       with grapheOsc.voieGTS2[voie] do begin
           WriteBool(section,'Active',active);
           WriteInteger(section,'Diff',DiffRG.itemIndex);
           WriteInteger(section,'Calibre',calibreCB.ItemIndex);
           WriteBool(section,'Positif',zeroCB.checked);
           WriteString(section,'Nom',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       end;
       with graphePoint.entreeClavier do begin
           section := 'Clavier';
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
           WriteString(section,'NomP',nom);
       end;
       WriteInteger('GTI2','Interpolation',ord(grapheOsc.interpolation));

       WriteInteger('Temps','Duree',DureeUpDown.position);
       WriteInteger('Mode','Point',ord(modeAcq));
       WriteInteger('Mode','GTS2',ord(gti2.withGts2));
       WriteInteger('Synchro','Mode',synchroRG.ItemIndex);
       WriteInteger('Synchro','Sens',sensRG.ItemIndex);
       WriteFloat('Synchro','Seuil',gti2.seuilVolt);
       WriteBool('Synchro','PreAcq',preAcqCB.checked);
       WriteBool('Synchro','Monocoup',MonocoupCB.checked);

       WriteInteger('GBF','Amplitude',amplitudeScroll.position);
       WriteInteger('GBF','Signal',signalRG.ItemIndex);
       WriteInteger('GBF','Duty',dutyScroll.position);
       WriteInteger('GBF','Offset',offsetScroll.position);
       WriteString('GBF','Frequence',LCD10k.value);
       WriteString('GBF','Expression',gbf.expression);
       WriteBool('GBF','Actif',GBFbtn.Down);
       WriteBool('GBF','Monocoup',monocoupgbfCB.checked);
       if signalRG.ItemIndex=ord(sdata) then begin
          WriteInteger('GBF','NbreData',gbf.nbreData);
          WriteInteger('GBF','GainData',gbf.GainData);          
          WriteInteger('GBF','FreqEch',gbf.freqEchData);
          for i := 0 to pred(gbf.NbreData) do
              WriteFloat('GBF','Data'+intToStr(i),gbf.dataReal[i]);
       end;
   end;
   fichier.UpdateFile;
   fichier.free;
   except
   end;
end;

procedure TGTI2MainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);

procedure WriteFormPlacement;
var
  ini : TregIniFile;
begin
  try
  Ini := TregIniFile.create(RegistreGTI2);
  Ini.WriteInteger('Window','State',ord(WindowState));
  Ini.WriteInteger('Window','Height',height);
  Ini.WriteInteger('Window','Width',width);
  Ini.WriteInteger('Window','Top',top);
  Ini.WriteInteger('Window','Left',left);
  Ini.free;
  except
  end;
end;

Procedure EcritConfigReg;
var Fichier : TRegistryIniFile;
    section : shortString;
    voie : indiceVoieYD;
begin
   try
   Fichier := TRegistryIniFile.create(RegistreGTI2);
   with fichier do begin
       WriteInteger('Affichage','DimPoint',dimPoint);
       WriteInteger('Affichage','PenWidth',grapheOsc.penWidth);
       WriteInteger('Affichage','WidthCursor',WidthCursor);
       writeBool('Affichage','Grille',grille);
       WriteInteger('Point','Auto',ModePpPRG.itemIndex);
       WriteInteger('Point','PourCent',DeltaPointSE.value);
       writeInteger('Affichage','Abscisse',graphePoint.voieAbscisse);
       with grapheOsc do begin
          WriteBool('Oscillo','AnalLog',AnalyseurLogique);
          WriteInteger('Oscillo','NbreMaxi',grapheOsc.NbreMaxi);
          WriteBool('Synchro','TestPente',TestPente);
       end;
       for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
           section := 'Voie'+intToStr(voie);
       with grapheOsc.voieOrphy[voie] do begin
           WriteBool(section,'Active',active);
           WriteInteger(section,'Diff',DiffRG.itemIndex);
           WriteInteger(section,'Calibre',calibreCB.ItemIndex);
           WriteBool(section,'Positif',zeroCB.checked);
           WriteString(section,'Nom',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       with graphePoint.voieOrphy[voie] do begin
           WriteBool(section,'ActiveP',active);
           WriteString(section,'NomP',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       section := 'VoieGTS'+intToStr(voie);
       with grapheOsc.voieGTS2[voie] do begin
           WriteBool(section,'Active',active);
           WriteInteger(section,'Diff',DiffRG.itemIndex);
           WriteInteger(section,'Calibre',calibreCB.ItemIndex);
           WriteBool(section,'Positif',zeroCB.checked);
           WriteString(section,'Nom',nom);
           WriteFloat(section,'Mini',Mini);
           WriteFloat(section,'Maxi',Maxi);
       end;
       end;
       UpdateFile;
   end;
   Fichier.free;
   if sauverConfig then EcritConfig(FichierConfig);
   gti2.store;
   except
   end;
end; // EcritConfigReg

begin
     Fermeture := true;
     DebutLectureParametres;
     writeFormPlacement;
     if gti2.isOpen then begin
        case modeAcq of
           mPointParPoint : gti2.stopAcqlente;
           mTemps : if stopEnCours then stopBtnClick(sender);
           mClavier : gti2.stopAcqlente;
        end;
        EcritConfigReg;
     end;
end; // FormClose

procedure TGTI2MainForm.RegSaveBtnClick(Sender: TObject);
begin
   debutLectureParametres;
   if ConstanteDlg.showModal=mrOk
      then case modeAcq of
        mPointParPoint : DDEForm.EnvoieDonneesPoint;
        mTemps : DDEForm.EnvoieDonneesOsc;
        mClavier : DDEForm.EnvoieDonneesClavier;
      end;
   finLectureParametres;
   if (modeAcq=mTemps) and
      monocoupCB.visible and                            
      not monocoupCB.checked then lanceAcq;
end;

procedure TGTI2MainForm.HelpBtnClick(Sender: TObject);
begin
//    Application.HelpCommand(HELP_CONTENTS, 0)
end;

procedure TGTI2MainForm.EscapeBtnClick(Sender: TObject);
begin
     Application.Terminate
end;

procedure TGTI2MainForm.OptionsBtnClick(Sender: TObject);
begin
    DebutLectureParametres;
    if (OptionsDlg.showModal=mrOK)
       then AfficheReglage
       else finLectureParametres;
end;

procedure TGTI2MainForm.DureeUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  if newValue>dureeUpDown.max then exit;
  if newValue<dureeUpDown.min then exit;
  gti2.baseDeTemps := TbaseDeTemps(newValue);
  dureeEdit.text := BaseDeTempsStr[gti2.baseDeTemps];
  grapheOsc.NbreMaxi := gti2.nbrePoints;
  fechEdit.Text := frequence.formatUnite(gti2.freqEch);
  nbreEdit.text := intToStr(gti2.NbrePoints);
  preAcqCB.Visible := gti2.voieSynchro>0;
  if not initialisation then begin
     affecteStop(false);
     if grapheOsc.pretrig
        then grapheOsc.voieTemps.Mini := -dureeBalayage[gti2.baseDeTemps]/10
        else grapheOsc.voieTemps.Mini := 0;
     grapheOsc.voieTemps.Maxi := grapheOsc.voieTemps.Mini + dureeBalayage[gti2.baseDeTemps];
     TempsPaintBox.invalidate;
     PanelDuree.visible := gti2.baseDeTemps>b5;
     PanelDuree.caption := '';
     avecSegment := (monocoupCB.checked or not monocoupCB.visible) and
          (gti2.baseDeTemps>baseDeTempsLente);
     avecSegmentLabel.caption := TexteAvecSegment[avecSegment];
     if (dureeBalayage[gti2.baseDeTemps]>10) and
         monoForcePermis then monocoupCB.checked := true;
     grapheOsc.monocoup := MonocoupCB.visible and MonocoupCB.checked;
     if monocoupCB.visible and
        not monocoupCB.checked and
        gti2.isOpen then lanceAcq;
  end;
end;

procedure TGTI2MainForm.SynchroRGClick(Sender: TObject);
var newSynchro : integer;
begin
    if initialisation then exit;
    newSynchro := synchroRG.itemIndex;
    if (newSynchro>0) and not gti2.active[newSynchro-1]
        then synchroRG.itemIndex := gti2.voieSynchro
              // Synchro sur voie non active interdit
        else if gti2.voieSynchro<>synchroRG.itemIndex then afficheReglage;
    edit1.setFocus;
end;

procedure TGTI2MainForm.SensRGClick(Sender: TObject);
begin
    if gti2.montant<>(sensRG.itemIndex=1) and
       not initialisation then afficheReglage;
end;

procedure TGTI2MainForm.FormActivate(Sender: TObject);

Procedure ReadFormPlacement;
var ini : Treginifile;
begin
  premiereFois := false;
  try
        Ini := TregIniFile.create(RegistreGTI2);
        WindowState := TwindowState(Ini.ReadInteger('Window','State',ord(wsMaximized)));
        Height := Ini.ReadInteger('Window','Height',height);
        Width := Ini.ReadInteger('Window','Width',width);
        Top := Ini.ReadInteger('Window','Top',top);
        Left := Ini.ReadInteger('Window','Left',left);
        Ini.free;
  except
  end;
end;
begin
   if premiereFois then begin
      readFormPlacement;
      if not gti2.open then orphyAbsent.visible := true;
   end;
   if gti2.isOpen then afficheReglage
end;

procedure TGTI2MainForm.LanceAcq;
begin
     if fermeture or
        initialisation or
        StopEnCours then begin // ??
           Header.simpleText := '';
           exit;
     end;
     if ActiveControl=nil then edit1.SetFocus;
     progressBarGTI2.position := 0;
     grapheOsc.NbreMaxi := gti2.nbrePoints;
     Header.simpleText := trWaitSynchro;
     if (gti2.baseDeTemps>b1) and
         monocoupCB.visible and
        (monocoupCB.checked) and
        (grapheOsc.Nbre>0)
       then begin
            grapheOsc.monocoup := true;
            grapheOsc.Nbre := 0;
            TempsPaintBox.invalidate;
       end;
     if (gti2.withGTS2=GTS2_EAD) and (gti2.nbreVoiesGTS2>0)
        then begin
            timerGTS2.enabled := true;
            timer.enabled := false;
            progressBarGTI2.max := gti2.nbreTotal+gti2.nbreGTS2;
        end
        else begin
            progressBarGTI2.max := gti2.nbreTotal;
            timer.enabled := true;
            timerGTS2.enabled := false;
        end;
     monocoupTemporaire := false;
     if (gti2.withGTS2=GTS2_DB15) then begin
        if reconnaissance then MajDB15;
        AfficheDB15
     end;
     if GBFbtn.Down and
        not(monocoupGbfCB.checked) and
        (not(gbf.enMarcheContinue) or gbf.majAfaire) then begin
           gbf.Marche;
           setLedGbf(lGreen);
     end;
     dureeMini := dureeBalayage[gti2.baseDeTemps]*1.1; // dure + 10% preAcq
     gti2.LanceAcquisition;
     AcqSuffisante := false;
     affecteStop(true);
end; // LanceAcq

procedure TGTI2MainForm.TempsPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);

procedure AffichePosition;
var Xr,Yr : double;
    voie : indiceVoieYD;
    isGTS2 : boolean;
begin with GrapheOsc do begin
    if GetCourbeProche(x,y,voie,isGTS2) then begin
    if isGts2 then with voieGTS2[voie] do begin
       yr := XMonde(y);
       labelX.font.color := couleur;
       labelY.font.color := couleur;
       shapeCurseur.Brush.Color := couleur;
       labelY.caption := ' '+NomValeurUnite(Yr)+' ';
    end
    else with voieOrphy[voie] do begin
       yr := XMonde(y);
       labelX.font.color := couleur;
       labelY.font.color := couleur;
       shapeCurseur.Brush.Color := couleur;
       labelY.caption := ' '+NomValeurUnite(Yr)+' ';
    end;
       xr := voieTemps.XMonde(x);
       labelX.caption := ' '+voieTemps.NomValeurUnite(Xr)+' ';
       labelX.Top := y+tempsPaintBox.top;
       labelX.Left := x+8;
       labelY.Left := labelX.Left;
       labelY.Top := labelX.Top+16;
       labelX.visible := true;
       labelY.visible := true;
       shapeCurseur.left := x-(shapeCurseur.width div 2);
       shapeCurseur.top := y-(shapeCurseur.height div 2)+tempsPaintBox.top;
       shapeCurseur.visible := true;
       tempsPaintBox.cursor := crCross;
    end
    else CacheCurseur
end end; // AffichePosition

begin
if modeAcq<>mTemps then begin
   cacheCurseur;
   exit;
end;
with grapheOsc do begin
   case curseur of
        curNone : begin
            if (synchroRG.itemIndex>0) and (abs(seuilAff-y)<4)
                then begin
                    TempsPaintBox.hint := hSynchro;
                    TempsPaintBox.cursor := crVsplit;
                    cacheCurseur;
                end
                else begin
                    TempsPaintBox.hint := '';
                    AffichePosition;
                end;
            Header.SimpleText := TempsPaintBox.hint;
        end;
        curSynchro : if ssLeft in Shift then begin
              cacheCurseur;
              TraceSynchro(pointCurseur.Y,false); // efface
              PointCurseur := Point(X,Y);
              TraceSynchro(pointCurseur.Y,true); // retrace
              with voieOrphy[voieSynchro] do
                   SeuilEdit.text := formatSynchro(Xmonde(y));
              CacheCurseur                   
        end;
   end;
end end; // MouseMove

procedure TGTI2MainForm.TempsPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if modeAcq<>mTemps then exit;
with grapheOsc do begin
  curseur := curNone;
  if (synchroRG.itemIndex>0) and
     (abs(seuilAff-y)<4) then begin
     curseur := curSynchro;
     PointCurseur := point(x,seuilAff);
     TempsPaintBox.hint := hSynchro;
     Header.SimpleText := hSynchro;
     TempsPaintBox.cursor := crVsplit;
   end;
end end;

procedure TGTI2MainForm.TempsPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

procedure affecteSynchro;
var newSeuil : double;
begin with grapheOsc,voieOrphy[voieSynchro] do begin
      newSeuil := Xmonde(y);
      gti2.seuilVolt := newSeuil;
      seuilSynchro := gti2.seuilVolt;
      seuilEdit.text := FormatSynchro(seuilSynchro);
      TempsPaintBox.refresh;
//      if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
end end;

begin
   if modeAcq<>mTemps then exit;
   if curseur=curSynchro then affecteSynchro;
   TempsPaintBox.hint := '';
   Header.SimpleText := '';
   TempsPaintBox.cursor := crDefault;
   curseur := curNone;
end;

procedure TGTI2MainForm.MonocoupCBClick(Sender: TObject);
begin
    if initialisation then exit;
    EnregistrePointBtn.Enabled := true;
    EnregistreBtn.Enabled := monocoupCB.checked or
                            (synchroRG.itemIndex=0);
//  gbf.Monocoup := monocoupCB.Checked or (synchroRG.ItemIndex=0);
    if not monocoupCB.checked and
       (synchroRG.itemIndex>0) and
       not StopEnCours then begin
          PremierTrace := true;
          EnregistreBtnClick(sender);
       end;
    if monocoupCB.checked then stopBtnClick(sender);
    if not monocoupCB.checked and
      (dureeBalayage[gti2.baseDeTemps]>10) 
       then monoForcePermis := false;
    avecSegment := (monocoupCB.checked or not monocoupCB.visible) and
         (gti2.baseDeTemps>baseDeTempsLente);
    avecSegmentLabel.caption := TexteAvecSegment[avecSegment];
    grapheOsc.monocoup := MonocoupCB.visible and MonocoupCB.checked;    
    edit1.setFocus;
end;

procedure TGTI2MainForm.TimerTimer(Sender: TObject);
var oldNbre,newNbre : integer;
    dt : double;

procedure TestSegment;
var voie : indiceVoieYD;
    duree : double;
begin
      if (newNbre-oldNbre)*dt>DeltatLent then begin
              grapheOsc.Nbre := newNbre;
              gti2.GetValeurTemps(grapheOsc.voieTemps.vecteurAff);
              Duree := grapheOsc.voieTemps.vecteurAff[pred(grapheOsc.Nbre)];
              PanelDuree.Caption := TimeToStr(duree/SecsPerDay);
              for voie := low(indiceVoieYD) to high(indiceVoieYD) do
                  with grapheOsc.VoieOrphy[voie] do if active then begin
                     gti2.GetValeurVoie(voie,vecteurAff);
                     valeurAff := vecteurAff[pred(grapheOsc.Nbre)];
                     LabelValeur.caption := AffVoltmetre;
                  end;
              if grapheOsc.verifPente
                 then if grapheOsc.penteCorrecte
                     then begin
                        grapheOsc.traceFragments(oldNbre);
                        oldNbre := grapheOsc.Nbre;
                    end
                    else begin
                       EnregistreBtnClick(nil); // nouvel essai
                       exit;
                   end
                 else begin
                      grapheOsc.traceFragments(oldNbre);
                      oldNbre := grapheOsc.Nbre;
                 end;
              if (duree>dureeMini) then begin
                    grapheOsc.setOrigineTemps;
                    AcqSuffisante := grapheOsc.seuilTrouve and
                       (grapheOsc.voieTemps.vecteurAff[pred(grapheOsc.Nbre)]>
                       dureeBalayage[gti2.baseDeTemps]);
              end;
     end;
end;

Procedure TestFini;
var duree : double;
begin
    grapheOsc.NbreTest := newNbre;
    gti2.GetValeurTemps(grapheOsc.vecteurTestT);
    Duree := grapheOsc.vecteurTestT[pred(grapheOsc.NbreTest)];
    if (duree>dureeMini) then begin
          gti2.GetValeurVoie(grapheOsc.voieSynchro,grapheOsc.vecteurTestS);
          grapheOsc.TestSeuil;
          AcqSuffisante := grapheOsc.seuilTrouve and
               (grapheOsc.vecteurTestT[pred(grapheOsc.NbreTest)]>
                dureeBalayage[gti2.baseDeTemps]);
    end;
end;

var voie : indiceVoieYD;
begin
    if stopEnCours then begin
       timer.Enabled := false;
       oldNbre := grapheOsc.Nbre;
       dt := 1/gti2.freqEch;
       while gti2.getResul and
             not(gti2.acqTerminee) and
             not(acqSuffisante) and
             StopEnCours and
             not(fermeture) do begin
           newNbre := gti2.nbreCourant;
           progressBarGTI2.position := newNbre;
           if avecSegment
              then testSegment
              else if synchroRG.itemIndex>0
                   then testFini;
           Application.ProcessMessages;
       end;
       if fermeture or not(StopEnCours) then exit;
       if gti2.acqTerminee or AcqSuffisante then begin
           progressBarGTI2.position := progressBarGTI2.max;
           gti2.GetValeurTemps(grapheOsc.voieTemps.vecteurAff);
           if gti2.acqTerminee
              then grapheOsc.Nbre := gti2.nbreTotal
              else grapheOsc.Nbre := gti2.nbreCourant;
           for voie := low(indiceVoieYD) to high(indiceVoieYD) do
               if grapheOsc.VoieOrphy[voie].active then
                  gti2.GetValeurVoie(voie,grapheOsc.voieOrphy[voie].vecteurAff);
           if (grapheOsc.voieSynchro<>voieT) // and grapheOsc.preTrig
                 then begin
                     grapheOsc.setOrigineTemps;
                     if grapheOsc.verifPente and
                        not grapheOsc.penteCorrecte then begin
                           PremierTrace := false;
                           EnregistreBtnClick(nil); // nouvel essai
                           exit;
                     end;
                 end;
           if grapheOsc.pretrig
              then grapheOsc.voieTemps.Mini := -dureeBalayage[gti2.baseDeTemps]/10
              else grapheOsc.voieTemps.Mini := 0;
           gti2.etalonnage := false;   
           grapheOsc.voieTemps.Maxi := grapheOsc.voieTemps.Mini + dureeBalayage[gti2.baseDeTemps];
           TempsPaintBox.invalidate;
           if gti2.withGTS2=GTS2_DB15 then begin
              if reconnaissance then MajDB15;
              AfficheDB15
           end;
           if autosetEnCours
              then autoset
              else if monocoupCB.Checked or
                     (synchroRG.itemIndex=0) or
                     monocoupTemporaire
                   then affecteStop(false)
                   else begin
                      PremierTrace := false;
                      stopEnCours := false;
                      EnregistreBtnClick(nil);
                   end;
        end // gti.acqTerminee
        else timer.Enabled := true;   
    end; // stopEnCours
end; // timerTimer

procedure TGTI2MainForm.MajGBF(etat : TledGBF);
begin
   setLedGbf(etat);
   AmplitudeGB.visible := signalRG.itemIndex<ord(sArbitraire);
   DutyGB.visible := (signalRG.itemIndex=ord(sTriangle)) or
                     (signalRG.itemIndex=ord(sCarre));
   OffsetGB.visible := not (Tsignal(signalRG.itemIndex) in [sArbitraire,sData]);
   OffsetNulBtn.visible := signalRG.itemIndex<ord(sArbitraire);
   ExpressionPanel.Visible := signalRG.itemIndex=ord(sArbitraire);
   EAD_GBF.Visible := signalRG.itemIndex=ord(sData);   
   FrequencePanel.Visible := signalRG.itemIndex<ord(sContinu);
   OffsetEdit.text := tension.formatSimple(OffsetScroll.position*10/OffsetScroll.max);
   DutyEdit.text := IntToStr(DutyScroll.position)+'%';
   AmplitudeEdit.text := tension.formatSimple(AmplitudeScroll.position*10/AmplitudeScroll.max);
   monocoupGBFCB.visible := signalRG.itemIndex<>ord(sContinu);
   monoGBFBtn.visible := monocoupGBFCB.visible and monocoupGBFCB.checked;  
   if signalRG.itemIndex=ord(sContinu)
      then offsetGB.Caption := 'Niveau (V)'
      else offsetGB.Caption := 'Dcalage (V)';
   compteurGBF := 0;
   gbfPanel.refresh;
   GBFPB.refresh;
end;

procedure TGTI2MainForm.signalRGClick(Sender: TObject);
begin
   if not initialisation then begin
      if (signalRG.itemIndex=ord(sData)) and (gbf.NbreData<50) then
          AcquisitionversGBF1Click(Sender);
      MajGBF(lRed);
   end;
end;

procedure TGTI2MainForm.SpeedButton5Click(Sender: TObject);
var diminue : boolean;
    posP : integer;
    freq : double;
    deltaFreq : double;
begin
    diminue := (sender as TspeedButton).top>16;
    freq := strToFloatWin(LCD10k.value);
    if labelHz.caption='kHz' then freq := freq*1000;
    posP := pos('.',LCD10k.value);
    if posP>0 then posP := 5-posP; //  partir de la fin
    deltaFreq := dix((sender as TspeedButton).tag-posP);
    if labelHz.caption='kHz' then deltafreq := deltafreq*1000;    
    if diminue
       then begin
           freq := freq-deltaFreq;
           if freq<FreqMinGBF then begin // passage de 1  0
              freq := freq+deltaFreq-deltaFreq/10; // diminution de la dcade suivante
              if freq<FreqMinGBF then // passage de 1  0 aussi ! (ou de 0  -1 !)
                 freq := freq+10*deltaFreq/10; // passage  9 de la dcade suivante
           end;
           if freq<FreqMinGBF then freq := FreqMinGBF;
       end
       else begin
           Freq := freq+deltaFreq;
           if Freq>FreqMaxGBF then freq := FreqMaxGBF;
       end;
    gbf.Frequence := freq;
    affecteFreqGBF(gbf.frequence); // valeurExacte
    gbf.calculValeur;
    FrequenceTB.position := round((FrequenceTB.Max+1)*(log10(freq)+1.7)/7.7);
// de log(0.02)=-1.7  log(1 MHZ)=6
    compteurGBF := 0;
    gbf.MajAFaire := true;
    setLedGBF(lRed);
end; // changement de frquence

procedure TGTI2MainForm.GbfPBPaint(Sender: TObject);
var freq : double;
begin
     if frequencePanel.visible then begin
        freq := strToFloatWin(LCD10k.value);
        if labelHz.caption='kHz' then freq := freq*1000;
        gbf.Frequence := freq;
     end;
     if EAD_GBF.visible then begin
        labelFreq.caption := 'Fech='+frequence.formatUnite(gbf.freqEchData);
        labelDuree.caption := 'Dure='+grapheOsc.voieTemps.formatUnite(gbf.NbreData/gbf.freqEchData);
     end;
     gbf.signal := Tsignal(signalRG.ItemIndex);
     gbf.gainData := gainGBF.position;
     gbf.expression := ExpressionEdit.text;
     gbf.amplitude := AmplitudeScroll.position*10/AmplitudeScroll.max; // +- 10 V
     gbf.offset := OffsetScroll.position*10/OffsetScroll.max;
     gbf.Duty := DutyScroll.position/100;
     gbf.calculValeur;
     gbf.Paint(GBFpb.canvas,GBFpb.width,GBFpb.height);
     if frequencePanel.visible then
        affecteFreqGBF(gbf.frequence); // valeur exacte de la frquence
end;

procedure TGTI2MainForm.GbfBtnClick(Sender: TObject);
begin
     gbfPanel.visible := gbfBtn.down;
     if not gbfPanel.visible then gbf.arret;
     compteurGBF := 0;
     timerGBF.Enabled := gbfPanel.visible;
     majGbfBtn.visible := false;
     gbfPanel.refresh;
     TempsPaintBox.invalidate;
end;

procedure TGTI2MainForm.MajGbfBtnClick(Sender: TObject);
begin
     monocoupGBFCB.visible := signalRG.itemIndex<>ord(sContinu);
     MajGBF(lGreen);
     application.ProcessMessages;
     compteurGBF := 0;
     gbf.monocoup := monocoupGBFCB.checked;
     monoGBFBtn.visible := monocoupGBFCB.visible and monocoupGBFCB.checked;
     if not monoGBFBtn.visible then
        if stopEnCours
           then gbf.majAfaire := true
           else gbf.marche;
     edit1.SetFocus;
end;

procedure TGTI2MainForm.ExpressionEditChange(Sender: TObject);
begin
     MajGbfBtn.Enabled := true;
end;

procedure TGTI2MainForm.ExpressionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
    if key=vk_return
       then begin
           if gbf.expression<>ExpressionEdit.text then MajGbfBtnClick(sender)
       end
       else SetLedGBF(lGray)
end;

procedure TGTI2MainForm.voie_gti2Click(Sender: TObject);
var voie : indiceVoieYD;
begin
     voie := (sender as Tcomponent).tag;
     case modeAcq of
        mPointParPoint : begin
           if ConfigVoiePointDlg=nil then
              Application.CreateForm(TConfigVoiePointDlg, ConfigVoiePointDlg);
           ConfigVoiePointDlg.voieCourante := graphePoint.voieOrphy[voie];
           if ConfigVoiePointDlg.ShowModal=mrOK then afficheReglage;
        end;
        mTemps : begin
           OrphyGti2Dlg.voieCourante := grapheOsc.voieOrphy[voie];
           if OrphyGti2Dlg.ShowModal=mrOK then afficheReglage;
        end;
        mClavier : begin
           if ConfigVoiePointDlg=nil then
              Application.CreateForm(TConfigVoiePointDlg, ConfigVoiePointDlg);
           ConfigVoiePointDlg.voieCourante := graphePoint.voieOrphy[voie];
           if ConfigVoiePointDlg.ShowModal=mrOK then afficheReglage;
        end;
     end;
end;

procedure TGTI2MainForm.EA_GTS2Click(Sender: TObject);
var voie : indiceVoieYD;
begin
     voie := (sender as Tcomponent).tag;
     if OrphyGts2Dlg=nil then
        Application.CreateForm(TOrphyGts2Dlg, OrphyGts2Dlg);
     OrphyGts2Dlg.voieCourante := grapheOsc.voieOrphy[voie];
     if OrphyGts2Dlg.ShowModal=mrOK then afficheReglage;
end;

procedure TGTI2MainForm.DB15Click(Sender: TObject);
begin
    if etalonneAutoDlg=nil then
       Application.CreateForm(TEtalonneAutoDlg, EtalonneAutoDlg);
    DebutLectureParametres;
    etalonneAutoDlg.voieCourante := (sender as Tcontrol).tag;
    etalonneAutoDlg.showModal;
    MajDB15;
    finLectureParametres;
end;

procedure TGTI2MainForm.PreAcqCBClick(Sender: TObject);
var newPreAcq : boolean;
begin
    newPreAcq := preAcqCB.visible and preAcqCB.checked;
    if grapheOsc.preTrig=newPreAcq then exit;
    grapheOsc.pretrig := newPreAcq;
//    grapheOsc.preTrig := gti2.preTrig;
    if not initialisation and
       monocoupCB.visible and
       not monocoupCB.checked
          then AfficheReglage
          else begin
              grapheOsc.preTrig := preAcqCB.checked;
              if grapheOsc.pretrig
                 then grapheOsc.voieTemps.Mini := dureeBalayage[gti2.baseDeTemps]/10
                 else grapheOsc.voieTemps.Mini := 0;
              TempsPaintBox.invalidate;
          end
end;

procedure TGTI2MainForm.PrintBtnClick(Sender: TObject);
begin
	printer.beginDoc;
 	printer.endDoc;
end;

procedure TGTI2MainForm.Shape1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
      var voie : indiceVoieYD;
begin
     DebutLectureParametres;
     voie := (sender as Tcomponent).tag;
     case modeAcq of
        mPointParPoint : begin
           if ConfigVoiePointDlg=nil then Application.CreateForm(TConfigVoiePointDlg, ConfigVoiePointDlg);
           ConfigVoiePointDlg.voieCourante := graphePoint.voieOrphy[voie];
           if ConfigVoiePointDlg.ShowModal=mrOK
             then afficheReglage
             else finLectureParametres;
        end;
        mTemps : begin
           if OrphyGti2Dlg=nil then Application.CreateForm(TOrphyGti2Dlg, OrphyGti2Dlg);
           OrphyGti2Dlg.voieCourante := grapheOsc.voieOrphy[voie];
           if (OrphyGti2Dlg.ShowModal=mrOK) or
               OrphyGti2Dlg.modifZero
                  then afficheReglage
                  else finLectureParametres;
        end;
        mClavier : begin
           if ConfigVoiePointDlg=nil then Application.CreateForm(TConfigVoiePointDlg, ConfigVoiePointDlg);
           ConfigVoiePointDlg.voieCourante := graphePoint.voieOrphy[voie];
           if ConfigVoiePointDlg.ShowModal=mrOK
             then afficheReglage
             else finLectureParametres;
        end;
     end;
end;

procedure TGTI2MainForm.Shape6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var voie : indiceVoieYD;
begin
     DebutLectureParametres;
     voie := (sender as Tcomponent).tag;
     if OrphyGts2Dlg=nil then Application.CreateForm(TOrphyGts2Dlg, OrphyGts2Dlg);     
     OrphyGts2Dlg.voieCourante := grapheOsc.voieGTS2[voie];
     if (OrphyGts2Dlg.ShowModal=mrOK) 
          then afficheReglage
          else finLectureParametres;
end;

procedure TGTI2MainForm.RadioGroup1Click(Sender: TObject);
var voie : indiceVoieYD;
    newActive : boolean;
    newDiff,modif : boolean;
begin
   voie := (sender as TradioGroup).tag;
   newDiff := (sender as TradioGroup).itemIndex=0;
   newActive := (sender as TradioGroup).itemIndex<2;
   modif := (newActive<>gti2.active[voie]) or
            (newDiff<>gti2.differentiel[voie]);
   case (sender as TradioGroup).itemIndex of
          0 : synchroRG.Items[voie+1] := 'YD'+intTostr(voie);
          1 : synchroRG.Items[voie+1] := 'Y'+intTostr(voie)+' BNC';
          2 : synchroRG.Items[voie+1] := '';
   end;
   if modif then if initialisation
       then begin
           gti2.differentiel[voie] := newDiff;
           graphePoint.voieOrphy[voie].active := newActive;
           grapheOsc.voieOrphy[voie].active := newActive;
       end
       else begin
           if stopEnCours then stopBtnClick(sender);
           if modeAcq<>mTemps then gti2.StopAcqlente;
           gti2.differentiel[voie] := newDiff;
           graphePoint.voieOrphy[voie].active := newActive;
           grapheOsc.voieOrphy[voie].active := newActive;
           afficheReglage;
       end
end;

procedure TGTI2MainForm.RadioGroup5Click(Sender: TObject);
var voie : indiceVoieYD;
    newActive : boolean;
    newDiff,modif : boolean;
begin
   voie := (sender as TradioGroup).tag;
   newDiff := (sender as TradioGroup).itemIndex=0;
   newActive := (sender as TradioGroup).itemIndex<2;
   modif := (newActive<>gti2.activeGTS2[voie]) or
            (newDiff<>gti2.diffGts2[voie]);
   if modif then begin
       gti2.diffGts2[voie] := newDiff;
       grapheOsc.voieGTS2[voie].active := newActive;
       if not initialisation then begin
           if stopEnCours then stopBtnClick(sender);
           afficheReglage;
       end;
   end;
end;

procedure TGTI2MainForm.ComBtnClick(Sender: TObject);
begin
    OrphyAbsent.Visible := not gti2.open;
    if gti2.isOpen then afficheReglage
end;

procedure TGTI2MainForm.SetLedGBF(etat : TledGBF);
var numero : integer;
    abitmap : Tbitmap;
begin
       ledGBF := etat;
       majGbfBtn.Visible := ledGBF<>lGreen;
       majArbitrBtn.Visible := (ledGBF<>lGreen) and (gbf.expression<>ExpressionEdit.text);
       timerGBF.Enabled := (ledGBF<>lGreen) and GBFPanel.visible;
       case LedGBF of
            lGray : numero := 16;
            lRed : numero := 14;
            else numero := 15;
       end;
       if ledGBF=lGreen
          then majGbfBtn.Hint := 'GBF OK'
          else majGbfBtn.Hint := 'MJ|Cliquer pour mettre  jour le GBF';
       abitmap := Tbitmap.Create;
       ImageList.GetBitmap(numero,abitmap);
       MajGbfBtn.Glyph := abitmap;
       MajArbitrBtn.Glyph := abitmap;
       case LedGBF of
            lGray : MajArbitrBtn.Font.color := clGray;
            lRed : MajArbitrBtn.Font.color := clRed;
            else MajArbitrBtn.Font.color := clGreen;
       end;
       if stopEnCours then gbf.majAfaire := LedGBF<>lGreen;
       MajGbfBtn.refresh;
       MajArbitrBtn.refresh;
end;

procedure TGTI2MainForm.OffsetNulBtnClick(Sender: TObject);
begin
   offsetSCroll.Position := 0;
   MajGbfBtnClick(sender);
end;

procedure TGTI2MainForm.Duty50BtnClick(Sender: TObject);
begin
   DutyScroll.Position := 50;
   MajGbfBtnClick(sender)
end;

procedure TGTI2MainForm.ExpressionEditExit(Sender: TObject);
begin
    if gbf.expression<>ExpressionEdit.text then MajGbfBtnClick(sender)
end;

procedure TGTI2MainForm.OffsetScrollScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
    if scrollCode=scEndScroll then majGbfBtnClick(sender)
end;

procedure TGTI2MainForm.Autoset;
const NzeroMin = 3;
var nouvelEssai : boolean;
   valMin,valMax,zero : array[indiceVoieYD] of double;
   Nzero : array[indiceVoieYD] of integer;
   NzeroMax : integer;
   ValeurMax : double;
   Nvoie : integer;

Procedure testVoie(voie : indiceVoieYD);
var i : indicevecteur;
    IsNegatif : boolean;
    Hyst,zz : double;
begin with grapheOsc,voieOrphy[voie] do begin
      valMax[voie] := vecteurAff[0];
      valMin[voie] := vecteurAff[0];
      for i := 1 to pred(Nbre) do begin
          zz := vecteurAff[i];
          if zz>valMax[voie] then valMax[voie] := zz;
          if zz<valMin[voie] then valMin[voie] := zz;
      end;
      zero[voie] := (valMin[voie]+valMax[voie])/2;
      Nzero[voie] := 0;
      Hyst := (valMax[voie]-valMin[voie])/4;
      if Hyst>Maxi/128 then begin
          isNegatif := vecteurAff[0]<(zero[voie]-Hyst);
          for i := 1 to pred(Nbre) do
              if isNegatif
                 then begin
                     isNegatif := vecteurAff[i]<(zero[voie]+Hyst);
                     if not isNegatif then inc(Nzero[voie]);
                 end
                 else begin
                     isNegatif := vecteurAff[i]<(zero[voie]-Hyst);
                     if isNegatif then inc(Nzero[voie]);
                 end;
      end;
      NouvelEssai := NouvelEssai and (Nzero[voie]<NzeroMin);
end end;

Procedure setVoie(voie : indiceVoieYD);
var margeV : double;
    AbsMax : double;
    calibre : Tcalibre;
begin with grapheOsc,voieOrphy[voie] do begin
      active := (valmax[voie]-valmin[voie])>0.2;
      gti2.active[voie] := active;
      margeV := (valMax[voie]-valMin[voie])/25;
      zeroCB.Checked := valMin[voie]>(-margeV);
      if Abs(valMax[voie])>Abs(valMin[voie])
         then AbsMax := Abs(valMax[voie])
         else AbsMax := Abs(valMin[voie]);
      calibre := c50m;
      while (calibre<high(Tcalibre)) and
            (valeurCalibre[calibre]<AbsMax) do inc(calibre);
      calibreCB.ItemIndex := ord(calibre);
      if not active
         then diffRG.itemIndex := 2
         else if gti2.differentiel[voie]
              then diffRG.itemIndex := 0
              else diffRG.itemIndex := 1;
      if active then
         if Nzero[voie]>NzeroMax then begin
            NzeroMax := Nzero[voie];
            voieSynchro := voie;
            synchroRG.itemIndex := voie+1;
            gti2.VoieSynchro := voie+1;
            gti2.SeuilVolt := zero[voie];
            valeurMax := absMax;
         end;
         if (Nzero[voie]=NzeroMax) and (absMax>valeurMax) then begin
            NzeroMax := Nzero[voie];
            voieSynchro := voie;
            synchroRG.itemIndex := voie+1;
            gti2.VoieSynchro := voie+1;
            gti2.SeuilVolt := zero[voie];
            valeurMax := absMax;
         end;
      case diffRg.itemIndex of
          0 : synchroRG.Items[voie+1] := 'YD'+intTostr(voie);
          1 : synchroRG.Items[voie+1] := 'Y'+intTostr(voie)+' BNC';
          2 : synchroRG.Items[voie+1] := '';
      end;
      if active then inc(Nvoie);
end end;

procedure AutosetBNC;
var voie : indiceVoieYD;
begin with grapheOsc do begin
      Timer.enabled := false;
      voieSynchro := voieT;
      if Nvoie=0 then gti2.baseDeTemps := b10mu; // 10 s
      gti2.voieSynchro := 0;      
      for voie := low(indiceVoieYD) to high(indiceVoieYD) do
          with voieOrphy[voie] do begin
           if not active then begin // sinon YD trouv
              active := true;
              gti2.active[voie] := true;
              gti2.differentiel[voie] := false; // BNC
              gti2.calibre15V[voie] := true;
              mini := -15;
              maxi := +15;
           end;
      end;
      autoSetEnCours := true;
      autoSetYD := false;
      EnregistreBtn.Enabled := false;
      stopEnCours := false;
      lanceAcq;
end end;

var voie : indiceVoieYD;
begin with grapheOsc do begin
    nouvelEssai := gti2.baseDeTemps<b500m; // 0,5 s
    for voie := low(indiceVoieYD) to high(indiceVoieYD) do testVoie(voie);
    if NouvelEssai
      then begin
         gti2.baseDeTemps := succ(gti2.baseDeTemps);
         EnregistreBtn.Enabled := false;
         stopEnCours := false;
         lanceAcq;
      end
      else begin
          initialisation := true;
          NzeroMax := Nzero[0];
          Nvoie := 0;
          ValeurMax := abs(valMax[0]);
          if valeurMax<Abs(valMin[0])
             then valeurMax := Abs(valMin[0]);
          autoSetEnCours := false;
          gti2.VoieSynchro := 1;
          gti2.SeuilVolt := zero[0];
          for voie := low(indiceVoieYD) to high(indiceVoieYD) do setVoie(voie);
          synchroRG.itemIndex := gti2.VoieSynchro;
          grapheOsc.seuilSynchro := gti2.seuilVolt;
          monocoupCB.Checked := false;
          DureeUpDown.position := ord(gti2.baseDeTemps);
          initialisation := false;
          if (Nvoie<2) and autosetYD
            then autosetBNC
            else AfficheReglage;
      end;
end end; // AutoSet

procedure TGTI2MainForm.AutosetBtnClick(Sender: TObject);
var voie : indiceVoieYD;
begin with grapheOsc do begin
      Timer.enabled := false;
      if stopEnCours then stopBtnClick(sender);
      voieSynchro := voieT;
      gti2.baseDeTemps := b10mu; // 10 s
      gti2.voieSynchro := 0;      
      for voie := low(indiceVoieYD) to high(indiceVoieYD) do with voieOrphy[voie] do begin
           active := true;
           gti2.active[voie] := true;
           gti2.differentiel[voie] := true;
           gti2.calibre15V[voie] := true;         
           mini := -15;
           maxi := +15;
      end;
      autoSetEnCours := true;
      autoSetYD := true;
      lanceAcq;
end end;

procedure TGTI2MainForm.TimerGBFTimer(Sender: TObject);
begin
  inc(compteurGBF);
  if (compteurGBF*TimerGBF.Interval>2000) and
      majGbfBtn.Visible then
     if Tsignal(signalRG.itemIndex) in [sContinu,sArbitraire]
        then gbf.MajAFaire := true
        else majGbfBtnClick(sender);
  if GBFPanel.Visible and (ledGBF in [lGray,lRed]) then
       if LedGBF=lGray then setLedGBF(lRed) else setLedGBF(lGray)
end;

procedure TGTI2MainForm.TimerGTS2Timer(Sender: TObject);

procedure AttenteGTS2;
begin
       while gti2.getResulGTS2 and
             StopEnCours and
             not(fermeture) do begin
                 progressBarGTI2.position := gti2.nbreCourantGts2;
                 Application.ProcessMessages;
       end;
end;

procedure AttenteGTI2;
begin
       while gti2.getResul and
             not(gti2.acqTerminee) and
             StopEnCours and
             not(fermeture) do begin
           progressBarGTI2.position := gti2.nbreGTS2+gti2.nbreCourant;
           Application.ProcessMessages;
       end;
end;

var voie : indiceVoieYD;
begin
    if stopEnCours then begin
       timerGTS2.Enabled := false;
       if not(gti2.acqGTS2Terminee) then AttenteGTS2;
       if fermeture or
          not(StopEnCours) then exit;
       if not(gti2.acqGTS2Terminee) then begin
          timerGTS2.Enabled := true;
          exit;
       end;
       AttenteGTI2;
       if fermeture or
          not(StopEnCours) then exit;
       if gti2.acqTerminee then begin
           progressBarGTI2.position := progressBarGTI2.max;
           gti2.GetValeurTemps(grapheOsc.voieTemps.vecteurAff);
           grapheOsc.Nbre := gti2.nbreTotal;
           grapheOsc.NbreGTS2 := gti2.nbreGTS2;           
           for voie := low(indiceVoieYD) to high(indiceVoieYD) do
               if grapheOsc.VoieOrphy[voie].active then
                  gti2.GetValeurVoie(voie,grapheOsc.voieOrphy[voie].vecteurAff);
           grapheOsc.setOrigineTemps;
{
           if grapheOsc.verifPente and
              not grapheOsc.penteCorrecte then begin
                  EnregistreBtnClick(nil); // nouvel essai
                  exit;
           end;
}           
           gti2.GetValeurTempsGTS2(grapheOsc.voieTempsGTS2.vecteurAff);
           for voie := low(indiceVoieYD) to high(indiceVoieYD) do
               if grapheOsc.VoieGTS2[voie].active then
                  gti2.GetValeurVoieGTS2(voie,grapheOsc.voieGTS2[voie].vecteurAff);
           grapheOsc.setOrigineGTS2;
           grapheOsc.voieTemps.Mini := 0;
           gti2.etalonnage := false;   
           grapheOsc.voieTemps.Maxi := dureeBalayage[gti2.baseDeTemps];
           TempsPaintBox.invalidate;
           if monocoupCB.Checked or
             (synchroRG.itemIndex=0) or
             monocoupTemporaire
                then affecteStop(false)
                else begin
                   stopEnCours := false;
                   EnregistreBtnClick(nil);
                end;
        end // gti.acqTerminee
        else timerGTS2.Enabled := true;
    end; // stopEnCours
end; // timerGTS2

procedure TGTI2MainForm.SeuilEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_return then SeuilEditExit(Sender);
end;

procedure TGTI2MainForm.SeuilEditExit(Sender: TObject);
var newSeuil : double;
begin
    try
       newSeuil := strToFloatWin(Seuiledit.text);
       gti2.seuilVolt := newSeuil;
       grapheOsc.seuilSynchro := gti2.seuilVolt;
    except
    end;
    if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
end;

procedure TGTI2MainForm.EnregistreBtnClick(Sender: TObject);
begin
   if stopEnCours
        then stopBtnClick(sender)
        else begin
        if synchroRG.itemIndex=0 then premierTrace := true;
        EnregistreBtn.enabled := false;
        if PremierTrace and
           (gti2.baseDeTemps>b1) and
           (grapheOsc.Nbre>0) then begin
              grapheOsc.Nbre := 0;
              TempsPaintBox.invalidate;
        end;
        lanceAcq;
     end;
end;

procedure TGTI2MainForm.CheckBox10Click(Sender: TObject);
var voie : indiceVoieYD;
begin
    if not initialisation then begin
       voie := (sender as TcheckBox).tag;
       with grapheOsc.voieOrphy[voie] do begin
            if (sender as TcheckBox).checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
       with graphePoint.voieOrphy[voie] do begin
            if (sender as TcheckBox).checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
       TempsPaintBox.invalidate;
   end;
end;

procedure TGTI2MainForm.CheckBox2Click(Sender: TObject);
var voie : indiceVoieYD;
begin
    if not initialisation then begin
       voie := (sender as TcheckBox).tag;
       with grapheOsc.voieGTS2[voie] do begin
            if (sender as TcheckBox).checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
       TempsPaintBox.invalidate;
   end;
end;

procedure TGTI2MainForm.CheckBox8Click(Sender: TObject);
var voie : indiceVoieYD;
    newActive : boolean;
begin
   voie := (sender as TcheckBox).tag;
   newActive := (sender as TcheckBox).checked;
   if (newActive<>gti2.activeGTS2[voie]) then begin
       gti2.activeGTS2[voie] := newActive;
       grapheOsc.voieGTS2[voie].active := newActive;
       if not initialisation then begin
          if stopEnCours then stopBtnClick(sender);
          afficheReglage;
       end
   end;
end;

procedure TGTI2MainForm.ClavierGBClick(Sender: TObject);
begin
    DebutLectureParametres;
    ClavierDlg := TClavierDlg.create(self);
    ClavierDlg.showModal;
    ClavierDlg.free;
    finLectureParametres;
end;

procedure TGTI2MainForm.ClavierGridExit(Sender: TObject);
begin
   if modeAcq=mClavier then setValeurClavier(true)
end;

procedure TGTI2MainForm.ClavierGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: string);
var Acourbe : TcourbePoint;
    i : integer;
begin
   if acol=0
      then Acourbe := graphePoint.entreeClavier
      else Acourbe := voieOrphyClavier[acol-1];
  if arow=0
     then value := Acourbe.nom
     else begin
        i := arow-1;
        if i>=grapheOsc.Nbre
            then value := ''
            else value := Acourbe.AffGrid(i)
     end;
end;

procedure TGTI2MainForm.ClavierGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=vk_return then setValeurClavier(false)
end;

procedure TGTI2MainForm.ClavierGridKeyPress(Sender: TObject; var Key: Char);
begin
with ClavierGrid do
    if (col=0) and(row>0)
        then if key in [',','.']
           then key := decimalSeparator
           else begin
              if not ( key in (ChiffreWin+ToucheEdition) ) then key := #0
           end
        else key := #0

end;

procedure TGTI2MainForm.ClavierGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
   CanSelect := (Acol=0) and (Arow>0);
   if CanSelect then rowEdit := Arow;
end;

procedure TGTI2MainForm.ComboBox0Change(Sender: TObject);
var voie : indiceVoieYD;
    calibre : Tcalibre;
    new15 : boolean;
begin
    if not initialisation then begin
       voie := (sender as TcomboBox).tag;
       with grapheOsc.voieOrphy[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
            new15 := maxi>5;
       end;
       if new15<>gti2.calibre15V[voie]
           then afficheReglage
           else TempsPaintBox.invalidate;
    end;
end;

procedure TGTI2MainForm.ComboBox5Change(Sender: TObject);
var voie : indiceVoieYD;
    calibre : Tcalibre;
begin
    if not initialisation then begin
       voie := (sender as TcomboBox).tag;
       with grapheOsc.voieGTS2[voie] do begin
            calibre := Tcalibre(calibreCB.itemIndex);
            maxi := valeurCalibre[calibre];
            if zeroCB.checked
               then mini := 0
               else mini := -maxi;
            setMinMax;
       end;
       TempsPaintBox.invalidate;
    end;
end;

procedure TGTI2MainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=vk_space then
     case modeAcq of
        mPointParPoint : enregistrePointBtnClick(sender);
        mClavier : ;
        mTemps : if StopEnCours
              then stopBtnClick(sender)
              else begin
                PremierTrace := true;
            enregistreBtnClick(sender)
        end
     end;
end;

procedure TGTI2MainForm.FormDestroy(Sender: TObject);
begin
    gti2.free
end;

procedure TGTI2MainForm.StopBtnClick(Sender: TObject);
begin
   progressBarGTI2.Position := 0;
   monocoupTemporaire := true;
   autoSetEnCours := false;
   gti2.stopAcquisition;
   affecteStop(false);
end;

procedure TGTI2MainForm.DeltaSeuil(signe : integer);
begin
    gti2.seuilVolt := gti2.seuilVolt+signe*deltaVSynchro;
    grapheOsc.seuilSynchro := gti2.seuilVolt;
    seuilEdit.text := FormatSynchro(grapheOsc.seuilSynchro);
    TempsPaintBox.refresh;
//    if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
    edit1.setFocus;
end;

procedure TGTI2MainForm.SpinButton1DownClick(Sender: TObject);
begin
    deltaSeuil(-1)
end;

procedure TGTI2MainForm.SpinButton1UpClick(Sender: TObject);
begin
   deltaSeuil(+1)
end;

procedure TGTI2MainForm.NbreSpinDownClick(Sender: TObject);
begin
     SetNbreDDE(grapheOsc.NbreMaxi div 2)
end;

procedure TGTI2MainForm.NbreSpinUpClick(Sender: TObject);
begin
     SetNbreDDE(2*GrapheOsc.NbreMaxi)
end;

Procedure TGTI2MainForm.SetNbreDDE(newNbre : integer);
begin
    gti2.NbrePoints := newNbre;    // pas modif structure gti2
    GrapheOsc.NbreMaxi := gti2.NbrePoints;
    NbreEdit.Text := intToStr(gti2.NbrePoints);
    FechEdit.Text := frequence.formatUnite(gti2.freqEch);
    if (gti2.withGTS2=GTS2_EAD) and (gti2.nbreVoiesGTS2>0)
        then progressBarGTI2.max := gti2.nbreTotal+gti2.nbreGTS2
        else progressBarGTI2.max := gti2.nbreTotal;
end;

procedure TGTI2MainForm.NbreEditExit(Sender: TObject);
var newNbre : integer;
begin
     try
     newNbre := StrToInt(NbreEdit.text);
     setNbreDDE(newNbre);
     except
        NbreEdit.text := IntToStr(gti2.nbrePoints);
     end;
end;

procedure TGTI2MainForm.NbreEditKeyPress(Sender: TObject; var Key: Char);
begin
     case key of
        crCR : NbreEditExit(sender);
        '0'..'9' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0;
     end;
end;

procedure TGTI2MainForm.CacheCurseur;
begin
       labelX.visible := false;
       labelY.visible := false;
       shapeCurseur.visible := false;
end;

procedure TGTI2MainForm.EnregistrePointBtnClick(Sender: TObject);
begin
    if modePpPRG.itemIndex=0
          then EnregistrePointCourant
          else if AcqPointEnCours
            then begin
                progressBarGTI2.Position := 0;
                ModePpPRG.enabled := true;
                AcqPointEnCours := false;
                ResetBtn.enabled := true;
                Header.simpleText := hPointAttente;
                EnregistrePointBtn.caption := 'Enregistrer';
                EnregistrePointBtn.hint := 'Lancer l''acquisition';
            end
            else begin
                AcqPointEnCours := true;
                EnregistrePointBtn.caption := 'Stop';
                EnregistrePointBtn.hint := 'Arrter l''acquisition';
                ModePpPRG.enabled := false;
                debutAcquisition := now;
                EnregistrePointBtn.enabled := true;
                Header.simpleText := hPointAcquisition;
          end
end;

Procedure TGTI2MainForm.EnregistrePointCourant;
   var voie : indiceVoieYD;
   begin with graphePoint do begin
       Header.simpleText := '';
//       effacePointCourant;
       with voieTemps do vecteurAff[nbre] := ValeurAff;
       for voie := low(indiceVoieYD) to high(indiceVoieYD) do
           with voieOrphy[voie] do if active then begin
              vecteurAff[nbre] := ValeurAff;
              if voie<>voieAbscisse then traceUnPoint(voie);
       end;
       inc(Nbre);
//       marquePointCourant;
       undoBtn.enabled := Nbre>0;
       resetBtn.enabled := Nbre>0;
       regSaveBtn.enabled := Nbre>2;
   end end;// EnregistrePointCourant

Procedure TGTI2MainForm.EffacePointCourant;
var voie : indiceVoieYD;
begin with graphePoint do begin
   if not ReticuleTrace then exit;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       if voieOrphy[voie].active then traceReticule(voie);
   ReticuleTrace := false;
end end;

Procedure TGTI2MainForm.MarquePointCourant;
var voie : indiceVoieYD;
begin with graphePoint do begin
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       with voieOrphy[voie] do
            if active then LabelValeur.caption := AffVoltmetre;
   if ReticuleTrace then exit;
   for voie := low(indiceVoieYD) to high(indiceVoieYD) do
       if voieOrphy[voie].active then traceReticule(voie);
   ReticuleTrace := true;
end end;

procedure TGTI2MainForm.UndoBtnClick(Sender: TObject);
begin
  dec(graphePoint.Nbre);
  graphePoint.entreeClavier.vecteurAff[graphePoint.Nbre] := sansSignif;
  resetBtn.Enabled := graphePoint.Nbre>0;
  undoBtn.Enabled := graphePoint.Nbre>0;
  regSaveBtn.enabled := graphePoint.Nbre>2;
  TempsPaintBox.invalidate;
  if modeAcq=mClavier then setFocusGrid;
end;

procedure TGTI2MainForm.ResetBtnClick(Sender: TObject);
var i : integer;
begin
  graphePoint.Nbre := 0;
  for i := 0 to MaxVecteur do
      graphePoint.entreeClavier.vecteurAff[i] := sansSignif;
  resetBtn.Enabled := false;
  undoBtn.Enabled := false;
  regSaveBtn.enabled := false;
  enregistreBtn.enabled := true;
  enregistrePointBtn.enabled := true;
  TempsPaintBox.invalidate;
  if modeAcq=mClavier then setFocusGrid;
end;

procedure TGTI2MainForm.TimerPointTimer(Sender: TObject);
var voie : indiceVoieYD;
    distance : double;
begin
    if fermeture then exit;
with graphePoint do begin
    timerPoint.Enabled := false;
    effacePointCourant;
    for voie := low(indiceVoieYD) to high(indiceVoieYD) do
        voieOrphy[voie].valeurAff := gti2.valeurPoint[voie];
    case modeAcq of
      mClavier: ;
      mPointparPoint: case ModePpPRG.ItemIndex of
       0 : voieTemps.valeurAff := 0;
       1 : if acqPointEnCours
            then if Nbre=0
                then begin
                    EnregistrePointCourant;
                    voieTemps.valeurAff := 0;
                end
                else begin // Nbre<>0
                    distance := 0;
                    voieTemps.valeurAff := nbre;
                    for voie := low(indiceVoieYD) to high(indiceVoieYD) do
                        with voieOrphy[voie] do if active then
                             distance := distance+abs((valeurAff-vecteurAff[pred(Nbre)])/(maxi-mini));
                    if 100*distance>deltaPointSE.value then EnregistrePointCourant;
               end
            else voieTemps.valeurAff := 0; // point par point auto
        2 : if acqPointEnCours
            then if Nbre=0
               then begin
                    EnregistrePointCourant;
                    voieTemps.valeurAff := 0;
                    PanelDureePoint.Caption := '0';
                    debutAcquisition := now
               end
               else begin // Nbre<>0
                  voieTemps.valeurAff := dureeEcoulee(DebutAcquisition);
                  PanelDureePoint.Caption := TimeToStr(voieTemps.valeurAff/SecsPerDay);
                  if (voieTemps.valeurAff>nbre*deltaPointSE.value)
                     then EnregistrePointCourant;
                  if (voieTemps.valeurAff>voieTemps.maxi)
                     then TempsPaintBox.refresh;
               end
           else begin
              PanelDureePoint.Caption := '';
              voieTemps.valeurAff := 0; // temporel
           end;
    end;// case modePpP
    end; // modeAcq
    marquePointCourant;
    if ActiveControl=nil then
       if modeAcq=mPointParPoint
          then edit1.SetFocus
          else setFocusGrid;
    timerPoint.Enabled := not fermeture;
end end;

procedure TGTI2MainForm.ModePpPRGClick(Sender: TObject);
begin
     if initialisation then exit;
     case ModePpPRG.ItemIndex of
          0 : begin
               Header.simpleText := hPointManuel;
               LabelAuto.caption := 'Clic ou Barre';
          end;
          1 : begin
               Header.simpleText := hPointAttente;
               LabelAuto.caption := 'Variation (%)';
          end;
          2 : begin
               Header.simpleText := hPointAttente;
               LabelAuto.caption := 'Deltat (s)';
          end;
     end;
     DeltaPointSE.Visible := ModePpPRG.itemIndex>0;
end;

procedure TGTI2MainForm.AbscisseRGClick(Sender: TObject);
var newX : integer;
begin
    newX := abscisseRG.itemIndex;
    if not graphePoint.voies[newX].active
         then abscisseRG.itemIndex := graphePoint.voieAbscisse
         else if not initialisation and
           (graphePoint.voieAbscisse<>newX) then afficheReglage
end;

procedure TGTI2MainForm.FrequenceTBScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
var freq : double;
begin
    freq := power(10,7.7*FrequenceTB.position/(FrequenceTB.Max+1)-1.7);
// de 10^-1.7=0.02 Hz  10^6=1 MHz 
    gbf.Frequence := freq;
    affecteFreqGBF(gbf.frequence);
    gbf.calculValeur;
    compteurGBF := 0;
    setLedGBF(lGray);
    if scrollCode=scTrack then ;
    if (scrollCode=scEndScroll) and
       majGbfBtn.Visible then majGbfBtnClick(sender);
end;

procedure TGTI2MainForm.RazSeuilBtnClick(Sender: TObject);
begin
  SeuilEdit.Text := '0';
  gti2.seuilVolt := 0;
  grapheOsc.seuilSynchro := 0;
  TempsPaintBox.refresh;
//  if monocoupCB.visible and not monocoupCB.checked then afficheReglage;
end;

procedure TGTI2MainForm.FFTbtnClick(Sender: TObject);
begin
    if FFTPaintBox.visible
       then begin // pas le mme ordre !
          Splitter.visible := false;
          FFTPaintBox.visible := false;
          FFTgb.Visible := false;
       end
       else begin
          FFTPaintBox.height := PanelCourbe.height div 3;
          FFTpaintBox.Visible := true;
          Splitter.visible := true;
          FFTgb.Visible := true;
       end;
end;

procedure TGTI2MainForm.FFTPaintBoxPaint(Sender: TObject);
var voie : indiceVoieYD;
    i : integer;
begin
     if not fftok then exit;
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do begin
         with grapheFFT.voieOrphy[voie] do if active then begin
              maxi := grapheOsc.voieOrphy[voie].maxi/10;
              for i := 0 to pred(grapheFFT.NbreAff) do
                  if maxi<vecteurAff[i] then maxi := 1.05*vecteurAff[i];
         end;
         with grapheFFT.voieGTS2[voie] do if active then begin
              maxi := grapheOsc.voieGTS2[voie].maxi/10;
              for i := 0 to pred(grapheFFT.NbreAff) do
                  if maxi<vecteurAff[i] then maxi := 1.05*vecteurAff[i];
         end;
     end;
     NbreFreqSE.value := GrapheFFT.NbreAff;
     grapheFFT.draw;
     if echelleFreq then FFTPaintBox.cursor := crHsplit;
end;

procedure TGTI2MainForm.ToolButton2Click(Sender: TObject);
begin
   DDEForm.EnvoieDonneesCorrel
end;

procedure TGTI2MainForm.OffsetScrollChange(Sender: TObject);
begin
   OffsetEdit.text := tension.formatSimple(OffsetScroll.position*10/OffsetScroll.max);
end;

procedure TGTI2MainForm.FFTPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
      if grapheFFT.isAxeX(x,y) then begin
            xCurseurEchelleFreq := x;
            FFTPaintBox.cursor := crHsplit;
            echelleFreq := true;
      end;
end; { MouseDown }

procedure TGTI2MainForm.FFTPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var i,v : integer;
begin
   if echelleFreq then begin
       if (abs(x-xCurseurEchelleFreq)>8) then with grapheFFT do begin
             changeEchelleX(x,xCurseurEchelleFreq);
             grapheFFT.NbreAff := round(voieTemps.maxi/voieTemps.vecteurAff[1]);
             if analyseHarmonique
                then NbreHarmoniqueAff := grapheFFT.NbreAff
                else NbreFreqAff := grapheFFT.NbreAff;
             xCurseurEchelleFreq := x;
             FFTPaintBox.refresh;
        end;
      end
      else begin
           grapheFFT.PointProche(x,y,v,i);
           if i>=0 then begin
              labelFFTx.top := y+FFTPaintBox.top-32;
              labelFFTy.Top := labelFFTx.Top+16;
              labelFFTx.left := x+8;
              labelFFTy.left := labelFFTx.left;
              labelFFTx.Caption := ' '+frequence.formatUnite(grapheFFT.voieTemps.vecteurAff[i])+' ';
              with grapheFFT.voieOrphy[v] do begin
                 labelFFTy.Caption := ' '+NomValeurUnite(vecteurAff[i])+' ';
                 labelFFTx.font.color := color;
                 labelFFTy.font.color := color;
              end;
              labelFFTx.visible := true;
              labelFFTy.visible := true;
           end
           else begin
              labelFFTx.visible := false;
              labelFFTy.visible := false;
           end;
      end;
end; { FrequenceMouseMove }

procedure TGTI2MainForm.FFTPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin { FrequenceMouseUp }
    if echelleFreq then with grapheFFT do begin
           changeEchelleX(x,xCurseurEchelleFreq);
           grapheFFT.NbreAff := round(voieTemps.maxi/voieTemps.vecteurAff[1]);
           if analyseHarmonique
              then NbreharmoniqueAff := grapheFFT.NbreAff
              else NbreFreqAff := grapheFFT.NbreAff;
           echelleFreq := false;
           FFTPaintBox.cursor := crDefault;
           FFTPaintBox.refresh;
       end;
end; { MouseUp }

procedure TGTI2MainForm.FFTperiodeClick(Sender: TObject);
begin
    fft.AnalyseHarmonique := FFTperiode.checked;
    if fft.AnalyseHarmonique
       then begin
           grapheFFT.trace := tHisto;
           NbreFreqSE.MinValue := 8;
           NbreFreqSE.MaxValue := 128;
           NbreFreqSE.value := NbreHarmoniqueAff;
           NbreFreqSE.hint := 'Nombre d''harmoniques';
       end
       else begin
          grapheFFT.trace := tRaie;
          NbreFreqSE.MinValue := 64;
          NbreFreqSE.MaxValue := 1024;
          NbreFreqSE.value := NbreFreqAff;
          NbreFreqSE.hint := 'Nombre de raies dans le spectre';
       end;
end;

procedure TGTI2MainForm.FreqAutoBtnClick(Sender: TObject);
var voie : indiceVoieYD;
    i,imax : integer;
    min : double;
begin
     if not fftok then exit;
     iMax := 0;
     for voie := low(indiceVoieYD) to high(indiceVoieYD) do
         with grapheFFT.voieOrphy[voie] do if active then begin
              min := grapheOsc.voieOrphy[voie].maxi/100;
              for i := 0 to pred(grapheFFT.Nbre) do
                  if min<vecteurAff[i] then iMax := i;
     end;
     iMax := puiss2Sup(iMax);
     if fft.AnalyseHarmonique
        then begin
           if imax>128 then iMax := 128
        end
        else begin
           if imax<128 then iMax := 128;
        end;
     if iMax>grapheFFT.nbre then iMax := grapheFFT.Nbre;
     if fft.AnalyseHarmonique
        then begin
           NbreHarmoniqueAff := imax;
           NbreFreqSE.value := NbreHarmoniqueAff;
        end
        else begin
           NbreFreqAff := imax;
           NbreFreqSE.value := NbreFreqAff;
        end;
end;

procedure TGTI2MainForm.AmplitudeScrollChange(Sender: TObject);
begin
   AmplitudeEdit.text := tension.formatSimple(AmplitudeScroll.position*10/AmplitudeScroll.max);
   setLedGbf(lGray);
end;

procedure TGTI2MainForm.DutyScrollChange(Sender: TObject);
begin
   DutyEdit.text := IntToStr(DutyScroll.position)+'%'
end;

procedure TGTI2MainForm.OffsetEditExit(Sender: TObject);
var valeur : double;
begin
   valeur := strToFloatWin(OffsetEdit.text);
   OffsetScroll.position := round(valeur/10*OffsetScroll.max);
   majGbfBtnClick(sender);
end;

procedure TGTI2MainForm.AmplitudeEditExit(Sender: TObject);
var valeur : double;
begin
   valeur := strToFloatWin(AmplitudeEdit.text);
   AmplitudeScroll.position := round(valeur/10*AmplitudeScroll.max);
   majGbfBtnClick(sender);   
end;

procedure TGTI2MainForm.OffsetEditKeyPress(Sender: TObject; var Key: Char);
begin
     case key of
        crCR : OffsetEditExit(sender);
        '.',',' : key := decimalSeparator;
        '0'..'9','-','+' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0
     end;
end;

procedure TGTI2MainForm.AmplitudeEditKeyPress(Sender: TObject;
  var Key: Char);
begin
     case key of
        crCR : AmplitudeEditExit(sender);
        '.',',' : key := decimalSeparator;
        '0'..'9' : ;
        crDroite,crGauche,crSuppr,crSupprArr : ;
        else key := #0
     end;
end;

procedure TGTI2MainForm.Help_GBF_btnClick(Sender: TObject);
begin
  SyntaxeDlg := TSyntaxeDlg.create(self);
  if SyntaxeDlg.showModal=mrOK then MajGbfBtnClick(sender);
  SyntaxeDlg.free;
end;

procedure TGTI2MainForm.FechEditKeyPress(Sender: TObject; var Key: Char);
begin
  key := #0
end;

procedure TGTI2MainForm.MonocoupGBF_EAD_CBClick(Sender: TObject);
begin
  gbf.Monocoup := monocoupGbf_EAD_CB.checked;
  monogbf_EAD_btn.Visible := monocoupGbf_EAD_CB.checked;
  if gbf.Monocoup then gbf.arret;
  MajGBF(lRed);
end;

procedure TGTI2MainForm.MonoGBFbtnClick(Sender: TObject);
begin
     if not stopEnCours and // ??
        (modeAcq=mTemps) then begin
          enregistreBtnClick(sender);
          sleep(100);
     end;
     MajGBF(lGreen);
     application.ProcessMessages;
     compteurGBF := 0;
     gbf.monocoup := true;
     gbf.marche;
end;

procedure TGTI2MainForm.monocoupGBFCBClick(Sender: TObject);
begin
  gbf.Monocoup := monocoupGbfCB.checked;
  monoGbfBtn.Visible := monocoupGbfCB.checked;
  if gbf.Monocoup then gbf.arret;
  MajGBF(lRed);
end;

procedure TGTI2MainForm.AcquisitionversGBF1Click(Sender: TObject);
begin
    if EAD_SA_Form=nil then
       Application.CreateForm(TEAD_SA_Form, EAD_SA_Form);
    if EAD_SA_Form.showModal=mrOK then begin
       signalRG.ItemIndex := ord(sData);
       gbf.MajAFaire := true;
       setLedGBF(lRed);
    end;
end;

procedure TGTI2MainForm.affecteFreqGBF(freq : double);
var puissance : integer;
begin
    puissance := trunc(log10(freq));
    LabelHz.Caption := ' Hz';
    case puissance of
         5,4 : begin
             LCD10k.value := floatTostrF(freq/1000,ffFixed,4,3); // 100 kHz > f >= 10 kHz
             LabelHz.Caption := 'kHz';
         end;
         3 : LCD10k.value := intToStr(round(freq)); // 10 kHz > f >= 1000 Hz
         1,2 : LCD10k.value := floatTostrF(freq,ffFixed,4,3-puissance); // f < 1 kHz
         else LCD10k.value := floatTostrF(freq,ffFixed,4,3); // f < 1 Hz
    end;
end;

procedure TGTI2MainForm.NbreFreqSEChange(Sender: TObject);
begin
    if fft.AnalyseHarmonique
       then NbreHarmoniqueAff := NbreFreqSE.value
       else NbreFreqAff := NbreFreqSE.value;
end;

procedure TGTI2MainForm.OuvrirConfigClick(Sender: TObject);
begin
    DebutLectureParametres;
    OpenDialog1.defaultExt := '.GTI2';
    OpenDialog1.filter := 'Configuration Orphy GTI2|*.GTI2';
    if OpenDialog1.Execute
       then begin
         LitConfig(OpenDialog1.FileName);
         afficheReglage
       end
       else finLectureParametres;
end;

procedure TGTI2MainForm.EnregistrerConfigClick(Sender: TObject);
begin
  DebutLectureParametres;
  saveDialog1.defaultExt := '.GTI2';
  saveDialog1.filter := 'Configuration Orphy GTI2|*.gt2';
  if SaveDialog1.Execute then ecritConfig(SaveDialog1.FileName);
  finLectureParametres;
end;

procedure TGTI2MainForm.ConfigDefautClick(Sender: TObject);
begin
   EcritConfig(FichierConfig);
   EcritConfig(FichierConfigAdmin);
   sauverConfig := false;
end;

procedure TGTI2MainForm.ToolButton1Click(Sender: TObject);
begin
   (sender as TtoolButton).CheckMenuDropdown
end;

procedure TGTI2MainForm.DebutLectureParametres;
begin
    TimerPoint.Enabled := false;
    Timer.Enabled := false;
    TimerGTS2.Enabled := false;
    TimerGBF.Enabled := false;
    case modeAcq of
       mPointParPoint : gti2.StopAcqLente;
       mTemps : begin
           monocoupTemporaire := true;
           stopBtnClick(nil);
       end;
       mClavier : gti2.StopAcqLente;
    end;
end;

procedure TGTI2MainForm.FinLectureParametres;
begin
    case modeAcq of
       mPointParPoint : begin
          TimerPoint.Enabled := true;
          MonocoupTemporaire := false;
          gti2.lanceAcqLente;
       end;
       mTemps : if (gti2.withGTS2=GTS2_EAD) and
               (gti2.nbreVoiesGTS2>0) and
               (synchroRG.itemIndex>0)
           then timerGTS2.enabled := true
           else Timer.Enabled := true;
       mClavier : begin
          TimerPoint.Enabled := true;
          MonocoupTemporaire := false;
          gti2.lanceAcqLente;
       end;    
    end;
    if GBFbtn.Down and MajGbfBtn.Visible then timerGBF.enabled := true;
end;

function TGTI2MainForm.Reconnaissance : boolean;

Procedure setCapteurAuto(index,voie,valeurW : integer);
var i : integer;
    code : char;
    Ainitialiser : boolean;
begin with grapheOsc.voieDB15[voie] do begin
    if active and (indexCapteurAuto=index) then begin
          valeurCourante := valeurReal(valeurW);
          exit;
    end;
    active := true;
    Ainitialiser := indexCapteurAuto<>index;
    indexCapteurAuto := index;
    with ListeCapteursAuto[index] do begin
           if Ainitialiser then begin
                nom := nomC;
                nomUnite := nomUniteC;
                signif := signifC;
                Mini := MiniAff;
                Maxi := MaxiAff;
                UnVolt := UnVoltC;
                Offset := OffsetC;
                result := true;
           end;
           setMinMax;
           valeurCourante := valeurReal(valeurW);
    end;
    code := numToCodePotar(voie);
    priseInitialisee := true;
    with ListeCapteursAuto[index] do begin
       if avecEtalonnage then GTI2.output := 'WRPOTAR '+code;
       for i := 0 to MaxPotarAuto do
           if PotarActif[i] then
              if valeurPotar[i]>0
                  then begin
                     GTI2.output := 'WEPOTAR '+code+' '+intToStr(i)+' '+intToStr(valeurPotar[i]);
                     GTI2.output := 'WMPOTAR '+code+' '+intToStr(i);
                  end
   end;
end end;

procedure Desactive(voie : integer);
begin with grapheOsc.voieDB15[voie] do begin
         priseInitialisee := false;
         if active then result := true;
         active := false;
         indexCapteurAuto := 0;
end end;

var voie : indiceVoieYD;
begin
    result := false;
    for voie := voieG to voieJ do
        if (gti2.valeurReco.index[voie]>MaxCapteurAuto) or
           (gti2.valeurReco.index[voie] in
              [0,indexCapteurMarteau,indexCapteurMagnum,indexCapteurSondor])
// capteur dbranch ou capteur non analogique
        then Desactive(voie)
        else setCapteurAuto(gti2.valeurReco.index[voie],
                                    voie,gti2.valeurReco.valeur[voie]);
end; // Reconnaissance

procedure TGTI2MainForm.MajDB15;
var voie : indiceVoieYD;
    largeur : integer;
begin
    DB15Panel.visible := false;
    largeur := (PanelCourbe.width div 4)-2;
    for voie := voieG to voieJ do with grapheOsc.voieDB15[voie] do
       if active then begin
             if isXP
                 then begin
                     GBvoie.color := clWhite;
                     LabelVoie.font.color := couleur;
                     GBvoie.font.color := couleur;
                 end
                 else GBvoie.color := couleur;
             GBvoie.caption := nom+'(prise'+char(voie+ord('G')-voieG)+')'+calibreVoie;
             DB15Panel.visible := true;
             GBvoie.width := largeur;
             BevelVoie.visible := maxi*mini<0;
             BarVoie.Visible := true;
             with ListeCapteursAuto[indexCapteurAuto] do
                speedVoie.Visible := avecEtalonnage and not etalonnageFait;
             speedVoie.left := largeur-25;                
             BevelVoie.left := BarVoie.Left-round(BarVoie.width*mini/(maxi-mini));
       end
       else begin
           GBvoie.color := clBtnFace;
           LabelVoie.caption := '';
           GBvoie.caption := 'Prise'+char(voie+ord('G')-voieG);
           GBvoie.width := largeur;
           BevelVoie.visible := false;
           BarVoie.Visible := false;
           speedVoie.Visible := false;
       end;
end;

procedure TGTI2MainForm.AfficheDB15;
var voie : indiceVoieYD;
begin
     for voie := voieG to VoieJ do with grapheOsc.voieDB15[voie] do
         if active then begin
            LabelVoie.caption := AffVoltmetre;
            BarVoie.Position := round(valeurRelative*100);
         end;
end;

procedure TGTI2MainForm.affecteStop(stop : boolean);
begin
    stopEnCours := stop;
    if stop then begin
        enregistreBtn.caption := 'Stop';
        enregistreBtn.hint := 'Arrter l''acquisition';
        enregistreBtn.imageIndex := 10;
        enregistreBtn.Enabled := true;
        enregistreBtn.Update;
    end
    else begin
        enregistreBtn.caption := 'Enregistrer';
        enregistreBtn.hint := 'Lancer l''acquisition';
        enregistreBtn.imageIndex := 5;
        enregistreBtn.enabled := monocoupCB.checked or
                                (synchroRG.itemIndex=0) or
                                 monocoupTemporaire;
   end
end;

procedure TGTI2MainForm.SetValeurClavier(sortie : boolean);

   Procedure EnregistrePointClavier;
   var voie : indiceVoieYD;
   begin with graphePoint do begin
       Header.simpleText := '';
       effacePointCourant;
       with entreeClavier do
            vecteurAff[rowEdit-1] := ValeurAff;
       for voie := low(indiceVoieYD) to high(indiceVoieYD) do
           with voieOrphy[voie] do if active then begin
              vecteurAff[rowEdit-1] := ValeurAff;
              traceUnPoint(voie);
       end;
       if (rowEdit=succ(Nbre))
          then inc(Nbre)
          else TempsPaintBox.Refresh;
       marquePointCourant;
       UndoBtn.enabled := Nbre>0;
       ResetBtn.enabled := Nbre>0;
       RegSaveBtn.enabled := Nbre>2;
   end end; // EnregistrePointClavier

var valeurLoc : double;
    i : integer;
begin with graphePoint.entreeClavier do begin
        valeurLoc := StrToFloatWin(ClavierGrid.Cells[0,rowEdit]);
        if valeurLoc=sansSignif then if sortie
          then exit
          else begin
             if (rowEdit=succ(graphePoint.Nbre)) then ValeurAff := sansSignif;
             AfficheErreur(erNombre);
             setFocusGrid;
             exit;
          end;
        if (valeurLoc>maxi) or (valeurLoc<mini) then begin
           AfficheErreur(FormatGTI2(mini)+'< '+nom+' <'+FormatGTI2(maxi));
           setFocusGrid;
           exit;
        end;
        if (rowEdit<=succ(graphePoint.Nbre)) then begin
           effacePointCourant;
           valeurAff := valeurLoc;
           marquePointCourant;
           EnregistrePointClavier;
           for i := 0 to pred(NbreVoieOrphyClavier) do
               ClavierGrid.cells[i+1,rowEdit] :=
                   voieOrphyClavier[i].AffGrid(rowEdit-1);
           setFocusGrid;
        end;
end end; // setValeurClavier

procedure TGTI2MainForm.SetFocusGrid;
var i,j : integer;
begin
       i := succ(graphePoint.Nbre);
       ClavierGrid.rowCount := i+1;
       for j := 0 to NbreVoieOrphyClavier do
           ClavierGrid.cells[j,i] := '';
       ClavierGrid.col := 0;
       ClavierGrid.row := i;
       rowEdit := i;
       ClavierGrid.setFocus;
       ClavierGrid.editorMode := true;
end;

end.


