unit options;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Spin,ComCtrls,
  maths_osc, gti2_osc, gti2_point_Graphe, gti2_osc_Graphe, gti2_osc_util;

type
  TOptionsDlg = class(TForm)
    PanelBoutons: TPanel;
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    PanelOptions: TPanel;
    GrilleCB: TCheckBox;
    AnalyseurCB: TCheckBox;
    EtalonneSeuilBtn: TBitBtn;
    Label1: TLabel;
    WidthCursorSE: TSpinEdit;
    penteCB: TCheckBox;
    PointParPointRG: TRadioGroup;
    gts2RG: TRadioGroup;
    Label2: TLabel;
    DerniereConfigCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure EtalonneSeuilBtnClick(Sender: TObject);
    procedure gts2RGClick(Sender: TObject);
  private
  public
  end;

var
  OptionsDlg : TOptionsDlg;

implementation

uses gti2_osc_Main, EtalonSeuil, fft;

{$R *.DFM}

procedure TOptionsDlg.FormActivate(Sender: TObject);
begin
     grilleCB.checked := grille;
     penteCB.checked := grapheOsc.testPente ;
     widthCursorSE.value := WidthCursor;
     AnalyseurCB.checked := grapheOsc.AnalyseurLogique;
     pointParPointRG.itemIndex := ord(Gti2MainForm.modeAcq);
     gts2RG.itemIndex := ord(Gti2.withGTS2);
     gts2RG.visible := gti2.gts2Permis;
     DerniereConfigCB.checked := Gti2MainForm.SauverConfig;
end;

procedure TOptionsDlg.gts2RGClick(Sender: TObject);
begin
	label2.visible := gts2RG.itemIndex=2
end;

procedure TOptionsDlg.BtnOKClick(Sender: TObject);
begin
    grille := grilleCB.checked;
    WidthCursor := widthCursorSE.value;
    grapheOsc.AnalyseurLogique := AnalyseurCB.checked;
    grapheOsc.testPente := penteCB.checked;
    Gti2MainForm.SauverConfig := DerniereConfigCB.checked;
    Gti2MainForm.modeAcq := TmodeAcq(pointParPointRG.itemIndex);
    if gts2RG.visible
       then Gti2.withGTS2 := TorphyGTS2(gts2rg.ItemIndex)
       else Gti2.withGTS2 := gts2_non;
end;

procedure TOptionsDlg.EtalonneSeuilBtnClick(Sender: TObject);
begin
     if EtalonSeuilDlg=nil then
        Application.CreateForm(TEtalonSeuilDlg, etalonSeuilDlg);
     EtalonSeuilDlg.showModal;
end;

end.
