unit gti2_osc_DDE;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry,
  Maths_osc, gti2_dll, gti2_osc_Graphe,
  UniteKer, gti2Util_osc, clipbrd, gti2_osc;

type
  TDDEForm = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    donnees : TstringList;
    procedure AjouteConst;
  public
      procedure Execute(Ordre : shortString;bascule : boolean);
      procedure EnvoieDonneesOsc;
      procedure EnvoieDonneesCorrel;
  end;

var
  DDEForm: TDDEForm;

implementation

uses gti2_osc_Main, gti2_osc_Const, gti2_osc_Reg;

const crTab=#9;

{$R *.DFM}

procedure TDDEForm.AjouteConst;
var ligneN,ligneU,ligneV : shortString;
begin with ConstanteDlg do begin
     ligneU := '';
     ligneV := '';
     ligneN := '';
     if (valeurConstEdit.text<>'') and
        (nomConstEdit.text<>'') then begin
        ligneN := ligneN+nomConstEdit.text;
        ligneV := ligneV+valeurConstEdit.text;
        ligneU := ligneU+uniteConstEdit.text;
     end;
     if ligneN<>'' then begin
         Donnees.Add('');
         Donnees.Add(ligneN);
         Donnees.Add(ligneU);
         Donnees.Add(ligneV);
     end;
end end;

procedure TDDEForm.Execute(Ordre : shortString;bascule : boolean);
var Buf: PChar;
begin
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then begin
            Buf := StrAlloc(Succ(Length(Ordre)));
            if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
               ShowMessage(Ordre+' non excut');
            StrDispose(Buf);                   
            if bascule then begin
                Buf := StrAlloc(6);
                if not ClientDDE.ExecuteMacro(StrPCopy(Buf,'FOCUS'), false) then
                   ShowMessage('Bascule vers Regressi non effectu');
                StrDispose(Buf);
            end;
            ClientDDE.closeLink;
        end
        else ShowMessage('Impossible de lancer Regressi');
end;

procedure TDDEForm.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','regressi.exe');
    Ini.Free;
end;

procedure TDDEForm.EnvoieDonneesOsc;
var i,N : integer;
    v : indiceVoieYD;
    ligne : shortString;
begin with grapheOsc do begin
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if ConstanteDlg.NewPageCB.itemIndex=1
        then Donnees.Add('')
        else Donnees.Add('Acquisition par Orphy GTI2');
     Donnees.Add(ConstanteDlg.editComm.text);
     N := 0;
     ligne := voieTemps.nom;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then begin
            ligne := ligne + crTab + voieOrphy[v].nom;
            inc(N);
         end;
     Donnees.Add(ligne);
     ligne := voieTemps.nomUnite;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then
            ligne := ligne + crTab + voieOrphy[v].nomUnite;
     Donnees.Add(ligne);
     ligne := voieTemps.signif;
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then
            ligne := ligne + crTab + voieOrphy[v].signif;
     Donnees.Add(ligne);
     if idebut<0 then idebut := 0;
     if ifin>=Nbre then ifin := pred(nbre);
     for i := idebut to ifin do begin
         ligne := FloatToStrPoint(voieTemps.vecteurAff[i]);
         for v := low(indiceVoieYD) to high(indiceVoieYD) do
             if voieOrphy[v].active then
                ligne := ligne + crTab + FloatToStrPoint(voieOrphy[v].vecteurAff[i]);
         Donnees.Add(ligne);
     end;
     AjouteConst;
     Donnees.Add(symbReg2+intToStr(N)+' NOMX');
     for i := 1 to N do Donnees.Add(voieTemps.nom);
     Donnees.Add(symbReg2+intToStr(N)+' NOMY');
     for v := low(indiceVoieYD) to high(indiceVoieYD) do
         if voieOrphy[v].active then
            Donnees.Add(voieOrphy[v].nom);
     ClipBoard.asText := donnees.text;
     if ConstanteDlg.NewPageCB.itemIndex=1
          then Execute('CLIP|ADD',true)
          else Execute('CLIP|LOAD',true);
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Screen.Cursor := crDefault;
     Donnees.Free;
end end; // EnvoieDonneesOscillo 

procedure TDDEForm.EnvoieDonneesCorrel;
var i : integer;
    ligne : shortString;
begin with grapheOsc do begin
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     Donnees.Add('Acquisition par Orphy GTI2');
     Donnees.Add('corrlation');
     ligne := voieTemps.nom+crTab+'Ya';
     Donnees.Add(ligne);
     ligne := voieTemps.nomUnite+crTab +'V';
     Donnees.Add(ligne);
     ligne := voieTemps.signif+ crTab + '';
     Donnees.Add(ligne);
     for i := 0 to pred(Nbre) do begin
         ligne := FloatToStrPoint(voieTemps.vecteurAff[i]);
         ligne := ligne + crTab + FloatToStrPoint(GTI2MainForm.Xa[i]);
         Donnees.Add(ligne);
     end;
     ClipBoard.asText := donnees.text;
     if ConstanteDlg.NewPageCB.itemIndex=1
          then Execute('CLIP|ADD',true)
          else Execute('CLIP|LOAD',true);
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Screen.Cursor := crDefault;
     Donnees.Free;
end end; { EnvoieDonneesCorrel }

procedure TDDEForm.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : shortString;
    ArgStart,ArgEnd : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if CompareText('CONFIG|LOAD',Fonction) = 0 then exit;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then exit;
       if CompareText('FOCUS',Fonction) = 0 then begin
           GTI2MainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 1;
           GTI2MainForm.setFocus;
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;


end.
